﻿using ZXR.BusinessLogic;
using CAUtility.Logic.Page;

namespace CAUtility.Plugin
{
    public class ContentPage : IContentInlinePlugin
    {

        public string RegionString
        {
            get { return @"^(Page\(\s*)([0-9]{1,}\s*|\s*[0-9]{1,}\s*[,]\s*[a-zA-Z]{2}[-][a-zA-Z]{2}\s*)(\))$"; }
        }

        public System.Collections.Generic.List<System.Web.UI.Control> ConvertControls(params string[] param)
        {
            string pageId = param[0].Trim();

            string culture = param.Length == 2 ? param[1].Trim() : CaSettings.PageDefaultCulture;

            GetSinglePageBizProcess pageParam = new GetSinglePageBizProcess();
            pageParam.ID = pageId;

            BizLogic logic = new GetSinglePageBizLogic();
            GetSinglePageBizResult pageInfo_ = (GetSinglePageBizResult)logic.Execute(pageParam);

            System.Collections.Generic.List<System.Web.UI.Control> result = new System.Collections.Generic.List<System.Web.UI.Control>();

            if (pageInfo_ == null)
                return null;
            else
            {
                result.Add(new System.Web.UI.LiteralControl("<a href=\"" + CAUtility.Utility.UrlPathUtil.CultureRootPath + "Page.aspx?PageID=" + pageId + "\">" + pageInfo_.DisplayText + "</a>"));
            }

            return result;
        }

    }
}
