﻿using System.Text;

using CAUtility.Logic.NewsLetter.News;
using CAUtility.Plugin;

namespace CAUtility.BuiltinPlugin
{

    internal class NewsLetter : ContentPluginBase, IContentInlinePlugin
    {

        public string RegionString
        {
            get { return @"^(NewsLetter\()(\s*[0-9]{1,}\s*|\s*[0-9]{1,}\s*[,]\s*[0-9]{1,}\s*)(\))$"; }
        }

        public System.Collections.Generic.List<System.Web.UI.Control> ConvertControls(params string[] param)
        {
            System.Collections.Generic.List<System.Web.UI.Control> result = new System.Collections.Generic.List<System.Web.UI.Control>();

            result.Add(getContent(param));

            return result;
        }

        private System.Web.UI.LiteralControl getContent(string[] param)
        {
            StringBuilder newsList = new StringBuilder();

            System.Web.UI.HtmlControls.HtmlLink myHtmlLink1 = new System.Web.UI.HtmlControls.HtmlLink();
            myHtmlLink1.Href = CaSettings.SkinDirectory + "NewsLetter.css";
            myHtmlLink1.Attributes.Add("rel", "stylesheet");
            myHtmlLink1.Attributes.Add("type", "text/css");
            this.PageInstance.Header.Controls.Add(myHtmlLink1);

            int tagId = System.Convert.ToInt32(param[0].Trim());

            ListNewsForDisplayBizProcess newsListParam = new ListNewsForDisplayBizProcess();
            newsListParam.TagID = tagId;

            if (param.Length == 2)
                newsListParam.SelectCount = System.Convert.ToInt32(param[1].Trim());

            ListNewsForDisplayBizLogic logic = new ListNewsForDisplayBizLogic();
            ListNewsForDisplayBizResult result = (ListNewsForDisplayBizResult)logic.Execute(newsListParam);

            string culture = SupportCulture.GetCultureFromUrl();
            if (string.IsNullOrEmpty(culture))
            {
                culture = CaSettings.AdminCulture;
            }

            newsList.Append("<table border=0 cellpadding=0 cellspacing=0 width=95%>\r\n");
            newsList.Append("  <tr>\r\n");
            newsList.Append("    <td class=newsTagTitle>\r\n");
            newsList.Append("<div style='float: left'>" + result.TagName + "</div>");

            newsList.Append("<div style='clear: right; float: right;'>");
            if (param.Length == 2 && result.DataList.Count < result.TotalPostCount)
                newsList.Append("<a href='NewsTag.aspx?NewsTagID=" + tagId + "&PageID=" + System.Web.HttpContext.Current.Request.QueryString["PageId"] + "'>More</a>&nbsp;&nbsp;");

            string currentCulture = SupportCulture.GetCultureFromUrl();
            if (string.IsNullOrEmpty(currentCulture))
                currentCulture = CaSettings.PageDefaultCulture;

            newsList.Append("<a href=\"");
            newsList.Append(CAUtility.Utility.UrlPathUtil.RootPath);
            newsList.Append("Rss2.0.aspx?PageID=");
            newsList.Append(System.Web.HttpContext.Current.Request.QueryString["PageId"]);
            newsList.Append("&Culture=");
            newsList.Append(currentCulture);
            newsList.Append("&Target=QuickPost");
            newsList.Append("&ID=");
            newsList.Append(tagId);
            newsList.Append("\"><img src=\"" + CAUtility.Utility.UrlPathUtil.RootPath + "App_Themes/Default/Images/System/rss.jpg\" height=\"15\" /></a>");
            newsList.Append("</div>");

            newsList.Append("    </td>\r\n");
            newsList.Append("  </tr>\r\n");
            foreach (ListNewsForDisplayBizResultElement ele in result.DataList)
            {
                newsList.Append("  <tr>\r\n");
                newsList.Append("    <td>\r\n");
                newsList.Append(System.DateTime.Parse(ele.RegDatetime).ToString("yyyy年MM月dd日 HH:mm:ss"));
                newsList.Append("&nbsp;&nbsp;&nbsp;<a href='News.aspx?NewsID=" + ele.NewsID + "&NewsTagID=" + tagId + "&PageId=" + System.Web.HttpContext.Current.Request.QueryString["PageId"] + "'>" + ele.NewsTitle + "</a>");
                newsList.Append("    </td>\r\n");
                newsList.Append("  </tr>\r\n");
                newsList.Append("  <tr>\r\n");
                newsList.Append("    <td class=newstd>\r\n");
                newsList.Append("&nbsp;");
                newsList.Append("    </td>\r\n");
                newsList.Append("  </tr>\r\n");
            }
            newsList.Append("</table>\r\n");

            return new System.Web.UI.LiteralControl(newsList.ToString());
        }
    }
}
