﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web.UI;
using System.Collections;
using System.Web.UI.WebControls;
using System.ComponentModel;

using ZXR.Web.Controls;

namespace CAUtility.Controls
{

    [ToolboxData("<{0}:SelectCulture ID='SelectCulture' runat=\"server\" />")]
    [SupportsEventValidation()]
    public class SelectCulture : ZxrDropDownListBase
    {

        private List<string> arrayListDataSource_ = null;

        protected override void OnSelectedIndexChanged(EventArgs e)
        {
            if (this.SelectedIndex != 0)
            {
                base.OnSelectedIndexChanged(e);
            }
        }

        [Browsable(false)]
        public List<string> ArrayListDataSource
        {
            get { return arrayListDataSource_; }
            set
            {
                if (this.Items.Count > 1)
                {
                    this.Items.Clear();
                }

                arrayListDataSource_ = value;
                foreach (string culture in arrayListDataSource_)
                {
                    ListItem item = new ListItem();
                    item.Text = SupportCulture.ConvertCodeToText(culture);
                    item.Value = culture;

                    this.Items.Add(item);
                }
            }
        }
    }
}
