﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.BBS
{

    public class ListForumDalFetch : DalSelectFetch
    {

        public ListForumDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            SelectCommand = "select id, forumname, clickcounter from forum";
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ListForumDalResult result = new ListForumDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ListForumDalResultElement param = new ListForumDalResultElement();
                param.ID = Convert.ToInt32(row[0].ToString());
                param.ForumName = row[1].ToString();
                param.ClickCount = Convert.ToInt32(row[2].ToString());

                result.Add(param);
            }

            return result;
        }
    }
}
