﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.Common
{

    public class ListSupportCultureDalFetch : DalSelectFetch
    {

        public ListSupportCultureDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select DISTINCT culture from pageinfo where " +
                " status <> '" + DataStatus.DummyDelete.ToString() + "';";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ListSupportCultureDalResult result = new ListSupportCultureDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ListSupportCultureDalResultElement param = new ListSupportCultureDalResultElement();
                param.Culture = row[0].ToString();

                result.Add(param);
            }

            return result;
        }
    }
}
