﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.GroupInfo
{

    public class ListGroupUsersDalFetch : DalSelectFetch
    {

        public ListGroupUsersDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string groupList = string.Empty;
            foreach (string group in ((ListGroupUsersDalProcess)param).GroupList)
            {
                groupList += group + ",";
            }

            if (groupList.IndexOf(',') > 0)
                groupList = groupList.Remove(groupList.Length - 1);

            if (((ListGroupUsersDalProcess)param).OnePageMaxItemsCount > 0)
            {

                SelectCommand = "select top " + ((ListGroupUsersDalProcess)param).OnePageMaxItemsCount + @" username , friendlyname " +
                    "from userinfo where usergroup in ( " + groupList +
                    ") and status = '" + DataStatus.Normal.ToString() + "'";

                if (((ListGroupUsersDalProcess)param).PageIndex != 1)
                {
                    SelectCommand += " and username not in (select top " +
                                  ((((ListGroupUsersDalProcess)param).PageIndex - 1) * ((ListGroupUsersDalProcess)param).OnePageMaxItemsCount)
                                  + @" username from userinfo where usergroup in( " + groupList + ") and userinfo.status = '" + DataStatus.Normal.ToString() + "'";
                    SelectCommand += ")";
                }
            }
            else
            {
                SelectCommand = "select  username , friendlyname " +
                    "from userinfo where usergroup in ( " + groupList +
                    ") and status = '" + DataStatus.Normal.ToString() + "'";
            }
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ListGroupUsersDalResult result = new ListGroupUsersDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ListGroupUsersDalResultElement param = new ListGroupUsersDalResultElement();
                param.UserName = row[0].ToString();
                param.FriendlyName = row[1].ToString();

                result.Add(param);
            }

            return result;
        }
    }
}
