﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.NewsLetter.News
{

    public class ListNewsDalFetch : DalSelectFetch
    {

        public ListNewsDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select ";

            if (((ListNewsDalProcess)param).SelectCount != 0)
            {
                query += " top " + ((ListNewsDalProcess)param).SelectCount;
            }
            else
            {
                query += "top " + ((ListNewsDalProcess)param).OnePageMaxItemsCount;
            }

            query += @"
    newsletter.id ,
    newstitle, 
    newscontent, 
    reg_datetime, 
    newstags.tagname,
    click
from newsletter inner join newstags on newstags.id = newsletter.newstagid ";
            query += " where newsletter.status = '" + DataStatus.Normal.ToString() + "'";

            if (((ListNewsDalProcess)param).TagID != 0)
                query += " and newsletter.newstagid = " + ((ListNewsDalProcess)param).TagID;

            if (((ListNewsDalProcess)param).SelectCount == 0 && ((ListNewsDalProcess)param).PageIndex != 1)
            {
                query += " and newsletter.id not in (select top " +
                          ((((ListNewsDalProcess)param).PageIndex -1) * ((ListNewsDalProcess)param).OnePageMaxItemsCount)
                          + @" newsletter.id from newsletter where newsletter.status = '" + DataStatus.Normal.ToString() + "'";

                if( ((ListNewsDalProcess)param).TagID != 0 )
                    query += " and newsletter.newstagid = " + ((ListNewsDalProcess)param).TagID;

                query += " order by newsletter.reg_datetime desc)";
            }

            query += " order by newsletter.reg_datetime  desc;";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ListNewsDalResult result = new ListNewsDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ListNewsDalResultElement param = new ListNewsDalResultElement();
                param.NewsID = row[0].ToString();
                param.NewsTitle = row[1].ToString();
                param.NewsContent = row[2].ToString();
                param.RegDatetime = row[3].ToString();
                result.TagName = row[4].ToString();
                param.ClickCounter = string.IsNullOrEmpty(row[5].ToString()) ? 0 : Convert.ToInt32(row[5].ToString());

                result.Add(param);
            }

            return result;
        }
    }
}
