﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.NewsLetter.News
{

    public class ListNewsForDisplayDalFetch : DalSelectFetch
    {

        public ListNewsForDisplayDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select ";

            if (((ListNewsForDisplayDalProcess)param).SelectCount != 0)
            {
                query += " top " + ((ListNewsForDisplayDalProcess)param).SelectCount;
            }

            query += @"
    newsletter.id ,
    newstitle, 
    newscontent, 
    reg_datetime, 
    newstags.tagname 
from newsletter inner join newstags on newstags.id = newsletter.newstagid ";
            query += " where newsletter.status = '" + DataStatus.Normal.ToString() + "'";

            query += " and newsletter.newstagid = " + ((ListNewsForDisplayDalProcess)param).TagID;

            query += " order by newsletter.reg_datetime  desc;";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ListNewsForDisplayDalResult result = new ListNewsForDisplayDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ListNewsForDisplayDalResultElement param = new ListNewsForDisplayDalResultElement();
                param.NewsID = row[0].ToString();
                param.NewsTitle = row[1].ToString();
                param.NewsContent = row[2].ToString();
                param.RegDatetime = row[3].ToString();

                result.TagName = row[4].ToString();
                result.Add(param);
            }

            return result;
        }
    }
}
