﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.OnlineShopping
{

    public class GetShoppingDetailsDalFetch : DalSelectFetch
    {

        public GetShoppingDetailsDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select sales.id, product.id, product.productname, amount, subtotal" +
                " from salesdetails inner join product on product.id = salesdetails.productid " +
                " where salesid = '" + ((GetShoppingDetailsDalProcess)param).SalesID + "';";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            GetShoppingDetailsDalResult result = new GetShoppingDetailsDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                GetShoppingDetailsDalResultElement param = new GetShoppingDetailsDalResultElement();
                param.SalesID = row[0].ToString();
                param.ProductID = row[1].ToString();
                param.ProductName = row[2].ToString();
                param.Amount = row[3].ToString();
                param.SubTotal = row[4].ToString();

                result.Add(param);
            }

            return result;
        }
    }
}
