﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.OnlineShopping
{

    public class ListShoppingDalFetch : DalSelectFetch
    {

        public ListShoppingDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select id, monetaryamount, arrivaldate, remarks, purchasedate, status" +
                " from sales ";

            if (!string.IsNullOrEmpty(((ListShoppingDalProcess)param).UserID))
                query += " where userid = '" + ((ListShoppingDalProcess)param).UserID + "'";

            query += ";";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ListShoppingDalResult result = new ListShoppingDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ListShoppingDalResultElement param = new ListShoppingDalResultElement();
                param.SalesID = row[0].ToString();
                param.MonetaryAmount = row[1].ToString();
                param.ArrivalDate = row[2].ToString();
                param.Remarks = row[3].ToString();
                param.PurchaseDate = row[4].ToString();
                param.Status = row[5].ToString();

                result.Add(param);
            }

            return result;
        }
    }
}
