﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.Page
{

    public class GetPageListDalFetch : DalSelectFetch 
    {

        public GetPageListDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = @"
select 
    id,displaytext,toppageid, status, linkimage ,pageorder ,showinmenu, click
                
from pageinfo 
     
where culture = '" + ((GetPageListDalProcess)param).Culture + @"' and
(
(" + ZXR.Core.ClientInfoContext.Current.UserPrincipal.UserGroup + " = " + CAUtility.CaSettings.AdminPageUserGroup + @")
or
(" + ZXR.Core.ClientInfoContext.Current.UserPrincipal.UserGroup + @" in (select readusergroupid from pageinfo_read_auth where pageinfo_read_auth.pageid = pageinfo.id) )
or
((select count(*) from pageinfo_read_auth where pageinfo_read_auth.pageid = pageinfo.id) = 0)
)
";

            if (!string.IsNullOrEmpty(((GetPageListDalProcess)param).IsShowInMenu))
                query += " and showinmenu = " + ((GetPageListDalProcess)param).IsShowInMenu;

            if (!string.IsNullOrEmpty(((GetPageListDalProcess)param).Status))
            {
                query += " and status = '" + ((GetPageListDalProcess)param).Status + "'";
            }

            if (!string.IsNullOrEmpty(((GetPageListDalProcess)param).TopPageId))
            {
                query += " and toppageid = " + ((GetPageListDalProcess)param).TopPageId;
            }

            query += " Order by pageorder;";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            GetPageListDalResult result = new GetPageListDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                GetPageListDalResultElement param = new GetPageListDalResultElement();
                param.ID = row[0].ToString();
                param.DisplayText = row[1].ToString();
                param.TopPageId = row[2].ToString();
                param.Status = row[3].ToString();
                param.LinkImage = row[4].ToString();
                param.PageOrder = row[5].ToString();
                param.IsShowInMenu = row[6].ToString();
                param.ClickCount = System.Convert.ToInt32(row[7].ToString());

                result.Add(param);
            }
            return result;
        }
    }
}
