﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.Page
{

    public class GetSinglePageDalFetch : DalSelectFetch 
    {

        public GetSinglePageDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            SelectCommand = "select displaytext,contents,pageorder,toppageid, showinmenu ,metakeyword, linkimage, culture, status " +
                " from pageinfo where id = " + ((GetSinglePageDalProcess)param).ID +
                @" and
(
(" + ZXR.Core.ClientInfoContext.Current.UserPrincipal.UserGroup +" = "+ CAUtility.CaSettings.AdminPageUserGroup + @")
or
(" + ZXR.Core.ClientInfoContext.Current.UserPrincipal.UserGroup + @" in (select readusergroupid from pageinfo_read_auth where pageinfo_read_auth.pageid = pageinfo.id) )
or
((select count(*) from pageinfo_read_auth where pageinfo_read_auth.pageid = pageinfo.id) = 0)
)
";
        } 

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            GetSinglePageDalResult result = new GetSinglePageDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                GetSinglePageDalResultElement param = new GetSinglePageDalResultElement();
                param.DisplayText = row[0].ToString();
                param.Contents = row[1].ToString();
                param.PageOrder = row[2].ToString();
                param.TopPageId = row[3].ToString();
                param.IsShowInMenu = row[4].ToString();
                param.MetaKeyword = row[5].ToString();
                param.LinkImage = row[6].ToString();
                param.Culture = row[7].ToString();
                param.Status = row[8].ToString();

                result.Add(param);
            }
            return result;
        }
    }
}
