﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.PostThread
{

    public class OneThreadDalFetch : DalSelectFetch
    {

        public OneThreadDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            SelectCommand = @"
(
select 
    id, 
    forumid, 
    parentthreadid,
    username,
    posttitle,
    postcontent,
    IIf([username]='', usernickname, (select friendlyname from userinfo where userinfo.username=postthread.username)) as nickname,
    postdatetime,
    updatedatetime

from postthread
where id = " + ((OneThreadDalProcess)param).ThreadId;
            SelectCommand += @"
)
union all

(
select 
    id, 
    forumid, 
    parentthreadid,
    username,
    posttitle,
    postcontent,
    IIf([username]='', usernickname, (select friendlyname from userinfo where userinfo.username=postthread.username)) as nickname,
    postdatetime,
    updatedatetime

from postthread
where parentthreadid = " + ((OneThreadDalProcess)param).ThreadId + @"
)
            ";
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            OneThreadDalResult result = new OneThreadDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                OneThreadDalResultElement param = new OneThreadDalResultElement();
                param.ID = Convert.ToInt32(row[0].ToString());
                param.ForumId = Convert.ToInt32(row[1].ToString());
                param.ParentThreadId = Convert.ToInt32(row[2].ToString());
                param.UserName = row[3].ToString();
                param.PostTitle = row[4].ToString();
                param.PostContent = row[5].ToString();
                param.UserNickName = row[6].ToString();
                param.PostDatetime = Convert.ToDateTime(row[7].ToString());

                if (!string.IsNullOrEmpty(row[8].ToString()))
                    param.UpdateDatetime = Convert.ToDateTime(row[8].ToString());
                else
                    param.UpdateDatetime = DateTime.MinValue;

                result.Add(param);
            }

            return result;
        }
    }
}
