﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.ProductKinds
{

    public class DisplayProductKindsListDalFetch : DalSelectFetch
    {

        public DisplayProductKindsListDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select id, kindname, details, metakeyword , linkimage" +
                " from productkind where culture = '" + ((DisplayProductKindsListDalProcess)param).Culture + "'" +
                " and status = '" + DataStatus.Normal.ToString() + "' Order by kindorder;";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            DisplayProductKindsListDalResult result = new DisplayProductKindsListDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                DisplayProductKindsListDalResultElement param = new DisplayProductKindsListDalResultElement();
                param.ID = Int32.Parse(row[0].ToString());
                param.Name = row[1].ToString();
                param.Details = row[2].ToString();
                param.MetaKeyword = row[3].ToString();
                param.LinkImage = row[4].ToString();

                result.Add(param);
            }
            return result;
        }
    }
}
