﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.ProductKinds
{

    public class GetProductKindsDetailsDalFetch : DalSelectFetch
    {

        public GetProductKindsDetailsDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select kindname, details, kindorder, metakeyword , linkimage " +
                "from productkind where id = " + ((GetProductKindsDetailsDalProcess)param).ID + 
                " and status = '" + DataStatus.Normal.ToString() + "';";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            GetProductKindsDetailsDalResult result = new GetProductKindsDetailsDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                GetProductKindsDetailsDalResultElement param = new GetProductKindsDetailsDalResultElement();
                param.Name = row[0].ToString();
                param.Details = row[1].ToString();
                param.KindOrder = row[2].ToString();
                param.MetaKeyword = row[3].ToString();
                param.LinkImage = row[4].ToString();

                result.Add(param);
            }
            return result;
        }
    }
}
