﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.Products
{

    public class DisplayProductListDalFetch : DalSelectFetch
    {

        public DisplayProductListDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select top " +((DisplayProductListDalProcess)param).OnePageMaxItemsCount +
                 " id, productid, productname, imagepath, outline, stockcount, price ,click" +
                 " from product where kindsid = " + ((DisplayProductListDalProcess)param).KindsID +
                 " and status = '" + DataStatus.Normal.ToString() + "'";

            if (((DisplayProductListDalProcess)param).PageIndex != 1)
            {
                query += " and id not in (select top " +
                              ((((DisplayProductListDalProcess)param).PageIndex - 1) * ((DisplayProductListDalProcess)param).OnePageMaxItemsCount)
                              + @" id from product where status = '" + DataStatus.Normal.ToString() + "'";
                query += " and kindsid = " + ((DisplayProductListDalProcess)param).KindsID;
                query += " Order by productorder, id)";
            }

            query += " Order by productorder, id";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            DisplayProductListDalResult result = new DisplayProductListDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                DisplayProductListDalResultElement param = new DisplayProductListDalResultElement();
                param.ID = Int32.Parse(row[0].ToString());
                param.ProductID = row[1].ToString();
                param.Name = row[2].ToString();
                param.ImagePath = row[3].ToString();
                param.OutLine = row[4].ToString();
                param.StockCount = Int32.Parse(row[5].ToString());
                param.Price = Decimal.Parse(row[6].ToString());
                param.ClickCount = Int32.Parse(row[7].ToString());

                result.Add(param);
            }
            return result;
        }
    }
}
