﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.Products
{

    public class GetProductDetailsDalFetch : DalSelectFetch
    {

        public GetProductDetailsDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select"+
                " productid, productname, kindsid ,price,imagepath, outline, details,stockcount,productorder, metakeyword" +
                " from product where id = " + ((GetProductDetailsDalProcess)param).ID +
                " and status = '" + DataStatus.Normal.ToString() + "';";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            GetProductDetailsDalResult result = new GetProductDetailsDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                GetProductDetailsDalResultElement param = new GetProductDetailsDalResultElement();
                param.ProductID = row[0].ToString();
                param.Name = row[1].ToString();
                param.KindsID = Int32.Parse(row[2].ToString());
                param.Price = Decimal.Parse(row[3].ToString());
                param.ImagePath = row[4].ToString();
                param.OutLine = row[5].ToString();
                param.Details = row[6].ToString();
                param.StockCount = Int32.Parse(row[7].ToString());
                param.ProductOrder = row[8].ToString();
                param.MetaKeyword = row[9].ToString();

                result.Add(param);
            }
            return result;
        }
    }
}
