﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.QuestionnaireManager.Response
{

    public class GetOneSessionDalFetch : DalSelectFetch
    {

        public GetOneSessionDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query =
                @"
select 
     qresponse.id,
     qresponse.questionnaireid, 
     question.id,
     question.q_content,
     ( select i_content from questionitem where questionitem.id = qresponse.questionitemid) as questionitemcontent,
     qresponse.r_content, 
     question.q_type, 
     question.q_order,
     r_datetime,
     r_session
from
     qresponse  inner join question on question.id = qresponse.questionid
where qresponse.questionnaireid = " + ((GetOneSessionDalProcess)param).QuestionnaireID;

            query += " and qresponse.r_session = '" + ((GetOneSessionDalProcess)param).ResponseSession + "'";
            query += " order by question.q_order asc;";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            GetOneSessionDalResult result = new GetOneSessionDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                GetOneSessionDalResultElement param = new GetOneSessionDalResultElement();
                param.ID = row[0].ToString();
                param.QuestionnaireID = row[1].ToString();
                param.QuestionID = row[2].ToString();
                param.QuestionContent = row[3].ToString();
                param.QuestionItemContent = row[4].ToString();
                param.ResponseContent = row[5].ToString();
                param.QuestionType = row[6].ToString();
                param.QuestionOrder = row[7].ToString();
                param.ResponseDatetime = row[8].ToString();
                param.ResponseSession = row[9].ToString();

                result.Add(param);
            }

            return result;
        }
    }
}
