﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.QuestionnaireManager.Response
{

    public class ListResponseItemDalFetch : DalSelectFetch
    {

        public ListResponseItemDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select DISTINCT id, questionitemid, questionid, questionnaireid, r_content, r_datetime, r_session " +
                "from qresponse where questionnaireid = " + ((ListResponseItemDalProcess)param).QuestionnaireID;

            if (!string.IsNullOrEmpty(((ListResponseItemDalProcess)param).QuestionID))
            {
                query += " and questionid = " + ((ListResponseItemDalProcess)param).QuestionID;
            }

            if (!string.IsNullOrEmpty(((ListResponseItemDalProcess)param).ResponseSession))
            {
                query += " and r_session = '" + ((ListResponseItemDalProcess)param).ResponseSession + "'";
            }

            query += ";";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ListResponseItemDalResult result = new ListResponseItemDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ListResponseItemDalResultElement param = new ListResponseItemDalResultElement();
                param.ID = row[0].ToString();
                param.QuestionItemID = row[1].ToString();
                param.QuestionID = row[2].ToString();
                param.QuestionnaireID = row[3].ToString();
                param.Content = row[4].ToString();
                param.ResponseDatatime = row[5].ToString();
                param.ResponseSession = row[6].ToString();

                result.Add(param);
            }

            return result;
        }
    }
}
