﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.QuestionnaireManager.Response
{

    public class ListSessionDalFetch : DalSelectFetch
    {

        public ListSessionDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select DISTINCT r_session , r_datetime" +
                " from qresponse where questionnaireid = " + ((ListSessionDalProcess)param).QuestionnaireID + " order by r_datetime desc;";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ListSessionDalResult result = new ListSessionDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ListSessionDalResultElement param = new ListSessionDalResultElement();
                param.SessionID = row[0].ToString();
                param.ResponseDatetime = row[1].ToString();

                result.Add(param);
            }

            return result;
        }
    }
}
