﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.ReservationData
{

    public class AdminGetReservationDalFetch : DalSelectFetch
    {

        public AdminGetReservationDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = @"
select 
    reservationdata.id,
    itemid, 
    begindatetime, 
    enddatetime, 
    reservationtime, 
    username, 
    userphone, 
    usermail, 
    reservationnumber, 
    reservationitem.iname, 
    reservationdata.status, 
    reservationitem.runit,
    reservationitem.datetimelength
from    
    reservationdata inner join reservationitem on reservationitem.id = reservationdata.itemid 
where 
     reservationdata.id = " + ((AdminGetReservationDalProcess)param).ReservationNumber + ";";

            

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            AdminGetReservationDalResult result = new AdminGetReservationDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                result.ID = row[0].ToString();
                result.ItemID = row[1].ToString();
                result.ReservationBegin = Convert.ToDateTime(row[2].ToString());
                result.ReservationEnd = Convert.ToDateTime(row[3].ToString());
                result.ReservateRegDate = Convert.ToDateTime(row[4].ToString());
                result.UserName = row[5].ToString();
                result.UserPhone = row[6].ToString();
                result.UserMail = row[7].ToString();
                result.ReservationNumber = row[8].ToString();
                result.ItemName = row[9].ToString();
                result.Status = row[10].ToString();
                result.ReservationType = Convert.ToInt32(row[11].ToString());
                result.DatetimeLegth = Convert.ToInt32(row[12].ToString());

                break;
            }

            return result;
        }
    }
}
