﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.ReservationData
{

    public class ListDataDalFetch : DalSelectFetch
    {

        public ListDataDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            if (ZXR.Core.CoreSettings.DbType == DbType.Access)
            {
                SelectCommand = "select reservationdata.id, itemid, begindatetime, enddatetime, reservationtime, username, notifymaillist, rpassword, userphone, usermail, reservationnumber , reservationitem.iname" +
                    " from reservationdata inner join reservationitem on reservationitem.id = reservationdata.itemid where reservationdata.status <> '" + DataStatus.Cancel.ToString() + "'";

                if (!string.IsNullOrEmpty(((ListDataDalProcess)param).ItemID))
                {
                    SelectCommand += " and itemid = " + ((ListDataDalProcess)param).ItemID;
                }

                if (((ListDataDalProcess)param).IsFromNow)
                {
                    SelectCommand += " and begindatetime > #" + DateTime.Now.ToString() + "#";
                }

                SelectCommand += ";";
            }
            else
            {
                SelectCommand = "select reservationdata.id, itemid, begindatetime, enddatetime, reservationtime, username, notifymaillist, rpassword, userphone, usermail, reservationnumber , reservationitem.iname" +
                    " from reservationdata inner join reservationitem on reservationitem.id = reservationdata.itemid where reservationdata.status != '" + DataStatus.Cancel.ToString() + "'";

                if (!string.IsNullOrEmpty(((ListDataDalProcess)param).ItemID))
                {
                    SelectCommand += " and itemid = " + ((ListDataDalProcess)param).ItemID;
                }

                if (((ListDataDalProcess)param).IsFromNow)
                {
                    SelectCommand += " and begindatetime > '" + DateTime.Now.ToString() + "'";
                }

                SelectCommand += ";";
            }
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ListDataDalResult result = new ListDataDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ListDataDalResultElement param = new ListDataDalResultElement();
                param.ID = row[0].ToString();
                param.ItemID = row[1].ToString();
                param.ReservationBegin = Convert.ToDateTime(row[2].ToString());
                param.ReservationEnd = Convert.ToDateTime(row[3].ToString());
                param.ReservateDatetime = Convert.ToDateTime(row[4].ToString());
                param.UserName = row[5].ToString();
                param.NotifyMailList = row[6].ToString();
                param.Passwrod = row[7].ToString();
                param.UserPhone = row[8].ToString();
                param.UserMail = row[9].ToString();
                param.ReservationNumber = row[10].ToString();
                param.ItemName = row[11].ToString();

                result.Add(param);
            }

            return result;
        }
    }
}
