﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.ReservationItem
{

    public class GetItemDetailDalFetch : DalSelectFetch
    {

        public GetItemDetailDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            SelectCommand = @"
select 
    iname, 
    imagepath, 
    runit, 
    permission,
    intervaltime, 
    canrepetition, 
    canmailnotify, 
    reservationbegintime, 
    reservationendtime, 
    simultaneousnumber, 
    itemdetail, 
    iorder, 
    holidaylist, 
    id, 
    dispalydatecount, 
    datetimelength
from reservationitem 
where id = " + ((GetItemDetailDalProcess)param).ID + ";";
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            GetItemDetailDalResult result = new GetItemDetailDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                result.Name = row[0].ToString();
                result.ImagePath = row[1].ToString();
                result.Unit = row[2].ToString();
                result.Permission = row[3].ToString();
                result.IntervalTime = row[4].ToString();
                result.CanRepetition = row[5].ToString();
                result.CanMailNotify = row[6].ToString();
                result.ReservationBeginTime = row[7].ToString();
                result.ReservationEndTime = row[8].ToString();
                result.SimultaneousNumber = row[9].ToString();
                result.ItemDetail = row[10].ToString();
                result.Order = row[11].ToString();
                result.HolidayList = row[12].ToString();
                result.ID = row[13].ToString();
                result.DisplayDateCount = row[14].ToString();
                result.DatetimeLength = row[15].ToString();

                break;
            }

            return result;
        }
    }
}
