﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.ReservationItem
{

    public class ReservationItemListDalFetch : DalSelectFetch
    {

        public ReservationItemListDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select id, iname, imagepath, runit, permission,intervaltime, canrepetition, canmailnotify, reservationbegintime, reservationendtime, simultaneousnumber, itemdetail, iorder, holidaylist " +
                "from reservationitem where status = '" + DataStatus.Normal.ToString() + "';";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ReservationItemListDalResult result = new ReservationItemListDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ReservationItemListDalResultElement param = new ReservationItemListDalResultElement();
                param.ID = row[0].ToString();
                param.Name = row[1].ToString();
                param.ImagePath = row[2].ToString();
                param.Unit = row[3].ToString();
                param.Permission = row[4].ToString();
                param.IntervalTime = row[5].ToString();
                param.CanRepetition = row[6].ToString();
                param.CanMailNotify = row[7].ToString();
                param.ReservationBeginTime = row[8].ToString();
                param.ReservationEndTime = row[9].ToString();
                param.SimultaneousNumber = row[10].ToString();
                param.ItemDetail = row[11].ToString();
                param.Order = row[12].ToString();
                param.HolidayList = row[13].ToString();

                result.Add(param);
            }

            return result;
        }
    }
}
