﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.Sales
{

    public class GetOneOrderDetailsDalFetch : DalSelectFetch
    {

        public GetOneOrderDetailsDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select product.productid, productname,price, amount, subtotal " +
                "from salesdetails inner join product on product.id = salesdetails.productid" + 
                " where salesid = '" + ((GetOneOrderDetailsDalProcess)param).SalesID + "'";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            GetOneOrderDetailsDalResult result = new GetOneOrderDetailsDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                GetOneOrderDetailsDalResultElement param = new GetOneOrderDetailsDalResultElement();
                param.ProductNumber = row[0].ToString();
                param.ProductName = row[1].ToString();
                param.ProductPrice = Convert.ToDecimal(row[2].ToString());
                param.Amount = Convert.ToInt32(row[3].ToString());
                param.Subtotal = Convert.ToDecimal(row[4].ToString());

                result.Add(param);
            }

            return result;
        }
    }
}
