﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.Sales
{

    public class ListOrdersDalFetch : DalSelectFetch
    {

        public ListOrdersDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select id, userid, purchasedate, status from sales";

            if (string.IsNullOrEmpty(((ListOrdersDalProcess)param).Status))
            {
                query += " where status = '" + DataStatus.Normal + "' ";
            }
            else if (string.Equals(((ListOrdersDalProcess)param).Status, "All"))
            {
                query += " where status = '" + DataStatus.Normal + "' or ";
                query += " status = '" + DataStatus.Cancel + "' or ";
                query += " status = '" + DataStatus.DummyDelete + "' or ";
                query += " status = '" + DataStatus.PeriodPassed + "' or ";
                query += " status = '" + DataStatus.Processing + "' ";
            }
            else
            {
                query += " where status = '" + ((ListOrdersDalProcess)param).Status + "' ";
            }

            if (!string.IsNullOrEmpty(((ListOrdersDalProcess)param).SalesId))
            {
                query += " and id = '" + ((ListOrdersDalProcess)param).SalesId + "' ";
            }

            if (!string.IsNullOrEmpty(((ListOrdersDalProcess)param).UserID))
            {
                query += " and userid = '" + ((ListOrdersDalProcess)param).UserID + "' ";
            }

            query += " order by purchasedate desc;";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ListOrdersDalResult result = new ListOrdersDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ListOrdersDalResultElement param = new ListOrdersDalResultElement();
                param.SalesID = row[0].ToString();
                param.UserID = row[1].ToString();
                param.PurchaseDate = DateTime.Parse(row[2].ToString());
                param.Status = row[3].ToString();

                result.Add(param);
            }

            return result;
        }
    }
}
