﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.Schedule
{

    public class ListAllMemberScheduleDalFetch : DalSelectFetch
    {

        public ListAllMemberScheduleDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {

            if (ZXR.Core.CoreSettings.DbType == DbType.Access)
            {
                SelectCommand = @"
SELECT 
 schedulejoinmember.username, schedule.stitle, schedule.sdescription, 
schedule.starttime, schedule.endtime, schedule.registedtime, 
schedule.groupid, schedule.id, schedule.status, schedule.stype, schedule.repeattime,
userinfo.friendlyname

From
 (schedule inner join schedulejoinmember on schedule.id = schedulejoinmember.scheduleid)
 inner join userinfo on userinfo.username = schedulejoinmember.username

where schedule.endtime >= #" + ((ListAllMemberScheduleDalProcess)param).StartDate.Date + "#" +
                  " and schedule.starttime <= #" + ((ListAllMemberScheduleDalProcess)param).StartDate.AddDays(7).Date + "#" +
                " order by schedule.starttime ";
            }
            else if (ZXR.Core.CoreSettings.DbType == DbType.SQLServer)
            {
                SelectCommand = @"
SELECT 
 schedulejoinmember.username, schedule.stitle, schedule.sdescription, 
schedule.starttime, schedule.endtime, schedule.registedtime, 
schedule.groupid, schedule.id, schedule.status, schedule.stype, schedule.repeattime,
userinfo.friendlyname

From
 (schedule inner join schedulejoinmember on schedule.id = schedulejoinmember.scheduleid)
 inner join userinfo on userinfo.username = schedulejoinmember.username

where schedule.endtime >= '" + ((ListAllMemberScheduleDalProcess)param).StartDate.Date + "'" +
                          " and schedule.starttime <= '" + ((ListAllMemberScheduleDalProcess)param).StartDate.AddDays(7).Date + "'" +
                        " order by schedule.starttime ";
            }
            
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ListAllMemberScheduleDalResult result = new ListAllMemberScheduleDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ListAllMemberScheduleDalResultElement param = new ListAllMemberScheduleDalResultElement();
                param.AuthorID = row[0].ToString();
                param.Title = row[1].ToString();
                param.Description = row[2].ToString();
                param.StartTime = Convert.ToDateTime(row[3].ToString());
                param.EndTime = Convert.ToDateTime(row[4].ToString());
                param.RegistedTime = Convert.ToDateTime(row[5].ToString());
                param.GroupID = Convert.ToInt32(row[6].ToString());
                param.ID = Convert.ToInt32(row[7].ToString());
                param.Status = row[8].ToString();
                param.Type = Convert.ToInt32(row[9].ToString());
                param.RepeatString = row[10].ToString();
                param.FriendlyName = row[11].ToString();

                result.Add(param);
            }

            return result;
        }
    }
}
