﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.Schedule
{

    public class ScheduleDetailDalFetch : DalSelectFetch
    {

        public ScheduleDetailDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {

            string query = @"SELECT 
authorid, schedule.stitle, schedule.sdescription, schedule.starttime,
schedule.endtime, schedule.registedtime, schedule.groupid, schedule.status,
schedule.lastupdatetime, schedule.stype, schedule.repeattime, userinfo.friendlyname

FROM 
 schedule inner join userinfo on userinfo.username = schedule.authorid

where schedule.id = " + ((ScheduleDetailDalProcess)param).ID;

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ScheduleDetailDalResult result = new ScheduleDetailDalResult();

            bool isFirst = true;
            foreach (Row row in dataContainer.Rows)
            {
                if (isFirst)
                {
                    result.AuthorID = row[0].ToString();
                    result.Title = row[1].ToString();
                    result.Description = row[2].ToString();
                    result.StartTime = Convert.ToDateTime(row[3].ToString());
                    result.EndTime = Convert.ToDateTime(row[4].ToString());
                    result.RegistedTime = Convert.ToDateTime(row[5].ToString());
                    result.GroupID = Convert.ToInt32(row[6].ToString());
                    result.Status = row[7].ToString();
                    if (!string.IsNullOrEmpty(row[8].ToString()))
                        result.LastUpdateTime = Convert.ToDateTime(row[8].ToString());
                    else
                        result.LastUpdateTime = DateTime.MinValue;
                    result.Type = Convert.ToInt32(row[9].ToString());
                    result.RepeatString = row[10].ToString();
                    result.FriendlyName = row[11].ToString();
                }
            }

            return result;
        }
    }
}
