﻿
using ZXR.DataAccess;

namespace CAUtility.Dal.Schedule
{

    public class UpdateScheduleDalFetch : DalUdiFetch
    {

        public UpdateScheduleDalFetch()
        {

        }

        public override void SetUDICommand(FetchProcessParam param)
        {
            if (ZXR.Core.CoreSettings.DbType == DbType.Access)
            {
                UDICommand = "update schedule set " +
                    " starttime = #" + ((UpdateScheduleDalProcess)param).StartTime + "#," +
                    " endtime = #" + ((UpdateScheduleDalProcess)param).EndTime + "#," +
                    " stitle = '" + ((UpdateScheduleDalProcess)param).Title + "'," +
                    " sdescription = '" + ((UpdateScheduleDalProcess)param).Description + "'," +
                    " lastupdatetime = #" + System.DateTime.Now + "#," +
                    " stype = " + ((UpdateScheduleDalProcess)param).Type + "," +
                    " repeattime = '" + ((UpdateScheduleDalProcess)param).RepeatString + "'," +
                    " status = '" + DataStatus.Updated.ToString() + "'" +
                    " where id = " + ((UpdateScheduleDalProcess)param).ID + ";";
            }
            else if (ZXR.Core.CoreSettings.DbType == DbType.SQLServer)
            {
                UDICommand = "update schedule set " +
                                " starttime = '" + ((UpdateScheduleDalProcess)param).StartTime + "'," +
                                " endtime = '" + ((UpdateScheduleDalProcess)param).EndTime + "'," +
                                " stitle = '" + ((UpdateScheduleDalProcess)param).Title + "'," +
                                " sdescription = '" + ((UpdateScheduleDalProcess)param).Description + "'," +
                                " lastupdatetime = '" + System.DateTime.Now + "'," +
                                " stype = " + ((UpdateScheduleDalProcess)param).Type + "," +
                                " repeattime = '" + ((UpdateScheduleDalProcess)param).RepeatString + "'," +
                                " status = '" + DataStatus.Updated.ToString() + "'" +
                                " where id = " + ((UpdateScheduleDalProcess)param).ID + ";";
            }
        }
    }
}
