﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.ScheduleJoinMember
{

    public class ListScheduleJoinMemberDalFetch : DalSelectFetch
    {

        public ListScheduleJoinMemberDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            SelectCommand = "select schedulejoinmember.username, userinfo.friendlyname " +
                "from schedulejoinmember inner join userinfo on userinfo.username = schedulejoinmember.username" +
                " where scheduleid = " + ((ListScheduleJoinMemberDalProcess)param).ScheduleID; 
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            ListScheduleJoinMemberDalResult result = new ListScheduleJoinMemberDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                ListScheduleJoinMemberDalResultElement param = new ListScheduleJoinMemberDalResultElement();
                param.UserName = row[0].ToString();
                param.FriendlyName = row[1].ToString();

                result.Add(param);
            }

            return result;
        }
    }
}
