﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.UserInfo
{

    public class SingleUserInfoDalFetch : DalSelectFetch
    {

        public SingleUserInfoDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            string query = "select usergroup, usertoken, lastchangepassword, friendlyname " +
                "from userinfo left join groupinfo on groupinfo.ID = userinfo.usergroup where userinfo.username = '" + ((SingleUserInfoDalProcess)param).UserName + "'" +
                " and userinfo.status = '" + DataStatus.Normal.ToString() + "';";

            SelectCommand = query;
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            SingleUserInfoDalResult result = new SingleUserInfoDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                result.UserGroup = Convert.ToInt32(string.IsNullOrEmpty(row[0].ToString()) ? "0" : row[0].ToString());
                result.UserToken = row[1].ToString();
                result.LastChangePassword = Convert.ToDateTime(row[2].ToString());
                result.FriendlyName = row[3].ToString();

                break;
            }

            return result;
        }
    }
}
