﻿
using System;

using ZXR.DataAccess;
using ZXR.Data;

namespace CAUtility.Dal.UserInfo
{

    public class UserListDalFetch : DalSelectFetch
    {

        public UserListDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            SelectCommand = @"select top " + ((UserListDalProcess)param).OnePageMaxItemsCount + @"
username , friendlyname, groupinfo.id, groupinfo.groupname " +
                "from userinfo left join groupinfo on groupinfo.ID = userinfo.usergroup where userinfo.status = '" + DataStatus.Normal.ToString() + "'";

            if (((UserListDalProcess)param).PageIndex != 1)
            {
                SelectCommand += " and username not in (select top " +
                              ((((UserListDalProcess)param).PageIndex - 1) * ((UserListDalProcess)param).OnePageMaxItemsCount)
                              + @" username from userinfo left join groupinfo on groupinfo.ID = userinfo.usergroup where userinfo.status = '" + DataStatus.Normal.ToString() + "'";
                SelectCommand += ")";
            }
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            UserListDalResult result = new UserListDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                UserListDalResultElement param = new UserListDalResultElement();
                param.UserName = row[0].ToString();
                param.FriendlyName = row[1].ToString();
                param.UserGroupID = Convert.ToInt32(string.IsNullOrEmpty(row[2].ToString()) ? "-1" : row[2].ToString());
                param.UserGroupName = row[3].ToString(); 
                result.Add(param);
            }
            return result;
        }
    }
}
