﻿
using System;

using ZXR.Data;
using ZXR.DataAccess;

namespace CAUtility.Dal.UserShoppingInfo
{

    public class GetUserDetailsDalFetch : DalSelectFetch
    {

        public GetUserDetailsDalFetch()
        {

        }

        protected override void SetSelectCommand(FetchProcessParam param)
        {
            SelectCommand = "select uaddress, homephone , mobile, zipcode, simei, furigana, mobilemail , pcmail, " +
                " secretquestion, secretanswer, companyname, officialposition, usex, ubirthday, ufax, logintype" +
                " from usershoppinginfo " +
                " where userid = '" + ((GetUserDetailsDalProcess)param).UserID + "';";
        }

        protected override DalSelectResult SelectResultProcessing(DalDataContainer dataContainer)
        {
            GetUserDetailsDalResult result = new GetUserDetailsDalResult();

            foreach (Row row in dataContainer.Rows)
            {
                result.Address = row[0].ToString();
                result.HomePhone = row[1].ToString();
                result.Mobile = row[2].ToString();
                result.ZipCode = row[3].ToString();
                result.Simei = row[4].ToString();
                result.Furigana = row[5].ToString();
                result.MobileMail = row[6].ToString();
                result.PCMail = row[7].ToString();
                result.SecretQuestion = Int32.Parse(row[8].ToString());
                result.SecretAnswer = row[9].ToString();
                result.Company = row[10].ToString();
                result.OfficialPosition = row[11].ToString();
                result.Sex = Convert.ToInt32(row[12].ToString());
                result.Birthday = DateTime.Parse(row[13].ToString());
                result.Fax = row[14].ToString();
                result.LoginType = row[15].ToString();

                break;
            }

            return result;
        }
    }
}
