﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;
using ZXR.IO;

namespace CAUtility.Logic.BackupFileManager
{

    
    public class GetBackupfileListBizLogic : BizLogic
    {

        public GetBackupfileListBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            GetBackupfileListBizResult result = new GetBackupfileListBizResult();

            foreach (string str in DirectoryIO.GetFilesInDirectory(((GetBackupfileListBizProcess)param).Path))
            {
                GetBackupfileListBizResultElement element = new GetBackupfileListBizResultElement();
                element.FileName = FileIO.GetFileNameFromFullName(str);
                element.CreateDate = FileIO.GetCreationTime(str);
                element.FileSize = FileIO.GetFileSize(str);

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
