﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;

using CAUtility.Dal.GroupInfo;

namespace CAUtility.Logic.GroupInfo
{

    public class ListGroupUsersBizLogic : BizLogic
    {

        public ListGroupUsersBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            this.ZxrTransaction = new ZXR.DataAccess.ZxrTransaction();

            ListGroupUsersBizResult result = new ListGroupUsersBizResult();

            ListGroupUsersDalProcess getParam = new ListGroupUsersDalProcess();
            getParam.GroupList = ((ListGroupUsersBizProcess)param).GroupList;
            getParam.OnePageMaxItemsCount = ((ListGroupUsersBizProcess)param).OnePageMaxItemsCount;
            getParam.PageIndex = ((ListGroupUsersBizProcess)param).PageIndex;

            DalSelectFetch fetch = new ListGroupUsersDalFetch();
            fetch.JoinTransaction(this.ZxrTransaction);
            ListGroupUsersDalResult fetchResult = (ListGroupUsersDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (ListGroupUsersDalResultElement ele in fetchResult)
            {
                ListGroupUsersBizResultElement element = new ListGroupUsersBizResultElement();
                element.UserName = ele.UserName;
                element.FriendlyName = ele.FriendlyName;

                result.DataList.Add(element);
            }

            CountGroupUsersDalProcess countUserParam = new CountGroupUsersDalProcess();
            countUserParam.GroupList = ((ListGroupUsersBizProcess)param).GroupList;

            CountGroupUsersDalFetch countUserFetch = new CountGroupUsersDalFetch();
            countUserFetch.JoinTransaction(this.ZxrTransaction);
            result.TotalUserCount = System.Convert.ToInt32(countUserFetch.ScalarExecuteLogic(countUserParam));

            this.ZxrTransaction.Commit();

            return result;
        }
    }
}
