﻿
using ZXR.BusinessLogic;
using ZXR.Security;
using ZXR.Core;
using ZXR.IO;

namespace CAUtility.Logic.LogManager
{

    
    public class GetLogFileListBizLogic : BizLogic
    {

        public GetLogFileListBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            GetLogFileListBizResult result = new GetLogFileListBizResult();

            foreach (string str in DirectoryIO.GetFilesInDirectory(((GetLogFileListBizProcess)param).Path))
            {
                GetLogFileListBizResultElement element = new GetLogFileListBizResultElement();
                element.FileName = FileIO.GetFileNameFromFullName(str);
                element.CreateDate = FileIO.GetCreationTime(str);
                element.FileSize = FileIO.GetFileSize(str);

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
