﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Web.Util;

using CAUtility.Dal.NewsLetter.News;

namespace CAUtility.Logic.NewsLetter.News
{

    public class GetOneNewsBizLogic : BizLogic
    {

        public GetOneNewsBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            GetOneNewsBizResult result = new GetOneNewsBizResult();

            GetOneNewsDalProcess getParam = new GetOneNewsDalProcess();
            getParam.NewsID = ((GetOneNewsBizProcess)param).NewsID;

            DalSelectFetch fetch = new GetOneNewsDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            GetOneNewsDalResult fetchResult = (GetOneNewsDalResult)fetch.SelectExecuteLogic(getParam);

            result.NewsContent = fetchResult.NewsContent;
            result.NewsTagId = fetchResult.NewsTagId;
            result.NewsTitle = fetchResult.NewsTitle;
            result.RegDatetime = fetchResult.RegDatetime;

            try
            {
                if (AccessCounter.ContentsCount("NewsLetter", System.Convert.ToInt32(((GetOneNewsBizProcess)param).NewsID)) == 1)
                {
                    UpdateCounterDalProcess counterParam = new UpdateCounterDalProcess();
                    counterParam.ID = ((GetOneNewsBizProcess)param).NewsID;

                    UpdateCounterDalFetch counterFetch = new UpdateCounterDalFetch();
                    counterFetch.UDIExecuteLogic(counterParam);
                }
            }
            catch (System.Exception ex)
            {

                ZXR.Log.Logger.Error("カウンタ", ex);
            }

            return result;
        }
    }
}
