﻿
using ZXR.BusinessLogic;
using ZXR.Security;
using ZXR.Core;

using CAUtility.Dal.NewsLetter.News;

namespace CAUtility.Logic.NewsLetter.News
{

    
    public class InsertNewsBizLogic : BizLogic
    {

        public InsertNewsBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            InsertNewsDalProcess udiParam = new InsertNewsDalProcess();
            udiParam.NewsContent = ((InsertNewsBizProcess)param).NewsContent;
            udiParam.NewsTitle = ((InsertNewsBizProcess)param).NewsTitle;
            udiParam.RegDatetime = ((InsertNewsBizProcess)param).RegDatetime;
            udiParam.NewsTag = ((InsertNewsBizProcess)param).NewsTag;

            if (string.IsNullOrEmpty(udiParam.NewsContent)
                || string.IsNullOrEmpty(udiParam.NewsTitle)
                || string.IsNullOrEmpty(udiParam.RegDatetime)
                || string.IsNullOrEmpty(udiParam.NewsTag)
                )
            {
                throw new ZXR.Core.ZxrException(MessageManager.GetValue(MessageKey.CommonE0002)) { ErrorType = ErrorType.OperationError };
            }

            InsertNewsDalFetch fetch = new InsertNewsDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            fetch.UDIExecuteLogic(udiParam);

            return new BizResult() { Result = true };
        }
    }
}
