﻿
using System;

using ZXR.BusinessLogic;
using ZXR.DataAccess;

using CAUtility.Dal.NewsLetter.News;

namespace CAUtility.Logic.NewsLetter.News
{

    public class ListNewsBizLogic : BizLogic
    {

        public ListNewsBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            this.ZxrTransaction = new ZXR.DataAccess.ZxrTransaction();

            ListNewsBizResult result = new ListNewsBizResult();

            ListNewsDalProcess getParam = new ListNewsDalProcess();
            getParam.TagID = ((ListNewsBizProcess)param).TagID;
            getParam.SelectCount = ((ListNewsBizProcess)param).SelectCount;
            getParam.PageIndex = ((ListNewsBizProcess)param).PageIndex;
            getParam.OnePageMaxItemsCount = CaSettings.NewsCountInPage;

            DalSelectFetch fetch = new ListNewsDalFetch();
            fetch.JoinTransaction(this.ZxrTransaction);
            ListNewsDalResult fetchResult = (ListNewsDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (ListNewsDalResultElement ele in fetchResult)
            {
                ListNewsBizResultElement element = new ListNewsBizResultElement();
                element.NewsContent = ele.NewsContent;
                element.NewsID = ele.NewsID;
                element.NewsTitle = ele.NewsTitle;
                element.RegDatetime = Convert.ToDateTime(ele.RegDatetime).ToString("yyyy/MM/dd");
                element.ClickCounter = ele.ClickCounter;

                result.DataList.Add(element);
            }

            result.TagName = fetchResult.TagName;

            PostCountDalProcess postCountParam = new PostCountDalProcess();
            postCountParam.TagID = ((ListNewsBizProcess)param).TagID;

            PostCountDalFetch postCountFetch = new PostCountDalFetch();
            fetch.JoinTransaction(this.ZxrTransaction);
            result.TotalPostCount = System.Convert.ToInt32(postCountFetch.ScalarExecuteLogic(postCountParam));

            this.ZxrTransaction.Commit();

            return result;
        }
    }
}
