﻿
using System;
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;

using CAUtility.Dal.NewsLetter.News;

namespace CAUtility.Logic.NewsLetter.News
{

    public class ListNewsForDisplayBizLogic : BizLogic
    {

        public ListNewsForDisplayBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            this.ZxrTransaction = new ZXR.DataAccess.ZxrTransaction();

            ListNewsForDisplayBizResult result = new ListNewsForDisplayBizResult();

            ListNewsForDisplayDalProcess getParam = new ListNewsForDisplayDalProcess();
            getParam.TagID = ((ListNewsForDisplayBizProcess)param).TagID;
            getParam.SelectCount = ((ListNewsForDisplayBizProcess)param).SelectCount;

            DalSelectFetch fetch = new ListNewsForDisplayDalFetch();
            fetch.JoinTransaction(this.ZxrTransaction);
            ListNewsForDisplayDalResult fetchResult = (ListNewsForDisplayDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (ListNewsForDisplayDalResultElement ele in fetchResult)
            {
                ListNewsForDisplayBizResultElement element = new ListNewsForDisplayBizResultElement();
                element.NewsContent = ele.NewsContent;
                element.NewsID = ele.NewsID;
                element.NewsTitle = ele.NewsTitle;
                element.RegDatetime = ele.RegDatetime;

                result.DataList.Add(element);
            }

            result.TagName = fetchResult.TagName;

            PostCountDalProcess postCountParam = new PostCountDalProcess();
            postCountParam.TagID = ((ListNewsForDisplayBizProcess)param).TagID;

            PostCountDalFetch postCountFetch = new PostCountDalFetch();
            fetch.JoinTransaction(this.ZxrTransaction);
            result.TotalPostCount = System.Convert.ToInt32(postCountFetch.ScalarExecuteLogic(postCountParam));

            this.ZxrTransaction.Commit();

            return result;
        }
    }
}
