﻿
using ZXR.BusinessLogic;
using ZXR.Data;
using ZXR.DataAccess;
using CAUtility.Dal.Page;

namespace CAUtility.Logic.Page
{

    [DataCache("GetPageListBizLogic")]
    public class GetPageListBizLogic : BizLogic
    {

        public GetPageListBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            GetPageListBizResult result = new GetPageListBizResult();

            GetPageListDalProcess getParam = new GetPageListDalProcess();
            getParam.Culture = ((GetPageListBizProcess)param).Culture;
            getParam.TopPageId = ((GetPageListBizProcess)param).TopPageId;
            getParam.Status = ((GetPageListBizProcess)param).Status;
            getParam.IsShowInMenu = ((GetPageListBizProcess)param).IsShowInMenu;

            DalSelectFetch fetch = new GetPageListDalFetch();
            GetPageListDalResult fetchResult = (GetPageListDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (GetPageListDalResultElement ele in fetchResult)
            {
                GetPageListBizResultElement element = new GetPageListBizResultElement();
                element.ID = ele.ID;
                element.DisplayText = ele.DisplayText;
                element.TopPageId = ele.TopPageId;
                element.Status = ele.Status;
                element.LinkImage = ele.LinkImage;
                element.PageOrder = ele.PageOrder;
                element.ClickCount = ele.ClickCount;

                if (string.Equals(ele.IsShowInMenu, "1"))
                    element.IsShowInMenu = true;
                else
                    element.IsShowInMenu = false;

                result.DataList.Add(element);
            }

            return result;
        }

    }
}
