﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;
using ZXR.Web.Util;

using CAUtility.Dal.Page;

namespace CAUtility.Logic.Page
{

    public class GetSinglePageBizLogic : BizLogic
    {

        public GetSinglePageBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            System.Reflection.Assembly asm = System.Reflection.Assembly.GetExecutingAssembly();
            GetSinglePageBizResult result = null;

            GetSinglePageDalProcess getParam = new GetSinglePageDalProcess();
            getParam.ID = ((GetSinglePageBizProcess)param).ID;

            DalSelectFetch fetch = new GetSinglePageDalFetch();

            if (this.ZxrTransaction != null)
                fetch.JoinTransaction(this.ZxrTransaction);

            GetSinglePageDalResult fetchResult = (GetSinglePageDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (GetSinglePageDalResultElement ele in fetchResult)
            {
                result = new GetSinglePageBizResult();
                result.Contents = ele.Contents;
                result.DisplayText = ele.DisplayText;
                result.PageOrder = ele.PageOrder;
                result.TopPageId = ele.TopPageId;
                result.IsShowInMenu = ele.IsShowInMenu;
                result.MetaKeyword = ele.MetaKeyword;
                result.LinkImage = ele.LinkImage;
                result.Culture = ele.Culture;
                result.Status = ele.Status;
            }

            try
            {
                if (AccessCounter.ContentsCount("Page", System.Convert.ToInt32(((GetSinglePageBizProcess)param).ID)) == 1)
                {
                    UpdateCounterDalProcess counterParam = new UpdateCounterDalProcess();
                    counterParam.ID = ((GetSinglePageBizProcess)param).ID;

                    UpdateCounterDalFetch counterFetch = new UpdateCounterDalFetch();
                    counterFetch.UDIExecuteLogic(counterParam);
                }
            }
            catch (System.Exception ex)
            {

                ZXR.Log.Logger.Error("カウンタ", ex);
            }

            return result;
        }

    }
}
