﻿
using ZXR.BusinessLogic;
using ZXR.Security;
using CAUtility.Dal.Page;
using CAUtility.Dal.Common;

namespace CAUtility.Logic.Page
{

    
    public class InsertNewPageBizLogic : BizLogic
    {

        public InsertNewPageBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            this.ZxrTransaction = new ZXR.DataAccess.ZxrTransaction();

            InsertNewPageDalProcess insertParam = new InsertNewPageDalProcess();
            insertParam.DisplayText = ((InsertNewPageBizProcess)param).DisplayText;
            insertParam.Contents = ((InsertNewPageBizProcess)param).Contents;
            insertParam.Culture = ((InsertNewPageBizProcess)param).Culture;
            insertParam.PageOrder = ((InsertNewPageBizProcess)param).PageOrder;
            insertParam.TopPageId = ((InsertNewPageBizProcess)param).TopPageId;
            insertParam.IsShowInMenu = ((InsertNewPageBizProcess)param).IsShowInMenu;
            insertParam.MetaKeyword = ((InsertNewPageBizProcess)param).MetaKeyword;
            insertParam.LinkImage = ((InsertNewPageBizProcess)param).LinkImage;

            InsertNewPageDalFetch fetch = new InsertNewPageDalFetch();
            fetch.JoinTransaction(this.ZxrTransaction);
            fetch.UDIExecuteLogic(insertParam);

            GetCurrentInsertIdDalFetch currentInsert = new GetCurrentInsertIdDalFetch();
            currentInsert.JoinTransaction(this.ZxrTransaction);
            object currentInsertResult = currentInsert.ScalarExecuteLogic(null);

            foreach (int groupid in ((InsertNewPageBizProcess)param).AllowReadGroups)
            {
                SetPageAuthDalProcess authParam = new SetPageAuthDalProcess();
                authParam.PageID = System.Convert.ToInt32(currentInsertResult);
                authParam.ReadUserGroupId = groupid;

                SetPageAuthDalFetch authFetch = new SetPageAuthDalFetch();
                authFetch.JoinTransaction(this.ZxrTransaction);
                authFetch.UDIExecuteLogic(authParam);
            }

            this.ZxrTransaction.Commit();

            return new BizResult() { Result = true, ResultData = currentInsertResult };
        }
    }
}
