﻿
using ZXR.BusinessLogic;
using CAUtility.Dal.Page;

namespace CAUtility.Logic.Page
{

    
    public class UpdatePageBizLogic : BizLogic
    {

        public UpdatePageBizLogic()
            : base()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            this.ZxrTransaction = new ZXR.DataAccess.ZxrTransaction();

            UpdatePageDalProcess updateParam = new UpdatePageDalProcess();
            updateParam.ID = ((UpdatePageBizProcess)param).ID;
            updateParam.DisplayText = ((UpdatePageBizProcess)param).DisplayText;
            updateParam.Contents = ((UpdatePageBizProcess)param).Contents;
            updateParam.PageOrder = ((UpdatePageBizProcess)param).PageOrder;
            updateParam.TopPageId = ((UpdatePageBizProcess)param).TopPageId;
            updateParam.IsShowInMenu = ((UpdatePageBizProcess)param).IsShowInMenu;
            updateParam.LinkImage = ((UpdatePageBizProcess)param).LinkImage ;
            updateParam.MetaKeyword = ((UpdatePageBizProcess)param).MetaKeyword;

            UpdatePageDalFetch fetch = new UpdatePageDalFetch();
            fetch.JoinTransaction(this.ZxrTransaction);
            fetch.UDIExecuteLogic(updateParam);

            ClearPageAuthDalProcess clearParam = new ClearPageAuthDalProcess();
            clearParam.ID = System.Convert.ToInt32(((UpdatePageBizProcess)param).ID);

            ClearPageAuthDalFetch clearFetch = new ClearPageAuthDalFetch();
            clearFetch.JoinTransaction(this.ZxrTransaction);
            clearFetch.UDIExecuteLogic(clearParam);

            foreach (int groupid in ((UpdatePageBizProcess)param).AllowReadGroups)
            {
                SetPageAuthDalProcess authParam = new SetPageAuthDalProcess();
                authParam.PageID = System.Convert.ToInt32(((UpdatePageBizProcess)param).ID);
                authParam.ReadUserGroupId = groupid;

                SetPageAuthDalFetch authFetch = new SetPageAuthDalFetch();
                authFetch.JoinTransaction(this.ZxrTransaction);
                authFetch.UDIExecuteLogic(authParam);
            }

            this.ZxrTransaction.Commit();

            return new BizResult() { Result = true };
        }

    }
}
