﻿
using System;
using ZXR.BusinessLogic;
using ZXR.Security;
using ZXR;
using ZXR.Core;

using ZXR.Web.Util;
using CAUtility.Dal.PostThread;

namespace CAUtility.Logic.PostThread
{

    public class InsertPostThreadBizLogic : BizLogic
    {

        public InsertPostThreadBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            if (string.IsNullOrEmpty(((InsertPostThreadBizProcess)param).Action))
            {
                throw new ZxrException("Error Code 01");
            }

            if (((InsertPostThreadBizProcess)param).ForumId == 0)
            {
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            }

            if (string.Equals(((InsertPostThreadBizProcess)param).Action, "Reply")
               && ((InsertPostThreadBizProcess)param).ParentThreadId == 0)
            {
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            }
            else if (string.Equals(((InsertPostThreadBizProcess)param).Action, "Insert")
               && ((InsertPostThreadBizProcess)param).ParentThreadId != 0)
            {
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            }
            else
            {
                InsertPostThreadDalProcess udiParam = new InsertPostThreadDalProcess();
                udiParam.ForumId = ((InsertPostThreadBizProcess)param).ForumId;
                udiParam.ParentThreadId = ((InsertPostThreadBizProcess)param).ParentThreadId;
                udiParam.PostContent = HtmlSanitize.Sanitize(((InsertPostThreadBizProcess)param).PostContent);
                udiParam.PostDatetime = DateTime.Now;
                udiParam.PostTitle = HtmlSanitize.Sanitize(((InsertPostThreadBizProcess)param).PostTitle);
                udiParam.UserName = ((InsertPostThreadBizProcess)param).UserName;
                udiParam.UserNickName = HtmlSanitize.Sanitize(((InsertPostThreadBizProcess)param).UserNickName);

                InsertPostThreadDalFetch fetch = new InsertPostThreadDalFetch();
                if (this.ZxrTransaction != null)
                {
                    fetch.JoinTransaction(this.ZxrTransaction);
                }
                fetch.UDIExecuteLogic(udiParam);

                return new BizResult() { Result = true };
            }
        }
    }
}
