﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;
using ZXR.Web.Util;

using CAUtility.Dal.PostThread;

namespace CAUtility.Logic.PostThread
{

    public class ListPostThreadBizLogic : BizLogic
    {

        public ListPostThreadBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            ListPostThreadBizResult result = new ListPostThreadBizResult();

            ListPostThreadDalProcess getParam = new ListPostThreadDalProcess();
            getParam.ForumId = ((ListPostThreadBizProcess)param).ForumId;
            getParam.PageIndex = ((ListPostThreadBizProcess)param).PageIndex;
            getParam.OnePageMaxItemsCount = ((ListPostThreadBizProcess)param).OnePageMaxItemsCount;

            DalSelectFetch fetch = new ListPostThreadDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            ListPostThreadDalResult fetchResult = (ListPostThreadDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (ListPostThreadDalResultElement ele in fetchResult)
            {
                ListPostThreadBizResultElement element = new ListPostThreadBizResultElement();
                element.ID = ele.ID;
                element.ClickCount = ele.ClickCount;
                element.ForumId = ele.ForumId;
                element.ParentThreadId = ele.ParentThreadId;
                element.PostContent = ele.PostContent;
                element.PostDatetime = ele.PostDatetime;
                element.PostTitle = ZXR.Core.StringUtility.StringDecode(ele.PostTitle);
                element.UpdateDatetime = ele.UpdateDatetime;
                element.UserName = ele.UserName;
                element.UserNickName = ele.UserNickName;
                element.ReplyCount = ele.ReplyCount;

                result.DataList.Add(element);
            }

            ThreadCountDalProcess threadCountParam = new ThreadCountDalProcess();
            threadCountParam.ForumId = ((ListPostThreadBizProcess)param).ForumId;

            ThreadCountDalFetch threadCountFetch = new ThreadCountDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            result.TotalThreadCount = System.Convert.ToInt32(threadCountFetch.ScalarExecuteLogic(threadCountParam));

            return result;
        }
    }
}
