﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;
using CAUtility.Dal.PostThread;
using ZXR.Web.Util;

namespace CAUtility.Logic.PostThread
{

    public class OneThreadBizLogic : BizLogic
    {

        public OneThreadBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            OneThreadBizResult result = new OneThreadBizResult();

            OneThreadDalProcess getParam = new OneThreadDalProcess();
            getParam.ThreadId = ((OneThreadBizProcess)param).ThreadId;

            DalSelectFetch fetch = new OneThreadDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            OneThreadDalResult fetchResult = (OneThreadDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (OneThreadDalResultElement ele in fetchResult)
            {
                OneThreadBizResultElement element = new OneThreadBizResultElement();
                element.ID = ele.ID;
                element.ForumId = ele.ForumId;
                element.ParentThreadId = ele.ParentThreadId;
                element.PostContent = ele.PostContent;
                element.PostDatetime = ele.PostDatetime;
                element.PostTitle = ele.PostTitle;
                element.UpdateDatetime = ele.UpdateDatetime;
                element.UserName = ele.UserName;
                element.UserNickName = ele.UserNickName;

                result.DataList.Add(element);
            }

            try
            {
                if (AccessCounter.ContentsCount("Forum", ((OneThreadBizProcess)param).ThreadId) == 1)
                {
                    UpdateCounterDalProcess counterParam = new UpdateCounterDalProcess();
                    counterParam.ThreadId = ((OneThreadBizProcess)param).ThreadId;

                    UpdateCounterDalFetch counterFetch = new UpdateCounterDalFetch();
                    counterFetch.UDIExecuteLogic(counterParam);
                }
            }
            catch (System.Exception ex)
            {

                ZXR.Log.Logger.Error("カウンタ", ex);
            }

            return result;
        }
    }
}
