﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;
using ZXR.Web.Util;

using CAUtility.Dal.PostThread;

namespace CAUtility.Logic.PostThread
{

    public class SingleThreadBizLogic : BizLogic
    {

        public SingleThreadBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            SingleThreadBizResult result = new SingleThreadBizResult();

            SingleThreadDalProcess getParam = new SingleThreadDalProcess();
            getParam.ID = ((SingleThreadBizProcess)param).ID;

            DalSelectFetch fetch = new SingleThreadDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            SingleThreadDalResult fetchResult = (SingleThreadDalResult)fetch.SelectExecuteLogic(getParam);

            result.ID = fetchResult.ID;
            result.PostTitle = HtmlSanitize.Desanitize(fetchResult.PostTitle);
            result.PostContent = HtmlSanitize.Desanitize(fetchResult.PostContent);
            result.UserName = fetchResult.UserName;

            return result;
        }
    }
}
