﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Data;

using CAUtility.Dal.ProductKinds;

namespace CAUtility.Logic.ProductKinds
{

    [DataCache("DisplayProductKindsListBizLogic")]
    public class DisplayProductKindsListBizLogic : BizLogic
    {

        public DisplayProductKindsListBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            DisplayProductKindsListBizResult result = new DisplayProductKindsListBizResult();

            DisplayProductKindsListDalProcess getParam = new DisplayProductKindsListDalProcess();
            getParam.Culture = ((DisplayProductKindsListBizProcess)param).Culture;

            DalSelectFetch fetch = new DisplayProductKindsListDalFetch();
            DisplayProductKindsListDalResult fetchResult = (DisplayProductKindsListDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (DisplayProductKindsListDalResultElement ele in fetchResult)
            {
                DisplayProductKindsListBizResultElement element = new DisplayProductKindsListBizResultElement();
                element.ID = ele.ID;
                element.Name = ele.Name;
                element.Details = ele.Details;
                element.MetaKeyword = ele.MetaKeyword;
                element.LinkImage = ele.LinkImage;

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
