﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Data;

using CAUtility.Dal.Products;

namespace CAUtility.Logic.Products
{

    [DataCache("DisplayProductListBizLogic")]
    public class DisplayProductListBizLogic : BizLogic
    {

        public DisplayProductListBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            this.ZxrTransaction = new ZXR.DataAccess.ZxrTransaction();

            DisplayProductListBizResult result = new DisplayProductListBizResult();

            DisplayProductListDalProcess listItemParam = new DisplayProductListDalProcess();
            listItemParam.KindsID = ((DisplayProductListBizProcess)param).KindsID;
            listItemParam.PageIndex = ((DisplayProductListBizProcess)param).PageIndex;
            listItemParam.OnePageMaxItemsCount = ((DisplayProductListBizProcess)param).OnePageMaxItemsCount;

            DalSelectFetch listItemFetch = new DisplayProductListDalFetch();
            listItemFetch.JoinTransaction(this.ZxrTransaction);
            DisplayProductListDalResult listItemResult = (DisplayProductListDalResult)listItemFetch.SelectExecuteLogic(listItemParam);

            foreach (DisplayProductListDalResultElement ele in listItemResult)
            {
                DisplayProductListBizResultElement element = new DisplayProductListBizResultElement();
                element.ID = ele.ID;
                element.Name  = ele.Name;
                element.Details  = ele.Details;
                element.ImagePath  = ele.ImagePath;
                element.KindsID  = ele.KindsID;
                element.OutLine  = ele.OutLine;
                element.ProductID  = ele.ProductID;
                element.StockCount  = ele.StockCount;
                element.Price  = ele.Price;
                element.ClickCount  = ele.ClickCount;

                result.DataList.Add(element);
            }

            GetProductCountDalProcess countItemParam = new GetProductCountDalProcess();
            countItemParam.KindsID = ((DisplayProductListBizProcess)param).KindsID;

            GetProductCountDalFetch countItemfetch = new GetProductCountDalFetch();
            countItemfetch.JoinTransaction(this.ZxrTransaction);
            BizResult countItemResult = new BizResult();

            result.TotalProductCount = System.Convert.ToInt32(countItemfetch.ScalarExecuteLogic(countItemParam));

            this.ZxrTransaction.Commit();

            return result;
        }
    }
}
