﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Web.Util;

using CAUtility.Dal.Products;

namespace CAUtility.Logic.Products
{

    public class GetProductDetailsBizLogic : BizLogic
    {

        public GetProductDetailsBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            GetProductDetailsBizResult result = new GetProductDetailsBizResult();

            GetProductDetailsDalProcess getParam = new GetProductDetailsDalProcess();
            getParam.ID = ((GetProductDetailsBizProcess)param).ID;

            DalSelectFetch fetch = new GetProductDetailsDalFetch();
            GetProductDetailsDalResult fetchResult = (GetProductDetailsDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (GetProductDetailsDalResultElement ele in fetchResult)
            {
                result.ID = ele.ID;
                result.Details = ele.Details;
                result.ImagePath = ele.ImagePath;
                result.KindsID = ele.KindsID;
                result.Name = ele.Name;
                result.OutLine = ele.OutLine;
                result.Price = ele.Price;
                result.ProductID = ele.ProductID;
                result.StockCount = ele.StockCount;
                result.ProductOrder = ele.ProductOrder;
                result.MetaKeyword = ele.MetaKeyword;

                break;
            }

            try
            {
                if (AccessCounter.ContentsCount("Product", System.Convert.ToInt32(((GetProductDetailsBizProcess)param).ID)) == 1)
                {
                    UpdateClickCountDalProcess counterParam = new UpdateClickCountDalProcess();
                    counterParam.ID = ((GetProductDetailsBizProcess)param).ID;

                    UpdateClickCountDalFetch counterFetch = new UpdateClickCountDalFetch();
                    counterFetch.UDIExecuteLogic(counterParam);
                }
            }
            catch (System.Exception ex)
            {

                ZXR.Log.Logger.Error("カウンタ", ex);
            }

            return result;
        }
    }
}
