﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;

using CAUtility.Dal.QuestionnaireManager.Question;

namespace CAUtility.Logic.QuestionnaireManager.Question
{

    public class ListQuestionBizLogic : BizLogic
    {

        public ListQuestionBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            ListQuestionBizResult result = new ListQuestionBizResult();

            ListQuestionDalProcess fetParam = new ListQuestionDalProcess();
            fetParam.QuestionnaireID = ((ListQuestionBizProcess)param).QuestionnaireID;

            DalSelectFetch fetch = new ListQuestionDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            ListQuestionDalResult fetchResult = (ListQuestionDalResult)fetch.SelectExecuteLogic(fetParam);

            foreach (ListQuestionDalResultElement ele in fetchResult)
            {
                ListQuestionBizResultElement element = new ListQuestionBizResultElement();
                element.ID = ele.ID;
                element.Contents = ele.Contents;
                element.QuestionnaireID = ele.QuestionnaireID;
                element.QuestionOrder = ele.QuestionOrder;
                element.QuestionType = ele.QuestionType;
                element.TextInputRows = ele.TextInputRows;

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
