﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;

using CAUtility.Dal.QuestionnaireManager.Questionnaire;

namespace CAUtility.Logic.QuestionnaireManager.Questionnaire
{

    public class ListQuestionnaireBizLogic : BizLogic
    {

        public ListQuestionnaireBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            ListQuestionnaireBizResult result = new ListQuestionnaireBizResult();

            ListQuestionnaireDalProcess getParam = null;
            if (param != null)
            {
                getParam = new ListQuestionnaireDalProcess();
                getParam.QuestionnaireStatus = ((ListQuestionnaireBizProcess)param).QuestionnaireStatus;
            }

            DalSelectFetch fetch = new ListQuestionnaireDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }

            ListQuestionnaireDalResult fetchResult = (ListQuestionnaireDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (ListQuestionnaireDalResultElement ele in fetchResult)
            {
                ListQuestionnaireBizResultElement element = new ListQuestionnaireBizResultElement();
                element.ID = ele.ID;
                element.QuestionnaireStatus = ele.QuestionnaireStatus;
                element.Title = ele.Title;

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
