﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;

using CAUtility.Dal.QuestionnaireManager.Response;

namespace CAUtility.Logic.QuestionnaireManager.Response
{

    public class GetOneSessionBizLogic : BizLogic
    {

        public GetOneSessionBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            GetOneSessionBizResult result = new GetOneSessionBizResult();

            GetOneSessionDalProcess getParam = new GetOneSessionDalProcess();
            getParam.QuestionnaireID = ((GetOneSessionBizProcess)param).QuestionnaireID;
            getParam.ResponseSession = ((GetOneSessionBizProcess)param).ResponseSession;

            DalSelectFetch fetch = new GetOneSessionDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            GetOneSessionDalResult fetchResult = (GetOneSessionDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (GetOneSessionDalResultElement ele in fetchResult)
            {
                GetOneSessionBizResultElement element = new GetOneSessionBizResultElement();
                element.ID = ele.ID;
                element.QuestionContent = ele.QuestionContent;
                element.QuestionID = ele.QuestionID;
                element.QuestionItemContent = ele.QuestionItemContent;
                element.QuestionnaireID = ele.QuestionnaireID;
                element.QuestionOrder = ele.QuestionOrder;
                element.QuestionType = ele.QuestionType;

                element.ResponseContent = ZXR.Security.DesCryptogram.Decrypt(ele.ResponseContent);
                element.ResponseDatetime = ele.ResponseDatetime;
                element.ResponseSession = ele.ResponseSession;

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
