﻿
using ZXR.BusinessLogic;
using ZXR.Security;

using CAUtility.Dal.QuestionnaireManager.Response;

namespace CAUtility.Logic.QuestionnaireManager.Response
{

    public class InsertResponseBizLogic : BizLogic
    {

        public InsertResponseBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            InsertResponseDalProcess udiParam = new InsertResponseDalProcess();

            if (!string.IsNullOrEmpty(((InsertResponseBizProcess)param).Content))
                udiParam.Content = DesCryptogram.Encrypt(
                        ZXR.Web.Util.HtmlSanitize.Sanitize(((InsertResponseBizProcess)param).Content)
                    );
            else
                udiParam.Content = string.Empty;

            udiParam.QuestionID = ((InsertResponseBizProcess)param).QuestionID;
            udiParam.QuestionItemID = ((InsertResponseBizProcess)param).QuestionItemID;
            udiParam.QuestionnaireID = ((InsertResponseBizProcess)param).QuestionnaireID;
            udiParam.ResponseDatatime = ((InsertResponseBizProcess)param).ResponseDatatime;
            udiParam.ResponseSession = ((InsertResponseBizProcess)param).ResponseSession;

            InsertResponseDalFetch fetch = new InsertResponseDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            fetch.UDIExecuteLogic(udiParam);

            return new BizResult() { Result = true };
        }
    }
}
