﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;

using CAUtility.Dal.QuestionnaireManager.Response;

namespace CAUtility.Logic.QuestionnaireManager.Response
{

    public class ListResponseItemBizLogic : BizLogic
    {

        public ListResponseItemBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            ListResponseItemBizResult result = new ListResponseItemBizResult();

            ListResponseItemDalProcess getParam = new ListResponseItemDalProcess();
            getParam.QuestionID = ((ListResponseItemBizProcess)param).QuestionID;
            getParam.QuestionnaireID = ((ListResponseItemBizProcess)param).QuestionnaireID;
            getParam.ResponseSession = ((ListResponseItemBizProcess)param).ResponseSession;

            DalSelectFetch fetch = new ListResponseItemDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            ListResponseItemDalResult fetchResult = (ListResponseItemDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (ListResponseItemDalResultElement ele in fetchResult)
            {
                ListResponseItemBizResultElement element = new ListResponseItemBizResultElement();
                element.ID = ele.ID;
                element.Content = ZXR.Security.DesCryptogram.Decrypt(ele.Content);
                element.QuestionID = ele.QuestionID;
                element.QuestionnaireID = ele.QuestionnaireID;
                element.ResponseDatatime = ele.ResponseDatatime;
                element.ResponseSession = ele.ResponseSession;

                result.DataList.Add(element);
            }

            return result;
        }

    }
}
