﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;
using CAUtility.Dal.ReservationData;

namespace CAUtility.Logic.ReservationData
{

    
    public class AdminGetReservationBizLogic : BizLogic
    {

        public AdminGetReservationBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            AdminGetReservationBizResult result = new AdminGetReservationBizResult();

            AdminGetReservationDalProcess getParam = new AdminGetReservationDalProcess();
            getParam.ReservationNumber = ((AdminGetReservationBizProcess)param).ReservationNumber;

            DalSelectFetch fetch = new AdminGetReservationDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            AdminGetReservationDalResult fetchResult = (AdminGetReservationDalResult)fetch.SelectExecuteLogic(getParam);

            result.ID = fetchResult.ID;
            result.ItemID = fetchResult.ItemID;
            result.ItemName = fetchResult.ItemName;
            result.NotifyMailList = fetchResult.NotifyMailList;
            result.ReservateRegDate = fetchResult.ReservateRegDate;
            result.ReservationBegin = fetchResult.ReservationBegin;
            result.ReservationEnd = fetchResult.ReservationEnd;
            result.ReservationNumber = fetchResult.ReservationNumber;
            result.Status = fetchResult.Status ;
            result.UserMail = ZXR.Security.DesCryptogram.Decrypt(fetchResult.UserMail);
            result.UserName = ZXR.Security.DesCryptogram.Decrypt(fetchResult.UserName);
            result.UserPhone = ZXR.Security.DesCryptogram.Decrypt(fetchResult.UserPhone);

            if (fetchResult.ReservationType == -2)
                {
                    result.ReservateDatetime = fetchResult.ReservationBegin.ToString("yyyy/MM/dd") + "～" + 
                        fetchResult.ReservationEnd.ToString("yyyy/MM/dd");
                }
                else if (fetchResult.ReservationType == -1)
                {
                    result.ReservateDatetime = fetchResult.ReservationBegin.ToString("yyyy/MM/dd");
                }
                else if (fetchResult.ReservationType == 0)
                {
                    result.ReservateDatetime = fetchResult.ReservationBegin.ToString("yyyy/MM/dd HH:mm:ss") + "～" +
                        fetchResult.ReservationEnd.ToString("HH:mm:ss");
                }
                else if (fetchResult.ReservationType == 1)
                {
                    result.ReservateDatetime = fetchResult.ReservationBegin.ToString("yyyy/MM/dd ") +
                        fetchResult.ReservationBegin.ToString("HH:mm:ss") +
                        "～" + fetchResult.ReservationBegin.AddMinutes(fetchResult.DatetimeLegth).ToString("HH:mm:ss");
                }

            return result;
        }
    }
}
