﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;
using CAUtility.Dal.ReservationData;

namespace CAUtility.Logic.ReservationData
{

    public class GetReservationBizLogic : BizLogic
    {

        public GetReservationBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            GetReservationBizResult result = new GetReservationBizResult();

            GetReservationDalProcess getParam = new GetReservationDalProcess();
            getParam.Passwrod = ((GetReservationBizProcess)param).Passwrod;
            getParam.ReservationNumber = ((GetReservationBizProcess)param).ReservationNumber;

            DalSelectFetch fetch = new GetReservationDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            GetReservationDalResult fetchResult = (GetReservationDalResult)fetch.SelectExecuteLogic(getParam);

            result.ID = fetchResult.ID;
            result.ItemID = fetchResult.ItemID;
            result.ItemName = fetchResult.ItemName;
            result.NotifyMailList = fetchResult.NotifyMailList;
            result.ReservateDatetime = fetchResult.ReservateDatetime;
            result.ReservationBegin = fetchResult.ReservationBegin;
            result.ReservationEnd = fetchResult.ReservationEnd;
            result.Status = fetchResult.Status;
            result.UserMail = fetchResult.UserMail;
            result.UserName = fetchResult.UserName;
            result.UserPhone = fetchResult.UserPhone;

            return result;
        }
    }
}
