﻿
using ZXR.Core;
using ZXR.BusinessLogic;
using ZXR.Security;
using CAUtility.Dal.ReservationData;

namespace CAUtility.Logic.ReservationData
{

    public class InsertReservationBizLogic : BizLogic
    {

        public InsertReservationBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            string reservationNumber = "";
            while (true)
            {
                reservationNumber = GuidUtility.RandomString(2) + GuidUtility.RandomNumber(10000, 99999).ToString();

                ReservationConfirmationBizProcess rcParam = new ReservationConfirmationBizProcess();
                rcParam.ReservationNumber = reservationNumber;

                ReservationConfirmationBizLogic rcLogic = new ReservationConfirmationBizLogic();
                if (rcLogic.Execute(rcParam).Result)
                {
                    break;
                }
            }

            InsertReservationDalProcess udiParam = new InsertReservationDalProcess();
            udiParam.ItemID = ((InsertReservationBizProcess)param).ItemID;
            udiParam.NotifyMailList = ((InsertReservationBizProcess)param).NotifyMailList;
            udiParam.Passwrod = ((InsertReservationBizProcess)param).Passwrod;
            udiParam.ReservateDatetime = ((InsertReservationBizProcess)param).ReservateDatetime;
            udiParam.ReservationBegin = ((InsertReservationBizProcess)param).ReservationBegin;
            udiParam.ReservationEnd = ((InsertReservationBizProcess)param).ReservationEnd;
            udiParam.ReservationNumber = reservationNumber;
            udiParam.UserMail = DesCryptogram.Encrypt(((InsertReservationBizProcess)param).UserMail);
            udiParam.UserName = DesCryptogram.Encrypt(
                        ZXR.Web.Util.HtmlSanitize.Sanitize(((InsertReservationBizProcess)param).UserName)
                    );
            udiParam.UserPhone = DesCryptogram.Encrypt(((InsertReservationBizProcess)param).UserPhone);

            InsertReservationDalFetch fetch = new InsertReservationDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            fetch.UDIExecuteLogic(udiParam);

            return new BizResult() { Result = true, ResultData = reservationNumber };
        }
    }
}
