﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;
using CAUtility.Dal.ReservationData;

namespace CAUtility.Logic.ReservationData
{

    public class ListDataBizLogic : BizLogic
    {

        public ListDataBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            ListDataBizResult result = new ListDataBizResult();

            ListDataDalProcess getParam = new ListDataDalProcess();
            getParam.ItemID = ((ListDataBizProcess)param).ItemId;

            DalSelectFetch fetch = new ListDataDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            ListDataDalResult fetchResult = (ListDataDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (ListDataDalResultElement ele in fetchResult)
            {
                ListDataBizResultElement element = new ListDataBizResultElement();
                element.ID = ele.ID;
                element.ItemID = ele.ItemID;
                element.ItemName = ele.ItemName;
                element.NotifyMailList = ele.NotifyMailList;
                element.Passwrod = ele.Passwrod;
                element.ReservateDatetime = ele.ReservateDatetime;
                element.ReservationBegin = ele.ReservationBegin;
                element.ReservationEnd = ele.ReservationEnd;
                element.ReservationNumber = ele.ReservationNumber;
                element.UserMail = ele.UserMail;
                element.UserName = ele.UserName;
                element.UserPhone = ele.UserPhone;

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
