﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;

using CAUtility.Dal.ReservationData;

namespace CAUtility.Logic.ReservationData
{

    
    public class SearchReservationDataBizLogic : BizLogic
    {

        public SearchReservationDataBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            SearchReservationDataBizResult result = new SearchReservationDataBizResult();

            SearchReservationDataDalProcess getParam = new SearchReservationDataDalProcess();
            getParam.RegistDate = ((SearchReservationDataBizProcess)param).RegistDate;
            getParam.ReservationNumber = ((SearchReservationDataBizProcess)param).ReservationNumber ;
            getParam.Status = ((SearchReservationDataBizProcess)param).Status;
            getParam.UserName = ((SearchReservationDataBizProcess)param).UserName;

            DalSelectFetch fetch = new SearchReservationDataDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            SearchReservationDataDalResult fetchResult = (SearchReservationDataDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (SearchReservationDataDalResultElement ele in fetchResult)
            {
                SearchReservationDataBizResultElement element = new SearchReservationDataBizResultElement();
                element.ID = ele.ID;
                element.ItemID = ele.ItemID;
                element.ItemName = ele.ItemName;
                element.ReservateRegDate = ele.ReservateRegDate;
                element.ReservationNumber = ele.ReservationNumber;
                element.UserMail = ele.UserMail;
                element.UserName = ZXR.Security.DesCryptogram.Decrypt(ele.UserName);
                element.UserPhone = ele.UserPhone;

                if (ele.ReservationType == -2)
                {
                    element.ReservateDatetime = ele.ReservationBegin.ToString("yyyy/MM/dd") + "～" + 
                        ele.ReservationEnd.ToString("yyyy/MM/dd");
                }
                else if (ele.ReservationType == -1)
                {
                    element.ReservateDatetime = ele.ReservationBegin.ToString("yyyy/MM/dd");
                }
                else if (ele.ReservationType == 0)
                {
                    element.ReservateDatetime = ele.ReservationBegin.ToString("yyyy/MM/dd") + "～" +  ele.ReservationEnd.ToString("yyyy/MMdd/");
                }
                else if (ele.ReservationType == 1)
                {
                    element.ReservateDatetime = ele.ReservationBegin.ToString("yyyy/MM/dd ") +
                        ele.ReservationBegin.ToString("HH:mm:ss") + "～" +
                        "～" + ele.ReservationEnd.ToString("HH:mm:ss");
                }

                if (string.Equals(ele.Status, DataStatus.Cancel.ToString()))
                    element.Status = "キャンセル";
                else if (string.Equals(ele.Status, DataStatus.DummyDelete.ToString()))
                    element.Status = "処理済み";
                else if (string.Equals(ele.Status, DataStatus.Normal.ToString()))
                    element.Status = "未処理";
                else if (string.Equals(ele.Status, DataStatus.Processing.ToString()))
                    element.Status = "処理中";

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
