﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;
using CAUtility.Dal.ReservationItem;

namespace CAUtility.Logic.ReservationItem
{

    public class GetItemDetailBizLogic : BizLogic
    {

        public GetItemDetailBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            GetItemDetailBizResult result = new GetItemDetailBizResult();

            GetItemDetailDalProcess getParam = new GetItemDetailDalProcess();
            getParam.ID = ((GetItemDetailBizProcess)param).ID;

            DalSelectFetch fetch = new GetItemDetailDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            GetItemDetailDalResult fetchResult = (GetItemDetailDalResult)fetch.SelectExecuteLogic(getParam);

            result.CanMailNotify = fetchResult.CanMailNotify;
            result.CanRepetition = fetchResult.CanRepetition;
            result.ImagePath = fetchResult.ImagePath ;
            result.IntervalTime  = fetchResult.IntervalTime ;
            result.ItemDetail = fetchResult.ItemDetail;
            result.Name = fetchResult.Name;
            result.Order = fetchResult.Order;
            result.Permission = fetchResult.Permission;
            result.ReservationBeginTime = fetchResult.ReservationBeginTime;
            result.ReservationEndTime = fetchResult.ReservationEndTime;
            result.SimultaneousNumber = fetchResult.SimultaneousNumber;
            result.Unit = fetchResult.Unit;
            result.HolidayList = fetchResult.HolidayList;
            result.ID = fetchResult.ID;
            result.DisplayDateCount = fetchResult.DisplayDateCount;
            result.DatetimeLength = fetchResult.DatetimeLength;

            return result;
        }
    }
}
