﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;
using CAUtility.Dal.ReservationItem;

namespace CAUtility.Logic.ReservationItem
{

    public class ReservationItemListBizLogic : BizLogic
    {

        public ReservationItemListBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            ReservationItemListBizResult result = new ReservationItemListBizResult();

            DalSelectFetch fetch = new ReservationItemListDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            ReservationItemListDalResult fetchResult = (ReservationItemListDalResult)fetch.SelectExecuteLogic(null);

            foreach (ReservationItemListDalResultElement ele in fetchResult)
            {
                ReservationItemListBizResultElement element = new ReservationItemListBizResultElement();
                element.ID = ele.ID;
                element.CanMailNotify = ele.CanMailNotify;
                element.CanRepetition = ele.CanRepetition;
                element.ImagePath = ele.ImagePath;
                element.IntervalTime = ele.IntervalTime;
                element.ItemDetail = ele.ItemDetail;
                element.Name = ele.Name;
                element.Order = ele.Order;
                element.Permission = ele.Permission;
                element.ReservationBeginTime = ele.ReservationBeginTime;
                element.ReservationEndTime = ele.ReservationEndTime;
                element.SimultaneousNumber = ele.SimultaneousNumber;
                element.Unit = ele.Unit;
                element.HolidayList = ele.HolidayList;

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
