﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;

using CAUtility.Dal.Sales;
using CAUtility.Dal.UserShoppingInfo;

namespace CAUtility.Logic.Sales
{

    
    public class GetOneOrderDetailsBizLogic : BizLogic
    {

        public GetOneOrderDetailsBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            GetOneOrderDetailsBizResult result = new GetOneOrderDetailsBizResult();

            GetOneOrderDetailsDalProcess getParam = new GetOneOrderDetailsDalProcess();
            getParam.SalesID = ((GetOneOrderDetailsBizProcess)param).SalesID;

            DalSelectFetch fetch = new GetOneOrderDetailsDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            GetOneOrderDetailsDalResult fetchResult = (GetOneOrderDetailsDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (GetOneOrderDetailsDalResultElement ele in fetchResult)
            {
                GetOneOrderDetailsBizResultElement element = new GetOneOrderDetailsBizResultElement();
                element.Amount = ele.Amount;
                element.ProductName = ele.ProductName;
                element.ProductNumber = ele.ProductNumber;
                element.Subtotal = ele.Subtotal;
                element.ProductPrice = ele.ProductPrice;

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
