﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;
using CAUtility.Dal.Sales;

namespace CAUtility.Logic.Sales
{

    
    public class GetOneOrderMasterBizLogic : BizLogic
    {

        public GetOneOrderMasterBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            GetOneOrderMasterBizResult result = new GetOneOrderMasterBizResult();

            GetOneOrderMasterDalProcess getParam = new GetOneOrderMasterDalProcess();
            getParam.SalesID = ((GetOneOrderMasterBizProcess)param).SalesID;

            DalSelectFetch fetch = new GetOneOrderMasterDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            GetOneOrderMasterDalResult fetchResult = (GetOneOrderMasterDalResult)fetch.SelectExecuteLogic(getParam);

            result.Address = ZXR.Security.DesCryptogram.Decrypt(fetchResult.Address);
            result.ArrivalTime = fetchResult.ArrivalTime;
            result.MonetaryAmount = fetchResult.MonetaryAmount;
            result.PurchaseDate = fetchResult.PurchaseDate;
            result.Remarks = fetchResult.Remarks;
            result.UserID = fetchResult.UserID;
            result.Zipcode = ZXR.Security.DesCryptogram.Decrypt(fetchResult.Zipcode);
            result.Status = fetchResult.Status;

            return result;
        }
    }
}
