﻿
using System;

using ZXR.Core;
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;

using CAUtility.Dal.Sales;

namespace CAUtility.Logic.Sales
{

    
    public class InsertOrdersBizLogic : BizLogic
    {

        public InsertOrdersBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            string salesID = GuidUtility.RandomString (2) + GuidUtility.RandomNumber(100000, 999999).ToString ();
            bool isExist = true;
            while (isExist)
            {
                CheckSalesIDDalProcess checkSalesIDParam = new CheckSalesIDDalProcess();
                checkSalesIDParam.SalesID = salesID;

                CheckSalesIDDalFetch checkSalesIDFetch = new CheckSalesIDDalFetch();
                object checkSalesIDResult = checkSalesIDFetch.ScalarExecuteLogic(checkSalesIDParam);

                if (checkSalesIDResult != null && Convert.ToInt32(checkSalesIDResult) > 0)
                {
                    isExist = true;
                    salesID = GuidUtility.RandomString(2) + GuidUtility.RandomNumber(100000, 999999).ToString();
                }
                else
                {
                    isExist = false;
                }
            }

            InsertSalesDalProcess udiParam = new InsertSalesDalProcess();
            udiParam.SalesID = salesID;
            udiParam.Address = DesCryptogram.Encrypt(((InsertOrdersSalesBizProcess)param).Address);
            udiParam.ArrivalDate = ((InsertOrdersSalesBizProcess)param).ArrivalDate;
            udiParam.ArrivalTime = ((InsertOrdersSalesBizProcess)param).ArrivalTime;
            udiParam.MonetaryAmount = ((InsertOrdersSalesBizProcess)param).MonetaryAmount;
            udiParam.PurchaseDate = ((InsertOrdersSalesBizProcess)param).PurchaseDate;
            udiParam.Remarks = ((InsertOrdersSalesBizProcess)param).Remarks;
            udiParam.UserID = ((InsertOrdersSalesBizProcess)param).UserID;
            udiParam.Zipcode = DesCryptogram.Encrypt(((InsertOrdersSalesBizProcess)param).Zipcode);

            InsertSalesDalFetch fetch = new InsertSalesDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            fetch.UDIExecuteLogic(udiParam);

            foreach (InsertOrdersDetailsBizProcessElement xxx in (InsertOrdersSalesBizProcess)param)
            {
                InsertSalesDetailsDalProcess detailParam = new InsertSalesDetailsDalProcess();
                detailParam.Amount = xxx.Amount;
                detailParam.ProductID = xxx.ProductID;
                detailParam.SalesID = salesID;
                detailParam.Subtotal = xxx.Subtotal;

                InsertSalesDetailsDalFetch detailsFetch = new InsertSalesDetailsDalFetch();
                if (this.ZxrTransaction != null)
                {
                    detailsFetch.JoinTransaction(this.ZxrTransaction);
                }
                detailsFetch.UDIExecuteLogic(detailParam);
            }

            return new BizResult() { Result = true , ResultData = salesID };
        }
    }
}
