﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;

using CAUtility.Dal.Sales;

namespace CAUtility.Logic.Sales
{

    
    public class ListOrdersBizLogic : BizLogic
    {

        public ListOrdersBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            ListOrdersBizResult result = new ListOrdersBizResult();

            ListOrdersDalProcess getParam = new ListOrdersDalProcess();
            getParam.UserID = ((ListOrdersBizProcess)param).UserID ;
            getParam.Status = ((ListOrdersBizProcess)param).Status;
            getParam.SalesId = ((ListOrdersBizProcess)param).SalesId;

            DalSelectFetch fetch = new ListOrdersDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            ListOrdersDalResult fetchResult = (ListOrdersDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (ListOrdersDalResultElement ele in fetchResult)
            {
                ListOrdersBizResultElement element = new ListOrdersBizResultElement();
                element.PurchaseDate = ele.PurchaseDate;
                element.SalesID = ele.SalesID;
                element.UserID = ele.UserID;

                if (string.Equals(ele.Status, DataStatus.Cancel.ToString()))
                    element.Status = "キャンセル";
                else if (string.Equals(ele.Status, DataStatus.DummyDelete.ToString()))
                    element.Status = "処理済み";
                else if (string.Equals(ele.Status, DataStatus.Normal.ToString()))
                    element.Status = "未処理";
                else if (string.Equals(ele.Status, DataStatus.Processing.ToString()))
                    element.Status = "処理中";

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
