﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;

using CAUtility.Dal.Schedule;

namespace CAUtility.Logic.Schedule
{

    
    public class ListAllMemberScheduleBizLogic : BizLogic
    {

        public ListAllMemberScheduleBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            ListAllMemberScheduleBizResult result = new ListAllMemberScheduleBizResult();

            ListAllMemberScheduleDalProcess getParam = new ListAllMemberScheduleDalProcess();
            getParam.StartDate = ((ListAllMemberScheduleBizProcess)param).StartDate;

            DalSelectFetch fetch = new ListAllMemberScheduleDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            ListAllMemberScheduleDalResult fetchResult = (ListAllMemberScheduleDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (ListAllMemberScheduleDalResultElement ele in fetchResult)
            {
                ListAllMemberScheduleBizResultElement element = new ListAllMemberScheduleBizResultElement();
                element.AuthorID = ele.AuthorID;
                element.EndTime = ele.EndTime;
                element.ID = ele.ID;
                element.RegistedTime = ele.RegistedTime;
                element.StartTime = ele.StartTime;
                element.Title = ele.Title;
                element.Description = ele.Description;
                element.GroupID = ele.GroupID;
                element.ID = ele.ID;
                element.Status = ele.Status;
                element.Type = ele.Type;
                element.RepeatString = ele.RepeatString;
                element.FriendlyName = ele.FriendlyName;

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
