﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;

using CAUtility.Dal.Schedule;
using CAUtility.Dal.GroupInfo;

namespace CAUtility.Logic.Schedule
{

    
    public class ListScheduleBizLogic : BizLogic
    {

        public ListScheduleBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            ListScheduleBizResult result = new ListScheduleBizResult();

            if (((ListScheduleBizProcess)param).GroupID > 0)
            {
                GetGroupInfoDalProcess groupParam = new GetGroupInfoDalProcess();
                groupParam.GroupId = ((ListScheduleBizProcess)param).GroupID;

                GetGroupInfoDalFetch groupFetch = new GetGroupInfoDalFetch();
                GetGroupInfoDalResult groupResult = (GetGroupInfoDalResult)groupFetch.SelectExecuteLogic(groupParam);
                result.GroupName = groupResult.GroupName;

                ListGroupScheduleDalProcess getParam = new ListGroupScheduleDalProcess();
                getParam.GroupID = ((ListScheduleBizProcess)param).GroupID;
                getParam.StartDate = ((ListScheduleBizProcess)param).StartDate;

                DalSelectFetch fetch = new ListGroupScheduleDalFetch();
                if (this.ZxrTransaction != null)
                {
                    fetch.JoinTransaction(this.ZxrTransaction);
                }
                ListGroupScheduleDalResult fetchResult = (ListGroupScheduleDalResult)fetch.SelectExecuteLogic(getParam);

                foreach (ListGroupScheduleDalResultElement ele in fetchResult)
                {
                    ListScheduleBizResultElement element = new ListScheduleBizResultElement();
                    element.AuthorID = ele.AuthorID;
                    element.EndTime = ele.EndTime;
                    element.ID = ele.ID;
                    element.RegistedTime = ele.RegistedTime;
                    element.StartTime = ele.StartTime;
                    element.Title = ele.Title;
                    element.Description = ele.Description;
                    element.GroupID = ele.GroupID;
                    element.ID = ele.ID;
                    element.Status = ele.Status;
                    element.Type = ele.Type;
                    element.RepeatString = ele.RepeatString;
                    element.FriendlyName = ele.FriendlyName;

                    result.DataList.Add(element);
                }
            }
            else
            {
                ListMemberScheduleDalProcess memberParam = new ListMemberScheduleDalProcess();
                memberParam.UserName = ((ListScheduleBizProcess)param).UserName;
                memberParam.StartDate = ((ListScheduleBizProcess)param).StartDate;

                DalSelectFetch memberfetch = new ListMemberScheduleDalFetch();
                if (this.ZxrTransaction != null)
                {
                    memberfetch.JoinTransaction(this.ZxrTransaction);
                }
                ListMemberScheduleDalResult memberfetchResult = (ListMemberScheduleDalResult)memberfetch.SelectExecuteLogic(memberParam);

                foreach (ListMemberScheduleDalResultElement ele in memberfetchResult)
                {
                    ListScheduleBizResultElement element = new ListScheduleBizResultElement();
                    element.AuthorID = ele.AuthorID;
                    element.EndTime = ele.EndTime;
                    element.ID = ele.ID;
                    element.RegistedTime = ele.RegistedTime;
                    element.StartTime = ele.StartTime;
                    element.Title = ele.Title;
                    element.Description = ele.Description;
                    element.GroupID = 0;
                    element.ID = ele.ID;
                    element.Status = ele.Status;
                    element.Type = ele.Type;
                    element.RepeatString = ele.RepeatString;
                    element.FriendlyName = ele.FriendlyName;

                    result.DataList.Add(element);
                }
            }

            return result;
        }
    }
}
