﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;

using CAUtility.Dal.Schedule;

namespace CAUtility.Logic.Schedule
{

    
    public class ScheduleDetailBizLogic : BizLogic
    {

        public ScheduleDetailBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            ScheduleDetailBizResult result = new ScheduleDetailBizResult();

            ScheduleDetailDalProcess getParam = new ScheduleDetailDalProcess();
            getParam.ID = ((ScheduleDetailBizProcess)param).ID;

            DalSelectFetch fetch = new ScheduleDetailDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            ScheduleDetailDalResult fetchResult = (ScheduleDetailDalResult)fetch.SelectExecuteLogic(getParam);

            result.AuthorID = fetchResult.AuthorID;
            result.Title = fetchResult.Title;
            result.Description = fetchResult.Description;
            result.StartTime = fetchResult.StartTime;
            result.EndTime = fetchResult.EndTime;
            result.RegistedTime = fetchResult.RegistedTime;
            result.Status = fetchResult.Status;
            result.GroupID = fetchResult.GroupID;
            result.LastUpdateTime = fetchResult.LastUpdateTime;
            result.Type = fetchResult.Type;
            result.RepeatString = fetchResult.RepeatString;
            result.FriendlyName = fetchResult.FriendlyName;

            return result;
        }
    }
}
