﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;

using CAUtility.Dal.ScheduleJoinMember;

namespace CAUtility.Logic.ScheduleJoinMember
{

    
    public class ListScheduleJoinMemberBizLogic : BizLogic
    {

        public ListScheduleJoinMemberBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            ListScheduleJoinMemberBizResult result = new ListScheduleJoinMemberBizResult();

            ListScheduleJoinMemberDalProcess getParam = new ListScheduleJoinMemberDalProcess();
            getParam.ScheduleID = ((ListScheduleJoinMemberBizProcess)param).ScheduleID;

            DalSelectFetch fetch = new ListScheduleJoinMemberDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            ListScheduleJoinMemberDalResult fetchResult = (ListScheduleJoinMemberDalResult)fetch.SelectExecuteLogic(getParam);

            foreach (ListScheduleJoinMemberDalResultElement ele in fetchResult)
            {
                ListScheduleJoinMemberBizResultElement element = new ListScheduleJoinMemberBizResultElement();
                element.UserName = ele.UserName;
                element.FriendlyName = ele.FriendlyName;

                result.DataList.Add(element);
            }

            return result;
        }
    }
}
