﻿
using ZXR.Core;
using ZXR.Security;
using ZXR.Data;

using ZXR.BusinessLogic;

namespace CAUtility.Logic.Settings
{

    
    public class BasicSettingBizLogic : BizLogic
    {
        private const string SITE_CONTEXT_FILE_PATH = "~/App_Data/ContentsSetting.xml";

        public BasicSettingBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            SettingManager setting = new SettingManager();
            setting.SetSettingValue("AdminEmail", ((BasicSettingBizProcess)param).AdminEmail);
            setting.SetSettingValue("IsSiteOpen", ((BasicSettingBizProcess)param).IsSiteOpen.ToString());
            setting.SetSettingValue("AllowRegist", ((BasicSettingBizProcess)param).AllowRegist.ToString());
            setting.Save();

            XMLKeyOfValueData xk = new XMLKeyOfValueData(
                    System.Web.HttpContext.Current.Server.MapPath(SITE_CONTEXT_FILE_PATH)
                );

            xk.SetValue("CompanyName", ((BasicSettingBizProcess)param).CompanyName);

            return new BizResult() { Result = true };
        }
    }
}
