﻿
using ZXR.Core;
using ZXR.IO;
using ZXR.Security;
using ZXR.BusinessLogic;

namespace CAUtility.Logic.Settings
{

    
    public class HighLevelSettingBizLogic : BizLogic
    {

        public HighLevelSettingBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            if (!string.Equals(((HighLevelSettingBizProcess)param).Culture, CaSettings.PageDefaultCulture))
            {
                CreateNewCultureBizProcess newCultureParam = new CreateNewCultureBizProcess();
                newCultureParam.Culture = CaSettings.PageDefaultCulture;

                CreateNewCultureBizLogic logic = new CreateNewCultureBizLogic();
                logic.Execute(newCultureParam);
            }

            SettingManager setting = new SettingManager();
            setting.SetSettingValue("AdminCulture", ((HighLevelSettingBizProcess)param).AdminCulture);
            setting.SetSettingValue("AccessDbPath", ((HighLevelSettingBizProcess)param).AccessDbPath);

            if (!string.IsNullOrEmpty(((HighLevelSettingBizProcess)param).AccessDbPw))
                setting.SetCryptoSettingValue("AccessDbPw", ((HighLevelSettingBizProcess)param).AccessDbPw);

            setting.SetSettingValue("PageDefaultCulture", ((HighLevelSettingBizProcess)param).Culture);
            setting.SetSettingValue("DataCacheTime", ((HighLevelSettingBizProcess)param).DataCacheTime.ToString());
            setting.SetSettingValue("DataCacheCount", ((HighLevelSettingBizProcess)param).DataCacheCount.ToString());
            setting.SetSettingValue("IsLogTrace", ((HighLevelSettingBizProcess)param).IsLogTrace.ToString());
            setting.SetSettingValue("BackupPath", ((HighLevelSettingBizProcess)param).BackupPath);
            setting.Save();

            return new BizResult() { Result = true };
        }
    }
}
