﻿
using System;
using ZXR.BusinessLogic;
using ZXR.Security;
using CAUtility.Dal.UserInfo;
using CAUtility.Dal.ReturnPassword;
using ZXR.DataAccess;

namespace CAUtility.Logic.UserInfo
{

    public class ForgotPasswordBizLogic : BizLogic
    {

        public ForgotPasswordBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            BizResult result = new BizResult();

            ZxrTransaction transsaction = new ZxrTransaction();

            CodeDateDalProcess codeDateDalProcess = new CodeDateDalProcess();
            codeDateDalProcess.Code = ((ForgotPasswordBizProcess)param).Code;

            CodeDateDalFetch codeDateDalFetch = new CodeDateDalFetch();
            codeDateDalFetch.JoinTransaction(transsaction);

            if ((DateTime.Now - Convert.ToDateTime(codeDateDalFetch.ScalarExecuteLogic(codeDateDalProcess))).Ticks < TimeSpan.FromHours(24).Ticks)
            {
                RechangePasswordDalProcess udiParam = new RechangePasswordDalProcess();
                udiParam.UserName = ((ForgotPasswordBizProcess)param).UserName;
                udiParam.Password = ((ForgotPasswordBizProcess)param).Password;

                RechangePasswordDalFetch fetch = new RechangePasswordDalFetch();
                fetch.JoinTransaction(transsaction);
                int changCount = fetch.UDIExecuteLogic(udiParam);

                if (changCount != 1)
                {
                    result.Result = false;
                }
                else
                {
                    result.Result = true;
                }
            }
            else
            {
                result.Result = false;
            }

            DeleteCodeDalProcess deleteCodeDalProcess = new DeleteCodeDalProcess();
            deleteCodeDalProcess.Code = ((ForgotPasswordBizProcess)param).Code;

            DeleteCodeDalFetch deleteCodeDalFetch = new DeleteCodeDalFetch();
            deleteCodeDalFetch.JoinTransaction(transsaction);
            deleteCodeDalFetch.UDIExecuteLogic(deleteCodeDalProcess);

            transsaction.Commit();

            return result;
        }
    }
}
