﻿
using ZXR.Core;
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;

using CAUtility.Dal.UserInfo;

namespace CAUtility.Logic.UserInfo
{

    public class InsertUserBizLogic : BizLogic
    {

        public InsertUserBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            UserExistCheckDalProcess userExistChectParam = new UserExistCheckDalProcess();
            userExistChectParam.UserName = ((InsertUserBizProcess)param).UserName;

            UserExistCheckDalFetch checkFetch = new UserExistCheckDalFetch ();
            object isExistResult = checkFetch.ScalarExecuteLogic(userExistChectParam);
            if (isExistResult !=null )
            {

                return new BizResult() { Result = false };
            }
            else
            {
                InsertUserDalProcess udiParam = new InsertUserDalProcess();
                udiParam.Password = ((InsertUserBizProcess)param).Password;
                udiParam.FriendlyName = ((InsertUserBizProcess)param).FriendlyName;
                udiParam.UserName = ((InsertUserBizProcess)param).UserName;
                udiParam.UserGroup = ((InsertUserBizProcess)param).UserGroup;

                InsertUserDalFetch fetch = new InsertUserDalFetch();
                if (this.ZxrTransaction != null)
                {
                    fetch.JoinTransaction(this.ZxrTransaction);
                }
                fetch.UDIExecuteLogic(udiParam);

                return new BizResult() { Result = true };
            }
        }
    }
}
