﻿
using ZXR.Security;
using ZXR.BusinessLogic;
using ZXR.DataAccess;

using CAUtility.Dal.UserInfo;

namespace CAUtility.Logic.UserInfo
{

    
    public class UserListBizLogic : BizLogic
    {

        public UserListBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            this.ZxrTransaction = new ZXR.DataAccess.ZxrTransaction();
            UserListBizResult result = new UserListBizResult();

            UserListDalProcess listUserParam = new UserListDalProcess();
            listUserParam.PageIndex = ((UserListBizProcess)param).PageIndex;
            listUserParam.OnePageMaxItemsCount = ((UserListBizProcess)param).OnePageMaxItemsCount;

            DalSelectFetch listUserFetch = new UserListDalFetch();
            listUserFetch.JoinTransaction(this.ZxrTransaction);
            UserListDalResult listUserResult = (UserListDalResult)listUserFetch.SelectExecuteLogic(listUserParam);

            foreach (UserListDalResultElement ele in listUserResult)
            {
                UserListBizResultElement element = new UserListBizResultElement();
                element.UserName = ele.UserName;
                element.UserGroupID = ele.UserGroupID;
                element.UserGroupName = ele.UserGroupName;
                element.UserLevel = ele.UserLevel;
                element.FriendlyName = ele.FriendlyName;

                result.DataList.Add(element);
            }

            CountUsersDalFetch countUserFetch = new CountUsersDalFetch();
            countUserFetch.JoinTransaction(this.ZxrTransaction);
            result.TotalUserCount = System.Convert.ToInt32(countUserFetch.ScalarExecuteLogic(null));

            this.ZxrTransaction.Commit();
            
            return result;
        }
    }
}
