﻿
using ZXR.Security;
using ZXR.BusinessLogic;

using CAUtility.Dal.UserInfo;

namespace CAUtility.Logic.UserInfo
{

    public class ValidationUserBizLogic : BizLogic
    {

        public ValidationUserBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            this.ZxrTransaction = new ZXR.DataAccess.ZxrTransaction();

            ValidationUserBizResult result = new ValidationUserBizResult();

            VaildationUserDalProcess vaildateParam = new VaildationUserDalProcess();
            vaildateParam.UserName = ((ValidationUserBizProcess)param).UserName;

            VaildationUserDalFetch fetch = new VaildationUserDalFetch();
            fetch.JoinTransaction(this.ZxrTransaction);

            VaildationUserDalResult vaildateResult = (VaildationUserDalResult)fetch.SelectExecuteLogic(vaildateParam);

            if (string.IsNullOrEmpty(vaildateResult.Password) && string.IsNullOrEmpty(vaildateResult.UserToken))
            {
                result.Result = false;
                result.UserGroup = -1;

                this.ZxrTransaction.Commit();
                return result;
            }

            if (string.Equals(vaildateResult.UserToken, ((ValidationUserBizProcess)param).UserToken))
            {
                result.Result = true;
                result.UserGroup = vaildateResult.UserGroup;
                result.FriendlyName = vaildateResult.FriendlyName;
                result.LastChangePasswordDate = vaildateResult.LastChangePasswordDate;

                this.ZxrTransaction.Commit();
                return result;
            }

            if (string.Equals(vaildateResult.Password, ((ValidationUserBizProcess)param).Password))
            {

                string userToken = System.Guid.NewGuid().ToString("N");

                UpdateUserTokenDalProcess updateTokenParam = new UpdateUserTokenDalProcess();
                updateTokenParam.UserName = ((ValidationUserBizProcess)param).UserName;
                updateTokenParam.UserToken = userToken;

                UpdateUserTokenDalFetch updateTokenFetch = new UpdateUserTokenDalFetch();
                updateTokenFetch.JoinTransaction(this.ZxrTransaction);
                updateTokenFetch.UDIExecuteLogic(updateTokenParam);

                result.Result = true;
                result.UserGroup = vaildateResult.UserGroup;
                result.FriendlyName = vaildateResult.FriendlyName;
                result.LastChangePasswordDate = vaildateResult.LastChangePasswordDate;
                result.UserToken = userToken;

                this.ZxrTransaction.Commit();

                return result;
            }

            result.Result = false;
            result.UserGroup = -1;

            this.ZxrTransaction.Commit();

            return result;
        }
    }
}
