﻿
using ZXR.Net;
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;
using System;
using System.Collections.Generic;

using ZXR.Core;
using ZXR.Log;
using CAUtility.Dal.UserShoppingInfo;

namespace CAUtility.Logic.UserShoppingInfo
{

    
    public class AllMemberMailBizLogic : BizLogic
    {

        public AllMemberMailBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            BizResult result = new BizResult();

            DalSelectFetch fetch = new AllMemberMailDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            AllMemberMailDalResult fetchResult = (AllMemberMailDalResult)fetch.SelectExecuteLogic(null);

            try
            {
                Mail mail = new Mail();
                mail.SmtpServerAddress = CaSettings.MailSmtpServerName;
                mail.SmtpServerPort = Convert.ToInt32(CaSettings.MailSmtpServerPort);
                mail.SmtpServerUserName = CaSettings.MailSmtpUsername;
                mail.SmtpServerPassword = CaSettings.MailSmtpPs;

                List<string> bccList = new List<string>();
                foreach (AllMemberMailDalResultElement ele in fetchResult)
                {
                    bccList.Add(DesCryptogram.Decrypt(ele.PcMailAddress));
                }

                mail.ConnectServer();

                mail.SendMail(
                    CaSettings.AdminEmail,
                    CaSettings.AdminEmail,
                    bccList,
                    ((AllMemberMailBizProcess)param).MailTitle,
                    ((AllMemberMailBizProcess)param).MailContent
                    );

                result.Result = true;
            }
            catch (Exception ex)
            {
                Logger.Error("メンバー全員への送信が失敗しました。", ex);
                result.Result = false;
                result.ResultData = ex.Message;
            }

            return result;
        }
    }
}
