﻿
using ZXR.BusinessLogic;
using ZXR.DataAccess;
using ZXR.Security;

using CAUtility.Dal.UserShoppingInfo;

namespace CAUtility.Logic.UserShoppingInfo
{

    public class GetUserDetailsBizLogic : BizLogic
    {

        public GetUserDetailsBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            GetUserDetailsBizResult result = new GetUserDetailsBizResult();

            GetUserDetailsDalProcess getParam = new GetUserDetailsDalProcess();
            getParam.UserID = ((GetUserDetailsBizProcess)param).UserID;

            DalSelectFetch fetch = new GetUserDetailsDalFetch();
            if (this.ZxrTransaction != null)
            {
                fetch.JoinTransaction(this.ZxrTransaction);
            }
            GetUserDetailsDalResult fetchResult = (GetUserDetailsDalResult)fetch.SelectExecuteLogic(getParam);

            result.Address = DesCryptogram.Decrypt(fetchResult.Address);
            result.HomePhone = DesCryptogram.Decrypt(fetchResult.HomePhone);
            result.Mobile = DesCryptogram.Decrypt(fetchResult.Mobile);
            result.ZipCode = DesCryptogram.Decrypt(fetchResult.ZipCode);
            result.Simei = DesCryptogram.Decrypt(fetchResult.Simei);
            result.Furigana = DesCryptogram.Decrypt(fetchResult.Furigana);
            result.LoginType = DesCryptogram.Decrypt(fetchResult.LoginType);
            result.PCMail = DesCryptogram.Decrypt(fetchResult.PCMail);
            result.Birthday = fetchResult.Birthday;
            result.Sex = fetchResult.Sex;

            result.SecretQuestion = fetchResult.SecretQuestion;

            if (!string.IsNullOrEmpty(fetchResult.MobileMail))
                result.MobileMail = DesCryptogram.Decrypt(fetchResult.MobileMail);

            if (!string.IsNullOrEmpty(fetchResult.SecretAnswer))
                result.SecretAnswer = DesCryptogram.Decrypt(fetchResult.SecretAnswer);

            if (!string.IsNullOrEmpty(fetchResult.Company))
                result.Company = DesCryptogram.Decrypt(fetchResult.Company);

            if (!string.IsNullOrEmpty(fetchResult.OfficialPosition))
                result.OfficialPosition = DesCryptogram.Decrypt(fetchResult.OfficialPosition);

            if (!string.IsNullOrEmpty(fetchResult.Fax))
                result.Fax = DesCryptogram.Decrypt(fetchResult.Fax);

            return result;
        }
    }
}
