﻿
using ZXR.Security;
using ZXR.BusinessLogic;
using CAUtility.Dal.UserShoppingInfo;

namespace CAUtility.Logic.UserShoppingInfo
{

    public class UpdateUserDetailsBizLogic : BizLogic
    {

        public UpdateUserDetailsBizLogic()
        {

        }

        protected override BizResult BusinessLogicExecute(BizProcessParm param)
        {
            CheckUserDetailsExistDalProcess checkUserExistParam = new CheckUserDetailsExistDalProcess();
            checkUserExistParam.UserID = ((UpdateUserDetailsBizProcess)param).UserID;

            CheckUserDetailsExistDalFetch checkuserExistFetch = new CheckUserDetailsExistDalFetch();
            object isExistResult = checkuserExistFetch.ScalarExecuteLogic(checkUserExistParam);

            UpdateInsertUserDetailsDalProcess udiParam = new UpdateInsertUserDetailsDalProcess();
            udiParam.UserID = ((UpdateUserDetailsBizProcess)param).UserID;
            udiParam.HomePhone = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).HomePhone) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).HomePhone);
            udiParam.Mobile = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).Mobile) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).Mobile);
            udiParam.Address = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).Address) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).Address);
            udiParam.ZipCode = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).ZipCode) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).ZipCode);
            udiParam.CompanyName = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).CompanyName) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).CompanyName);
            udiParam.Fax = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).Fax) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).Fax);
            udiParam.LoginType = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).LoginType) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).LoginType);
            udiParam.OfficialPosition = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).OfficialPosition) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).OfficialPosition);
            udiParam.SecretAnswer = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).SecretAnswer) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).SecretAnswer);
            udiParam.SecretQuestion = ((UpdateUserDetailsBizProcess)param).SecretQuestion;
            udiParam.PcMail = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).PcMail) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).PcMail);
            udiParam.MobileMail = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).MobileMail) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).MobileMail);

            udiParam.Sex = ((UpdateUserDetailsBizProcess)param).Sex;

            udiParam.Simei = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).Simei) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).Simei);
            udiParam.Furikana = string.IsNullOrEmpty(((UpdateUserDetailsBizProcess)param).Furigana) ? "" : DesCryptogram.Encrypt(((UpdateUserDetailsBizProcess)param).Furigana);

            udiParam.Birthday = ((UpdateUserDetailsBizProcess)param).Birthday;

            if (System.Convert.ToInt32(isExistResult) != 0)
            {
                UpdateUserDetailsDalFetch fetch = new UpdateUserDetailsDalFetch();
                if (this.ZxrTransaction != null)
                {
                    fetch.JoinTransaction(this.ZxrTransaction);
                }
                fetch.UDIExecuteLogic(udiParam);

                return new BizResult() { Result = true };
            }
            else
            {
                InsertUserDetailsDalFetch insertFech = new InsertUserDetailsDalFetch();
                if (this.ZxrTransaction != null)
                {
                    insertFech.JoinTransaction(this.ZxrTransaction);
                }
                insertFech.UDIExecuteLogic(udiParam);

                return new BizResult() { Result = true };
            }
        }
    }
}
