﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web.UI;
using System.Web.UI.WebControls;
using ZXR.Web.Controls;
using ZXR.Core;
using CAUtility;
using CAUtility.Pages;

namespace CAUtility.Menu
{
    public class DynamicSiteMapPath : SiteMapPath
    {
        protected override void InitializeItem(SiteMapNodeItem item)
        {
            if (item.ItemType != SiteMapNodeItemType.PathSeparator)
            {
                string url = item.SiteMapNode.Url;
                string param = item.SiteMapNode["param"];

                string targetCuluture = string.Empty;
                if (!string.IsNullOrEmpty(param))
                {

                    targetCuluture = System.Web.HttpContext.Current.Request.QueryString[param];

                    if (ZXR.Core.Validate.ValidataRequired(System.Web.HttpContext.Current.Request.QueryString["TargetCulture"]) == false)
                        throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
                    else
                    {
                        if (SupportCulture.IsSupport(System.Web.HttpContext.Current.Request.QueryString["TargetCulture"]) == false)
                            throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
                    }
                }

                System.Web.UI.WebControls.HyperLink link = new System.Web.UI.WebControls.HyperLink();

                if (!string.IsNullOrEmpty(param))
                    link.NavigateUrl = url + "?" + param + "=" + targetCuluture;
                else
                    link.NavigateUrl = url;

                if (!string.IsNullOrEmpty(item.SiteMapNode["nolink"])
                    && string.Equals("true", item.SiteMapNode["nolink"].ToLower()))
                {
                    link.NavigateUrl = string.Empty;
                }

                link.Text = item.SiteMapNode.Title;

                item.Controls.Add(link);
            }
            else
            {

                base.InitializeItem(item);
            }
        }
    }
}
