﻿using System;
using ZXR.Core;
using ZXR.DataAccess;
using ZXR.BusinessLogic;

using CAUtility;
using CAUtility.Logic.NewsLetter.NewsTags;

namespace CAUtility.Menu
{
    public class NewsTagMenu
    {

        static NewsTagMenu()
        {
            string culture = SupportCulture.GetCultureFromUrl();
            MessageManager.CultureTarget = new System.Globalization.CultureInfo(culture);
        }

        public static string GetNewsTagMenu(string pageid, string currentPageTopPage_)
        {
            string newsList = string.Empty;

            ListTagsBizProcess param = new ListTagsBizProcess();

            ListTagsBizLogic logic = new ListTagsBizLogic();
            ListTagsBizResult result = (ListTagsBizResult)logic.Execute(param);

            string culture = SupportCulture.GetCultureFromUrl();
            if (string.IsNullOrEmpty(culture))
            {
                culture = CaSettings.AdminCulture;
            }

            newsList = "<ul>\r\n";

            foreach (ListTagsBizResultElement ele in result.DataList)
            {
                newsList += "  <li>\r\n";
                newsList += "     <a href=\"./News.aspx?NewsTagID=" + ele.TagID + "\">" + ele.TagName + "</a>";
                newsList += "  </li>\r\n";
            }
            newsList += "</table>\r\n";

            return newsList;
        }
    }
}
