﻿using ZXR.Core;

using CAUtility.Logic.ProductKinds;
using CAUtility.Logic.Products;

namespace CAUtility.Menu
{

    public class ProductInfoMenu
    {

        private static string productPageName_ = string.Empty;

        public static string ProductPageName
        {
            get { return MessageManager.GetValue(MessageKey.PageD0001); }
        }

        static ProductInfoMenu()
        {
        }

        public static void GetProductMenu()
        {
            System.Web.HttpContext.Current.Response.Write(GetProductMenuHtmlTag());
        }

        public static string GetProductMenuHtmlTag()
        {
            string productMenu = string.Empty;

            if (CaSettings.EnableProductInfo == false)
                return string.Empty;

            DisplayProductKindsListBizProcess param = new DisplayProductKindsListBizProcess();

            string culture = SupportCulture.GetCultureFromUrl();
            if (!string.IsNullOrEmpty(culture))
                param.Culture = culture;
            else
                param.Culture = CaSettings.PageDefaultCulture;

            DisplayProductKindsListBizLogic logic = new DisplayProductKindsListBizLogic();
            DisplayProductKindsListBizResult result = (DisplayProductKindsListBizResult)logic.Execute(param);

            if (result.DataList.Count > 1)
            {

                productMenu += "\r\n        <ul>";

                foreach (DisplayProductKindsListBizResultElement ele in result.DataList)
                {
                    productMenu += "\r\n            <li>";
                    productMenu += "<a href=\"ProductList.aspx?ProductKID=" + ele.ID + "\">" + ele.Name + "</a>";
                    productMenu += "</li>";
                }

                productMenu += "\r\n        </ul>\r\n";

            }

            return productMenu;
        }
    }
}
