﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Text.RegularExpressions;

namespace CAUtility.Plugin
{

    public class ContentConvertor
    {
        public ContentConvertor()
        {
        }

        private static Dictionary<int, string> pluginInf_ = new Dictionary<int, string>();

        public List<System.Web.UI.Control> DynamicSideMenu(string input)
        {
            List<Type> pluginList_ = new List<Type>();

            if (CaContext.Current.PluginList.Count == 0)
            {
                return null;
            }
            List<System.Web.UI.Control> result = new List<System.Web.UI.Control>();

            foreach (string str in GetTargets(input))
            {
                bool hasMatch = false;
                foreach (Type plugin in CaContext.Current.SidePluginList)
                {
                    object target = plugin.InvokeMember(null,
                               BindingFlags.CreateInstance,
                               null,
                               null,
                               null);

                    string reginString = plugin.GetProperty("RegionString").GetValue(target, null).ToString();

                    Regex regex = new Regex(reginString);
                    Match match = regex.Match(str);
                    if (match.Success)
                    {
                        string temp = Regex.Replace(str, @"(.*)(\()(.*)(\))(.*)", "$3");
                        string[] param = ZXR.Core.StringUtility.SpiltString(temp, ",");

                        List<System.Web.UI.Control> ele = (List<System.Web.UI.Control>)plugin.InvokeMember("ConvertControls",
                            BindingFlags.InvokeMethod,
                            null,
                            target,
                            new object[] { param });

                        if (ele != null)
                            result.AddRange(ele);

                        hasMatch = true;

                        break;
                    }
                }

                if (hasMatch == false)
                    result.Add(new System.Web.UI.LiteralControl(str));

            }

            return result;
        }

        public List<System.Web.UI.Control> DynamicControl(string input)
        {
            List<Type> pluginList_ = new List<Type>();

            if (CaContext.Current.PluginList.Count == 0)
            {
                return null;
            }
            List<System.Web.UI.Control> result = new List<System.Web.UI.Control>();

            int plugIndexAtPage = 0;
            foreach (string str in GetTargets(input))
            {
                bool hasMatch = false;
                foreach (Type plugin in CaContext.Current.PluginList)
                {
                    object target = plugin.InvokeMember(null,
                               BindingFlags.CreateInstance,
                               null,
                               null,
                               null);

                    string reginString = plugin.GetProperty("RegionString").GetValue(target, null).ToString();

                    Regex regex = new Regex(reginString);
                    Match match = regex.Match(str);
                    if (match.Success)
                    {
                        string temp = Regex.Replace(str, @"(.*)(\()(.*)(\))(.*)", "$3");
                        string[] param = ZXR.Core.StringUtility.SpiltString(temp, ",");
                        
                        if (!(System.Web.HttpContext.Current.Handler as System.Web.UI.Page).IsPostBack)
                            pluginInf_[plugIndexAtPage] = System.Guid.NewGuid().ToString("N");

                        PropertyInfo clientIdProperty = plugin.GetProperty("ClientID");
                        if (clientIdProperty != null)
                        {
                            clientIdProperty.SetValue(target, pluginInf_[plugIndexAtPage], null);
                        }

                        List<System.Web.UI.Control> ele = (List<System.Web.UI.Control>)plugin.InvokeMember("ConvertControls",
                            BindingFlags.InvokeMethod,
                            null,
                            target,
                            new object[] { param });

                        if (ele != null)
                        {
                            result.AddRange(ele);
                        }

                        hasMatch = true;

                        break;
                    }
                }

                if (hasMatch == false)
                    result.Add(new System.Web.UI.LiteralControl(str));

                plugIndexAtPage++;
            }

            return result;
        }

        private List<string> targetLists_ = new List<string>();

        public List<string> GetTargets(string contents)
        {
            string[] parts = Microsoft.VisualBasic.Strings.Split(contents, "++", -1, Microsoft.VisualBasic.CompareMethod.Binary);

            List<string> result = new List<string>();
            result.AddRange(parts);
            return result;
        }

    }
}
