﻿using ZXR.Core;

namespace CAUtility.Plugin
{

    public class ContentPluginBase
    {

        public string ClientID
        {
            get;
            set;
        }

        public System.Web.UI.Page PageInstance
        {
            get
            {
                return System.Web.HttpContext.Current.Handler as System.Web.UI.Page;
            }
        }

        public System.Web.UI.MasterPage ContentPageMasterPage
        {
            get
            {
                if (this.PageInstance == null)
                    return null;

                return this.PageInstance.Master;
            }
        }

        public System.Web.UI.MasterPage SiteMasterPage
        {
            get
            {
                if (this.ContentPageMasterPage == null)
                    return null;

                return this.ContentPageMasterPage.Master;
            }
        }

        public System.Web.UI.WebControls.ContentPlaceHolder PagePlaceHolder
        {
            get
            {
                 if (this.SiteMasterPage == null)
                    return null;

                 return this.SiteMasterPage.FindControl("CommonMasterPageMain") as System.Web.UI.WebControls.ContentPlaceHolder;
            }
        }

        public System.Web.UI.WebControls.ContentPlaceHolder ContentPlaceHolder
        {
            get
            {
                if (this.PagePlaceHolder == null)
                    return null;

                System.Web.UI.Control control = this.PagePlaceHolder.FindControl("CommonMasterPage");

                if (control != null)
                    control = control.FindControl("ContentPlaceHolderCommonMasterPage");
                else
                    return null;

                return control as System.Web.UI.WebControls.ContentPlaceHolder;
            }
        }

      
        public System.Web.UI.WebControls.PlaceHolder ContentControl
        {
            get
            {
                if (this.SiteMasterPage == null)
                    return null;

                System.Web.UI.Control control = this.ContentPlaceHolder.FindControl("PlaceHolderMainContent");

                return control as System.Web.UI.WebControls.PlaceHolder;

             }
        }

        public ZXR.Web.Controls.PageDivider PageDividerControl
        {
            get
            {
                if (this.SiteMasterPage == null)
                    return null;

                System.Web.UI.Control control = this.ContentPlaceHolder.FindControl("PageDivider1");

                return control as ZXR.Web.Controls.PageDivider;
            }
        }

        public int CurrentPageIndex
        {
            get
            {
                if (ZXR.Core.Validate.ValidateInteger(System.Web.HttpContext.Current.Request.QueryString["Page"], true) == false)
                    throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
                else
                    return System.Convert.ToInt32(System.Web.HttpContext.Current.Request.QueryString["Page"]);
            }
        }

        public int CurrentPageID
        {
            get
            {
                if (ZXR.Core.Validate.ValidateInteger(System.Web.HttpContext.Current.Request.QueryString["PageId"], true) == false)
                    throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
                else
                    return System.Convert.ToInt32(System.Web.HttpContext.Current.Request.QueryString["PageId"]);
            }
        }
    }
}
