﻿using System;
using System.Collections.Generic;

using ZXR.Net;
using ZXR.Core;
using ZXR.Log;

namespace CAUtility.Utility
{
    public class MailUtil
    {
        Mail mail_ = new Mail();

        public MailUtil()
        {
            try
            {
                mail_.SmtpServerAddress = CaSettings.MailSmtpServerName;
                mail_.SmtpServerPort = Convert.ToInt32(CaSettings.MailSmtpServerPort);
                mail_.SmtpServerUserName = CaSettings.MailSmtpUsername;
                mail_.SmtpServerPassword = CaSettings.MailSmtpPs;

                mail_.ConnectServer();
            }
            catch (Exception ex)
            {
                Logger.Error("メール機構の初期化にエラーが発生", ex);
            }
        }

        public void SendErrorMail(string title, string content)
        {
            try
            {
                mail_.SendMail(CaSettings.AdminEmail,
                                  CaSettings.AdminEmail,
                                  title,
                                  content
                                  );
            }
            catch (Exception ex)
            {
                Logger.Error("メールの送信にエラーが発生", ex);
            }
        }

        public void SendMailToMember(string to, string title, string contents)
        {
            try
            {
                mail_.SendMail(
                      to,
                      CaSettings.AdminEmail,
                      title,
                      contents
                      );
            }
            catch (Exception ex)
            {
                Logger.Error("メールの送信にエラーが発生", ex);
            }
        }

        public void SendMail(string title, string contents)
        {
            try
            {
                List<string> bccList = SettingManager.GetListValue("MessageNotfytargetList");

                mail_.SendMail(
                    CaSettings.AdminEmail,
                    CaSettings.AdminEmail,
                    bccList,
                    title,
                    contents
                    );

            }
            catch (Exception ex)
            {
                Logger.Error("メールの送信にエラーが発生", ex);
            }
        }

    }
}
