﻿using System;
using System.Runtime.Serialization;
using System.ServiceModel.DomainServices.Client.ApplicationServices;
using System.Windows;
using System.Windows.Controls;
using CaManager.Controls;
using SilverlightFramework;

namespace CaManager
{

    public partial class App : Application
    {
        private BusyIndicator busyIndicator;

        public App()
        {
            InitializeComponent();
        }

        private void Application_Startup(object sender, StartupEventArgs e)
        {

            this.InitializeRootVisual();
        }

        private void Application_UserLoaded(LoadUserOperation operation)
        {
        }

        protected virtual void InitializeRootVisual()
        {
            this.busyIndicator = new BusyIndicator();
            this.busyIndicator.Content = new MainPage();
            this.busyIndicator.HorizontalContentAlignment = HorizontalAlignment.Stretch;
            this.busyIndicator.VerticalContentAlignment = VerticalAlignment.Stretch;
            this.busyIndicator.Background = new System.Windows.Media.SolidColorBrush(SystemColors.ControlDarkColor);

            this.RootVisual = this.busyIndicator;
        }

        private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
        {

            if (!System.Diagnostics.Debugger.IsAttached)
            {

                e.Handled = true;
                ErrorWindow.CreateNew(e.ExceptionObject);
            }
        }
    }
}