﻿namespace CaManager
{
    using System;
    using System.Windows.Data;

    public class StringFormatValueConverter : IValueConverter
    {
        private readonly string formatString;

        public StringFormatValueConverter(string formatString)
        {
            this.formatString = formatString;
        }

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return string.Format(System.Globalization.CultureInfo.CurrentUICulture, this.formatString, value);
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotSupportedException();
        }
    }
}
