﻿using System.Windows;
using System.Reflection;
using System.Windows.Controls;
using System.Windows.Navigation;
using System.Windows.Input;

using CaManager.Models;
using SilverlightFramework.Core;
using SilverlightFramework;
using CaManager.ServiceReference;

namespace CaManager.Views
{

    public partial class Home : Page
    {
        private LoginInfo loginInfo = new LoginInfo();

        public Home()
        {
            InitializeComponent();

            this.Title = Assets.Resources.MainPage.ID001;
            this.DataContext = this.loginInfo;
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private void buttonLogin_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            (Application.Current.RootVisual as CaManager.Controls.BusyIndicator).BusyContent = CaManager.Assets.Resources.View.Home.ID005;
            (Application.Current.RootVisual as CaManager.Controls.BusyIndicator).IsBusy = true;

            if (this.loginForm.ValidateItem() == false)
            {
                (Application.Current.RootVisual as CaManager.Controls.BusyIndicator).IsBusy = false;
                return;
            }

            WebServiceSoapClient client = ServiceContext.Current.GetClient();
            client.LoginCompleted += new System.EventHandler<LoginCompletedEventArgs>(client_LoginCompleted);
            client.LoginAsync(this.loginInfo.UserName, this.loginInfo.Password);
        }

        private void client_LoginCompleted(object sender, LoginCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                WebContext.Current.UserName = this.loginInfo.UserName;
                WebContext.Current.IsAuthenticated = true;
                WebContext.Current.UserToken = e.Result.UserToken;

                this.NavigationService.Navigate(new System.Uri("/MessageCenter", System.UriKind.Relative));
            }
            else
            {

            }
            (Application.Current.RootVisual as CaManager.Controls.BusyIndicator).IsBusy = false;
        }

        private void loginForm_AutoGeneratingField(object sender, DataFormAutoGeneratingFieldEventArgs e)
        {

            PropertyInfo propertyInfo = this.loginForm.CurrentItem.GetType().GetProperty(e.PropertyName);

            if (e.Field.Content is TextBox && this.IsPasswordProperty(propertyInfo))
            {
                e.Field.ReplaceTextBox(new PasswordBox(), PasswordBox.PasswordProperty);
            }
        }

        protected virtual bool IsPasswordProperty(PropertyInfo propertyInfo)
        {

            return propertyInfo.Name.IndexOf("Password") != -1;
        }

        private void loginForm_KeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {
            if (e.Key == Key.Escape)
            {
                this.loginForm.CommitEdit();
            }
            else if (e.Key == Key.Enter && this.buttonLogin.IsEnabled)
            {
                this.buttonLogin_Click(sender, e);
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            WebServiceSoapClient client = ServiceContext.Current.GetClient();
            client.GetTestCompleted +=new System.EventHandler<GetTestCompletedEventArgs>(client_GetTestCompleted);
            client.GetTestAsync();
        }

         private void client_GetTestCompleted(object sender, GetTestCompletedEventArgs e)
         {

         }
    }
}