﻿using System;

using ZXR.Core;
using ZXR.Web.Controls;
using CAUtility.Pages;

namespace WebApplication.Admin
{
    public partial class AdminPage : SecurityPage
    {
        void Page_PreInit(object sender, EventArgs e)
        {
        }

        protected void Page_Load(object sender, EventArgs e)
        {

            this.DisplayLabelSysInfo.Text = "<br />";
            this.DisplayLabelSysInfo.Text += "現在のCAシステムバージョンは：" + GetVersion() + "<br />";
            this.DisplayLabelSysInfo.Text += "サーバー上の物理パスは：<br />" + GetServerPath();
            this.DisplayLabelSysInfo.Text += "<br />";
            this.DisplayLabelSysInfo.Text += "データキャッシュ時間は：" + CoreSettings.DataCacheTime.ToString() + "分";
            this.DisplayLabelSysInfo.Text += "<br />";
        }

        private string GetVersion()
        {
            System.Reflection.Assembly asm = System.Reflection.Assembly.GetExecutingAssembly(); 
            System.Version ver = asm.GetName().Version;

            return ver.ToString();
        }

        private string GetServerPath()
        {
            return AppDomain.CurrentDomain.BaseDirectory;
        }
        
    }
}
