﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;

using ZXR.Core;
using ZXR.Web;
using ZXR.Web.Controls;
using ZXR.BusinessLogic;

using CAUtility.Logic.BBS;
using CAUtility;
using CAUtility.Pages;
namespace WebApplication.Admin.BBS
{
    public partial class BBSManager : SecurityPage
    {
        private const string ForumPrefix = "Forum";

        private const string BlogPrefix = "Blog";

        private const string TransitionDefinition_OperationResult = "BBSManager.aspx";

        protected void Page_Init(object sender, EventArgs e)
        {
            initInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            initPage();
        }

        private void initInterface()
        {
            this.ButtonAdd.Text = MessageManager.GetValue(MessageKey.AdminD0165);
        }

        private void initPage()
        {
            ListForumBizLogic logic = new ListForumBizLogic();
            ListForumBizResult result = (ListForumBizResult)logic.Execute(null);

            this.MenuTable.InitTable(MenuTableDisplayType.RowDisplay);
            this.MenuTable.RowCount = result.DataList.Count + 1;
            this.MenuTable.TurnBackNumber = 4;
            this.MenuTable.CssClass = "AdminTable";

            if (result.DataList.Count > 0)
            {
                this.MenuTable.AddContex(MessageManager.GetValue(MessageKey.AdminD0166));
                this.MenuTable.AddContex(MessageManager.GetValue(MessageKey.AdminD0179));
                this.MenuTable.AddContex(MessageManager.GetValue(MessageKey.AdminD0073));
                this.MenuTable.AddContex(MessageManager.GetValue(MessageKey.AdminD0073));
            }

            int rowIndex = 1;
            foreach (ListForumBizResultElement ele in result.DataList)
            {
                Label LabelName = new Label();
                LabelName.Text = ele.ForumName;
                this.MenuTable.AddControl(LabelName);

                Label codeLabel = new Label();
                codeLabel.Text = "++" + ForumPrefix + "(" + ele.ID + ")++<br />++" + BlogPrefix + "(" + ele.ID + ")++";
                this.MenuTable.AddControl(codeLabel);

                ValidatorButton updateButton = new ValidatorButton();
                updateButton.UserDatas["TagID"] = ele.ID.ToString();
                updateButton.UserDatas["RowIndex"] = rowIndex.ToString();
                updateButton.Text = MessageManager.GetValue(MessageKey.AdminD0008);
                updateButton.Click += new EventHandler(updateButton_Click);
                this.MenuTable.AddControl(updateButton);

                ValidatorButton delButton = new ValidatorButton();
                delButton.UserDatas["TagID"] = ele.ID.ToString();
                delButton.ConfirmMessage = MessageManager.GetValue(MessageKey.AdminD0037);
                delButton.Text = MessageManager.GetValue(MessageKey.AdminD0031);
                delButton.Click += new EventHandler(delButton_Click);
                this.MenuTable.AddControl(delButton);

                rowIndex++;
            }
            this.MenuTable.Flush();
        }

        void updateButton_Click(object sender, EventArgs e)
        {
            Response.Redirect("BbsEdit.aspx?BbsID=" + ((ValidatorButton)sender).UserDatas["TagID"]);
        }

        void delButton_Click(object sender, EventArgs e)
        {
            DeleteForumBizProcess param = new DeleteForumBizProcess();
            param.ID = ((ValidatorButton)sender).UserDatas["TagID"];

            DeleteForumBizLogic logic = new DeleteForumBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result == true)
            {
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030), TransitionDefinition_OperationResult);
            }
        }

        protected void ButtonAdd_Click(object sender, EventArgs e)
        {
            Response.Redirect("BbsEdit.aspx");
        }
    }
}