﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;

using ZXR.Core;
using ZXR.Web;
using ZXR.Web.Controls;
using ZXR.BusinessLogic;

using CAUtility.Logic.BBS;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Admin.BBS
{
    public partial class BbsEdit : SecurityPage
    {

        private const string TransitionDefinition_OperationResult = "BBSManager.aspx";

        private int QueryString_BBSId = 0;

        protected void Page_Init(object sender, EventArgs e)
        {
            initInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            initQueryString();
            initPage();
        }

        private void initInterface()
        {
            this.LabelName.Text = MessageManager.GetValue(MessageKey.AdminD0166);
        }

        private void initPage()
        {
            if (QueryString_BBSId != 0 && !IsPostBack)
            {
                SingleForunInfoBizProcess param = new SingleForunInfoBizProcess();
                param.ID = Convert.ToInt32(QueryString_BBSId);

                SingleForunInfoBizLogic logic = new SingleForunInfoBizLogic();
                SingleForunInfoBizResult result = (SingleForunInfoBizResult)logic.Execute(param);

                this.TextBoxBbsName.Text = result.ForumName;
                this.ButtonInsert.Text = MessageManager.GetValue(MessageKey.AdminD0072);
            }
            else
            {
                this.ButtonInsert.Text = MessageManager.GetValue(MessageKey.AdminD0036);
            }
        }

        private void initQueryString()
        {
            if (ZXR.Core.Validate.ValidateInteger(Request.QueryString["BbsID"], true) == false)
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
                QueryString_BBSId = Convert.ToInt32(Request.QueryString["BbsID"]);
        }

        protected void ButtonInsert_Click(object sender, EventArgs e)
        {
            if (QueryString_BBSId != 0)
            {
                UpdateForumInfoBizProcess param = new UpdateForumInfoBizProcess();
                param.ForumName = this.TextBoxBbsName.Text;
                param.ID = QueryString_BBSId;

                UpdateForumInfoBizLogic logic = new UpdateForumInfoBizLogic();
                BizResult result = logic.Execute(param);

                if (result.Result)
                {
                    WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030), TransitionDefinition_OperationResult);
                }
            }
            else
            {
                InsertForumBizProcess param = new InsertForumBizProcess();
                param.ForumName = this.TextBoxBbsName.Text;

                InsertForumBizLogic logic = new InsertForumBizLogic();
                BizResult result = logic.Execute(param);

                if (result.Result)
                {
                    WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030), TransitionDefinition_OperationResult);
                }
            }
        }
    }
}