﻿using System;
using ZXR.Core;
using ZXR.Web;
using ZXR.Web.Controls;
using ZXR.BusinessLogic;

using CAUtility.Logic.BBS;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Admin.BBS
{
    public partial class BbsSettings : SecurityPage
    {

        private const string TransitionDefinition_OperationResult = "BbsSettings.aspx";

        protected void Page_Init(object sender, EventArgs e)
        {
            initInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                this.TextBoxPageSize.Text = CaSettings.ForumPageSize.ToString();

                if (CaSettings.IsBBsUseVerifyImage)
                    this.RadioButtonYes.Checked = true;
                else
                    this.RadioButtonNo.Checked = true;
            }
        }

        private void initInterface()
        {
            this.LabelPageSize.Text = MessageManager.GetValue(MessageKey.AdminD0172);
            this.ButtonSetup.Text = MessageManager.GetValue(MessageKey.AdminD0072);
            this.LabelVerifyImage.Text = MessageManager.GetValue(MessageKey.AdminD0191);
        }

        protected void ButtonSetup_Click(object sender, EventArgs e)
        {
            BbsConfigBizProcess param = new BbsConfigBizProcess();
            param.OnePageMaxItemsCount = Convert.ToInt32(this.TextBoxPageSize.Text);
            param.IsBBsUseVerifyImage = this.RadioButtonYes.Checked;

            BbsConfigBizLogic logic = new BbsConfigBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result)
            {
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030), TransitionDefinition_OperationResult);
            }
        }
    }
}