﻿using System;

using ZXR.Core;
using ZXR.Web;

using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Admin
{

    public partial class AdminHead : MasterPage
    {

        private const string TransitionDefinition_Postback = "../Default.aspx";

        private const string UserInfoCookieName = "UserInfo";

        protected void Page_Init(object sender, EventArgs e)
        {
            InitInterface();
        }

        private void InitInterface()
        {
            string adminCulture = CoreSettings.CoreCulture;
            MessageManager.CultureTarget = new System.Globalization.CultureInfo(adminCulture);

            SiteMapPathAdminPage.SiteMapProvider = adminCulture + CaConstant.SiteMapProvider;

            this.Page.Title = MessageManager.GetValue(MessageKey.AdminD0137);

            this.CustomLinkButtonLogout.Text = MessageManager.GetValue(MessageKey.UserLoginS0006);
            this.HyperLinkCompanyInfoEditor.Text = MessageManager.GetValue(MessageKey.AdminD0004);
            this.HyperLinkProductEditor.Text = MessageManager.GetValue(MessageKey.AdminD0005);

            this.CustomHyperLinkHighLevelSetting.Text = MessageManager.GetValue(MessageKey.AdminD0062);
            this.CustomHyperLinkSettings.Text = MessageManager.GetValue(MessageKey.AdminD0060);
            this.CustomHyperLinkBackup.Text = MessageManager.GetValue(MessageKey.AdminD0063);
            this.DisplayLabel2.Text = MessageManager.GetValue(MessageKey.AdminD0064);
            this.DisplayLabel1.Text = MessageManager.GetValue(MessageKey.AdminD0065);
            this.CustomHyperLinkUserManager.Text = MessageManager.GetValue(MessageKey.AdminD0162);
            this.DisplayLabelSystem.Text = MessageManager.GetValue(MessageKey.AdminD0082);
            this.CustomHyperLinkMail.Text = MessageManager.GetValue(MessageKey.AdminD0089);
            this.CustomHyperLinkCultureManagement.Text = MessageManager.GetValue(MessageKey.AdminD0084);
            this.HyperLinkReservation.Text = MessageManager.GetValue(MessageKey.AdminD0136);
            this.HyperLinkBBS.Text = MessageManager.GetValue(MessageKey.AdminD0164);

            this.HyperLinkNews.Text = MessageManager.GetValue(MessageKey.AdminD0138);
            this.HyperLinkPageFooter.Text = MessageManager.GetValue(MessageKey.AdminD0140);
            this.HyperLinkQuann.Text = MessageManager.GetValue(MessageKey.AdminD0142);

            CAUtility.Plugin.PluginMenu pm = new CAUtility.Plugin.PluginMenu ();
            this.LabelPlugMenu.Text = pm.GetPluginMenu();
        }

        protected void CustomLinkButtonLogout_Click(object sender, EventArgs e)
        {
            Session.Abandon();
            CookieManager.CookieDiscard(UserInfoCookieName);
            Response.Redirect(TransitionDefinition_Postback);
        }
    }
}
