﻿using System;

using ZXR.BusinessLogic;
using ZXR.Core;
using ZXR.Web.Controls;

using CAUtility;
using CAUtility.Logic.NewsLetter.News;
using CAUtility.Pages;

namespace WebApplication.Admin.NewsLetter
{
    public partial class NewsSettings : SecurityPage
    {

        private const string TransitionDefinition_OperationResult = "Default.aspx";

        protected void Page_Init(object sender, EventArgs e)
        {
            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                InitPage();
            }
        }

        private void InitInterface()
        {
            this.LabelNewsCountInPage.Text = MessageManager.GetValue(MessageKey.AdminD0152);
            this.ButtonSetting.Text = MessageManager.GetValue(MessageKey.AdminD0072);
        }
        

        private void InitPage()
        {
            this.TextBoxNewsCountInPage.Text = CaSettings.NewsCountInPage.ToString();
        }

        protected void ButtonSetting_Click(object sender, EventArgs e)
        {
            NewsSettingBizProcess param = new NewsSettingBizProcess();
            param.NewsCountInPage = Int32.Parse(this.TextBoxNewsCountInPage.Text);

            NewsSettingBizLogic logic = new NewsSettingBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result)
            {
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030), TransitionDefinition_OperationResult);
            }
        }

    }
}
