﻿using System;

using ZXR.Core;
using ZXR.Web;

using ZXR.Web.Controls;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Admin.PageFooter
{

    public partial class Default : SecurityPage
    {

        private const string TransitionDefinition_Postback = "PageFooterEditor.aspx";

        protected void Page_Init(object sender, EventArgs e)
        {
            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                SupportCulture.Init();
                this.MenuTable1.InitTable(MenuTableDisplayType.RowDisplay);
                this.MenuTable1.TurnBackNumber = 10;
                this.MenuTable1.RowCount = (SupportCulture.LanguageList.Count / this.MenuTable1.TurnBackNumber) + 1;

                foreach (string culture in SupportCulture.LanguageList)
                {
                    HyperLink hl = new HyperLink();
                    hl.Text = SupportCulture.ConvertCodeToText(culture);
                    hl.NavigateUrl = TransitionDefinition_Postback + "?TargetCulture=" + culture;

                    this.MenuTable1.AddControl(hl);
                }

                this.MenuTable1.Flush();
            }
        }

        private void InitInterface()
        {
            this.DisplayLabel2.Text = MessageManager.GetValue(MessageKey.AdminD0012);
        }
    }
}
