﻿using System;
using ZXR.Web.Controls;
using ZXR.Core;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Admin.ProductInfo
{
    public partial class FunctionPage : SecurityPage
    {

        private string QueryString_TargetCulture = string.Empty;

        protected void Page_Init(object sender, EventArgs e)
        {
            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            initQueryString();

            this.HyperLinkClassifciationEditor.NavigateUrl = "ClassificationManager.aspx?TargetCulture=" + QueryString_TargetCulture;
            this.HyperLinkProductEdit.NavigateUrl = "ProductManager.aspx?TargetCulture=" + QueryString_TargetCulture;
            this.HyperLinkSetting.NavigateUrl = "ProductSettings.aspx?TargetCulture=" + QueryString_TargetCulture;
        }

        private void InitInterface()
        {
            this.HyperLinkClassifciationEditor.Text = MessageManager.GetValue(MessageKey.AdminD0014);
            this.HyperLinkProductEdit.Text = MessageManager.GetValue(MessageKey.AdminD0013);
            this.HyperLinkSetting.Text = MessageManager.GetValue(MessageKey.AdminD0103);
            this.HyperLinkShopping.Text = MessageManager.GetValue(MessageKey.AdminD0141);
        }

        private void initQueryString()
        {
            if (ZXR.Core.Validate.ValidataRequired(Request.QueryString["TargetCulture"]) == false)
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
            {
                QueryString_TargetCulture = Request.QueryString["TargetCulture"];

                if (SupportCulture.IsSupport(QueryString_TargetCulture) == false)
                    throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            }
        }
    }
}