﻿using System;
using System.Web.UI.WebControls;

using ZXR.Core;
using ZXR.BusinessLogic;
using ZXR.Web.Controls;

using CAUtility.Logic.QuestionnaireManager.Question;
using CAUtility.Logic.QuestionnaireManager.QuestionItem;
using CAUtility.Logic.QuestionnaireManager.Response;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Admin.Questionnaire
{

    public partial class QuestionnaireAnalysis : SecurityPage
    {

        private const string TransitionDefinition_OperationResult = "QuestionnaireAnalysis.aspx";

        protected void Page_Init(object sender, EventArgs e)
        {
            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(CaSession.QuestionnaireID))
            {
                QuestionnaireAnaysis(CaSession.QuestionnaireID);
            }
        }

        private void InitInterface()
        {
            this.DisplayLabelSessionList.Text = MessageManager.GetValue(MessageKey.AdminD0117);
        }

        private void QuestionnaireAnaysis(string questionnaireId)
        {
            ListQuestionBizProcess questionParam = new ListQuestionBizProcess();
            questionParam.QuestionnaireID = questionnaireId;

            ListQuestionBizLogic questionLogic = new ListQuestionBizLogic();
            ListQuestionBizResult questionResult = (ListQuestionBizResult)questionLogic.Execute(questionParam);

            this.MenuTableAnaysis.InitTable(MenuTableDisplayType.RowDisplay);
            this.MenuTableAnaysis.RowCount = questionResult.DataList.Count * 2 + 1;
            this.MenuTableAnaysis.TurnBackNumber = 1;
            this.MenuTableAnaysis.TextHorizontalAlign = HorizontalAlign.Left;
            this.MenuTableAnaysis.CssClass = "AdminTable";

            int questionIndex = 1;
            foreach (ListQuestionBizResultElement qEle in questionResult.DataList)
            {
                this.MenuTableAnaysis.AddContex(questionIndex.ToString() + " : " + qEle.Contents, "QuestionnaireTitle");
                if (string.Equals(qEle.QuestionType, "2"))//入力
                {
                    ListResponseItemBizProcess param = new ListResponseItemBizProcess();
                    param.QuestionnaireID = questionnaireId;
                    param.QuestionID = qEle.ID;

                    ListResponseItemBizLogic logic = new ListResponseItemBizLogic();
                    ListResponseItemBizResult result = (ListResponseItemBizResult)logic.Execute(param);

                    string inputContent = string.Empty;
                    foreach (ListResponseItemBizResultElement rEle in result.DataList)
                    {
                        inputContent += rEle.Content + "<br />";
                        inputContent += "--------------- <br />";
                    }

                    this.MenuTableAnaysis.AddContex(inputContent);
                }
                else
                {
                    ListQuestionItemBizProcess itemParam = new ListQuestionItemBizProcess();
                    itemParam.QuestionID = qEle.ID;

                    ListQuestionItemBizLogic itemLogic = new ListQuestionItemBizLogic();
                    ListQuestionItemBizResult itemResult = (ListQuestionItemBizResult)itemLogic.Execute(itemParam);

                    string questionItem = string.Empty;
                    foreach (ListQuestionItemBizResultElement iEle in itemResult.DataList)
                    {
                        ResponseCounterBizProcess rcParam = new ResponseCounterBizProcess();
                        rcParam.QuestionItemID = iEle.ID;
                        rcParam.QuestionnaireID = questionnaireId;

                        ResponseCounterBizLogic logic = new ResponseCounterBizLogic();
                        BizResult result = logic.Execute(rcParam);

                        questionItem += iEle.ItemContents + " : " + result.ResultData.ToString() + "<br />";
                    }
                    this.MenuTableAnaysis.AddContex(questionItem);
                }

                questionIndex++;
            }

            this.MenuTableAnaysis.Flush();
        }

    

    }
}
