﻿using System;
using System.Web.UI.WebControls;

using ZXR.Core;
using ZXR.BusinessLogic;
using ZXR.Web.Controls;

using CAUtility.Logic.QuestionnaireManager.Response;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Admin.Questionnaire
{
    public partial class ResponseList : SecurityPage
    {

        private const string TransitionDefinition_OperationResult = "ResponseList.aspx";

        protected void Page_Init(object sender, EventArgs e)
        {
            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(CaSession.QuestionnaireID))
            {
                InitSessionList(CaSession.QuestionnaireID);
            }

            this.HyperLinkAnaysis.NavigateUrl = "QuestionnaireAnalysis.aspx";
        }

        private void InitInterface()
        {
            this.DisplayLabelSessionList.Text = MessageManager.GetValue(MessageKey.AdminD0117);
            this.HyperLinkAnaysis.Text = MessageManager.GetValue(MessageKey.AdminD0171);
        }

        private void InitSessionList(string questionnaireId)
        {
            ListSessionBizProcess param = new ListSessionBizProcess();
            param.QuestionnaireID = questionnaireId;

            ListSessionBizLogic logic = new ListSessionBizLogic();
            ListSessionBizResult result = (ListSessionBizResult)logic.Execute(param);

            this.DisplayLabelSessionList.Text += MessageManager.GetValue(MessageKey.AdminD0129, result.DataList.Count.ToString());

            if (!IsPostBack)
            {
                this.ZxrGridView1.PageSize = 15;
                this.ZxrGridView1.DataSource = result.DataList;
                this.ZxrGridView1.DataBind();
            }
        }

        void ZxrGridView1_OperationButtonClick(object sender, EventArgs e)
        {
           
        }

        void ZxrGridView1_RowSelected(object sender, EventArgs e)
        {
            Response.Redirect("~/Admin/Questionnaire/ViewOneSession.aspx?SessionID=" + ((GridView)sender).SelectedRow.Cells[2].Text);
        }

        protected void ZxrGridView1_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            DeleteSessionResponseBizProcess param = new DeleteSessionResponseBizProcess();
            param.SessionID = this.ZxrGridView1.Rows[e.RowIndex].Cells[0].Text;

            DeleteSessionResponseBizLogic logic = new DeleteSessionResponseBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result == true)
            {
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030), TransitionDefinition_OperationResult);
            }
        }

        protected void ZxrGridView1_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {

        }

    }
}