﻿using System;

using ZXR.BusinessLogic;
using ZXR.Core;
using ZXR.Web.Controls;

using CAUtility;
using CAUtility.Pages;
using CAUtility.Logic.QuestionnaireManager;

namespace WebApplication.Admin.Questionnaire
{
    public partial class Settings : SecurityPage
    {

        private const string TransitionDefinition_OperationResult = "Settings.aspx";

        protected void Page_Init(object sender, EventArgs e)
        {
            initInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                if (CaSettings.IsFormUseVerifyImage)
                    this.RadioButtonYes.Checked = true;
                else
                    this.RadioButtonNo.Checked = true;
            }
        }

        private void initInterface()
        {
            this.LabelVerifyImage.Text = MessageManager.GetValue(MessageKey.AdminD0191);
            this.ButtonUpdate.Text = MessageManager.GetValue(MessageKey.AdminD0072);
        }

        protected void ButtonUpdate_Click(object sender, EventArgs e)
        {
            FormSettingBizProcess param = new FormSettingBizProcess();
            param.IsFormUseVerifyImage = this.RadioButtonYes.Checked;

            FormSettingBizLogic logic = new FormSettingBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result)
            {
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030), TransitionDefinition_OperationResult);
            }
        }
    }
}