﻿using System;
using System.Web.UI.WebControls;

using ZXR.Web.Controls;

using CAUtility.Logic.QuestionnaireManager.Question;
using CAUtility.Logic.QuestionnaireManager.Response;
using CAUtility.Pages;
using CAUtility;

namespace WebApplication.Admin.Questionnaire
{

    public partial class ViewOneSession : SecurityPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(Request.QueryString["SessionID"]) && !string.IsNullOrEmpty(CaSession.QuestionnaireID))
            {
                InitPage(CaSession.QuestionnaireID, Request.QueryString["SessionID"]);
            }
        }

        private void InitPage(string questionnaireId, string sessionid)
        {
            ListQuestionBizProcess questionParam = new ListQuestionBizProcess();
            questionParam.QuestionnaireID = questionnaireId;

            ListQuestionBizLogic questionLogic = new ListQuestionBizLogic();
            ListQuestionBizResult questionResult = (ListQuestionBizResult)questionLogic.Execute(questionParam);

            this.MenuTableOneSession.InitTable(MenuTableDisplayType.RowDisplay);
            this.MenuTableOneSession.RowCount = questionResult.DataList.Count * 2 + 1;
            this.MenuTableOneSession.TurnBackNumber = 1;
            this.MenuTableOneSession.TextHorizontalAlign = HorizontalAlign.Left;
            this.MenuTableOneSession.CssClass = "AdminTable";

            GetOneSessionBizProcess sessionParam = new GetOneSessionBizProcess();
            sessionParam.ResponseSession = sessionid;
            sessionParam.QuestionnaireID = questionnaireId;

            GetOneSessionBizLogic sessionLogic = new GetOneSessionBizLogic();
            GetOneSessionBizResult sessionResult = (GetOneSessionBizResult)sessionLogic.Execute(sessionParam);

            int questionIndex = 1;
            foreach (ListQuestionBizResultElement qEle in questionResult.DataList)
            {
                this.MenuTableOneSession.AddContex(questionIndex.ToString() + " : " + qEle.Contents, "QuestionnaireTitle");

                string inputContent = string.Empty;
                foreach (GetOneSessionBizResultElement sEle in sessionResult.DataList)
                {
                    if (string.Equals(qEle.ID, sEle.QuestionID))
                    {
                        if (string.Equals(qEle.QuestionType, "2"))
                        {
                            inputContent = sEle.ResponseContent;
                        }
                        else
                        {
                            inputContent += sEle.QuestionItemContent + "<br />";
                        }
                    }
                }
                this.MenuTableOneSession.AddContex(inputContent);

                questionIndex++;
            }

            this.MenuTableOneSession.Flush();
        }

    }
}
