﻿using System;
using System.Collections.Generic;

using ZXR.Core;
using ZXR.Web;
using ZXR.Web.Controls;
using ZXR.BusinessLogic;

using CAUtility;
using CAUtility.Logic.ReservationData;
using CAUtility.Pages;

namespace WebApplication.Admin.Reservation
{

    public partial class UpdateStatus : SecurityPage
    {

        private const string TransitionDefinition_OperationResult = "ReservationManager.aspx";

        private string QueryString_ID = string.Empty;

        private string QueryString_Status = string.Empty;

        protected void Page_Load(object sender, EventArgs e)
        {
            initQueryString();

            this.DropDownListStatus.AddItem("キャンセル", "Cancel");
            this.DropDownListStatus.AddItem("処理済み", "DummyDelete");
            this.DropDownListStatus.AddItem("未処理", "Normal");
            this.DropDownListStatus.AddItem("処理中", "Processing");

            if (!IsPostBack)
            {
                initPage();
            }
        }

        private void initPage()
        {

            AdminGetReservationBizProcess param = new AdminGetReservationBizProcess();
            param.ReservationNumber = QueryString_ID;

            AdminGetReservationBizLogic logic = new AdminGetReservationBizLogic();
            AdminGetReservationBizResult result = (AdminGetReservationBizResult)logic.Execute(param);

            this.LabelNumber.Text = result.ReservationNumber;
            this.LabelReservationDate.Text = result.ReservateDatetime;
            this.DropDownListStatus.SelectedValue = result.Status;
            this.LabelMail.Text = result.UserMail;
            this.LabelPhone.Text = result.UserPhone;
            this.LabelUserName.Text = result.UserName;
            this.LabelTarget.Text = result.ItemName;
            this.LabelRegDate.Text = result.ReservateRegDate.ToString("yyyy/MM/dd HH:mm:ss");

        }

        private void initQueryString()
        {
            if (string.IsNullOrEmpty(Request.QueryString["ID"]))
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
                QueryString_ID = Request.QueryString["ID"];
        }

        protected void ButtonUpdate_Click(object sender, EventArgs e)
        {
            AdminUpdateStatusBizProcess param = new AdminUpdateStatusBizProcess();
            param.ID = QueryString_ID;
            param.Status = this.DropDownListStatus.SelectedValue;

            AdminUpdateStatusBizLogic logic = new AdminUpdateStatusBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result == true)
            {
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030),
                    TransitionDefinition_OperationResult);
            }
        }

    }
}