﻿using System;
using System.Globalization;

using ZXR.Core;
using ZXR.IO;
using ZXR.Web.Controls;

using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Admin.Settings
{
    public partial class CultureManagement : SecurityPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            this.MenuTableCurrentCultureList.InitTable(ZXR.Web.Controls.MenuTableDisplayType.RowDisplay);
            this.MenuTableCurrentCultureList.TurnBackNumber = 2;

            foreach (string culture in SupportCulture.LanguageList)
            {
                this.MenuTableCurrentCultureList.AddContex(SupportCulture.ConvertCodeToText(culture));

                ValidatorButton deleteButton = new ValidatorButton();
                deleteButton.Text = MessageManager.GetValue(MessageKey.AdminD0031);
                deleteButton.UserDatas["culturecode"] = culture;
                deleteButton.Click += new EventHandler(deleteButton_Click);
                this.MenuTableCurrentCultureList.AddControl(deleteButton);
            }

            this.MenuTableCurrentCultureList.Flush();

            this.SelectCulture1.ViewText = MessageManager.GetValue(MessageKey.AdminN0008);
            foreach (CultureInfo cul in CultureInfo.GetCultures(CultureTypes.AllCultures))
            {
                this.SelectCulture1.AddItem(cul.NativeName, cul.Name);
            }
        }

        protected void deleteButton_Click(object sender, EventArgs e)
        {
            DirectoryIO.DeleteFolder("", true);
        }

        protected void CustomButtonAppend_Click(object sender, EventArgs e)
        {
            WebMessageBox.Show(this.SelectCulture1.SelectedValue);
        }

    }
}
