﻿using System;

using ZXR.Core;
using ZXR.Net;
using ZXR.Log;
using ZXR.Web.Controls;
using ZXR.BusinessLogic;

using CAUtility.Logic.Settings;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Admin.Settings
{

    public partial class EmailSetting : SecurityPage
    {
        protected void Page_Init(object sender, EventArgs e)
        {
            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                InitPage();
            }
        }

        private void InitInterface()
        {
            this.DisplayLabelUsername.Text = MessageManager.GetValue(MessageKey.AdminD0002);
            this.DisplayLabelPW.Text = MessageManager.GetValue(MessageKey.AdminD0003);
            this.LabelPwDes.Text = MessageManager.GetValue(MessageKey.AdminC0013);
            this.DisplayLabelServername.Text = MessageManager.GetValue(MessageKey.AdminD0086);
            this.DisplayLabelPort.Text = MessageManager.GetValue(MessageKey.AdminD0087);
            this.DisplayLabelTarget.Text = MessageManager.GetValue(MessageKey.AdminD0088);
            this.DisplayLabelTargetNotfy.Text = MessageManager.GetValue(MessageKey.AdminC0012);
            this.CustomButtonTestConntect.Text = MessageManager.GetValue(MessageKey.AdminD0102);
            this.CustomButtonSubmit.Text = MessageManager.GetValue(MessageKey.AdminD0103);
        }

        private void InitPage()
        {
            this.CustomTextBoxServerName.Text = CaSettings.MailSmtpServerName;
            this.CustomTextBoxPort.Text = CaSettings.MailSmtpServerPort.ToString();
            this.CustomTextBoxUserName.Text = CaSettings.MailSmtpUsername;
            this.CustomTextBoxTarget.Text = SettingManager.GetSettingValue("MessageNotfytargetList");
        }

        protected void CustomButton1_Click(object sender, EventArgs e)
        {
            EmailSettingBizProcess param = new EmailSettingBizProcess();
            param.MailSmtpServerName =  this.CustomTextBoxServerName.Text;
            param.MailSmtpServerPort= this.CustomTextBoxPort.Text;
            param.MailSmtpUsername= this.CustomTextBoxUserName.Text;
            param.MailSmtpPs= this.CustomTextBoxPassword.Text;
            param.MessageNotfytargetList = this.CustomTextBoxTarget.Text;

            EmailSettingBizLogic logic = new EmailSettingBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result)
            {
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030));
            }
        }

        protected void CustomButtonTestConntect_Click(object sender, EventArgs e)
        {
            try
            {
                Mail mail = new Mail();
                mail.SmtpServerAddress = this.CustomTextBoxServerName.Text;
                mail.SmtpServerPort = Convert.ToInt32(this.CustomTextBoxPort.Text);
                mail.SmtpServerUserName = this.CustomTextBoxUserName.Text;

                if (!string.IsNullOrEmpty(this.CustomTextBoxPassword.Text))
                    mail.SmtpServerPassword = this.CustomTextBoxPassword.Text;
                else
                    mail.SmtpServerPassword = CaSettings.MailSmtpPs;

                mail.ConnectServer();
                bool result = mail.SendMail("123@test.com",
                    this.CustomTextBoxUserName.Text,
                    "ConnectionTest",
                    "Test Message");

                if (result)
                    WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminN0004));
            }
            catch (Exception)
            {
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminN0005));
            }
        }

    }
}
