﻿using System;

using ZXR.Web.Controls;
using CAUtility.Pages;
using ZXR.Core;
using ZXR.Log;

using ZXR.BusinessLogic;
using CAUtility.Logic.Settings;

using CAUtility;

namespace WebApplication.Admin.Settings
{
    public partial class SettingsManager : SecurityPage
    {

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                InitInterface();
                InitPage();
            }
        }

        private void InitInterface()
        {
            this.DisplayLabelCompanyName.Text = MessageManager.GetValue(MessageKey.AdminD0042);
            this.DisplayLabelEmail.Text = MessageManager.GetValue(MessageKey.AdminD0041);
            this.LabelIsSiteOpen.Text = MessageManager.GetValue(MessageKey.AdminD0151);
            this.LabelAllowRegist.Text = MessageManager.GetValue(MessageKey.AdminD0182);
            this.LabelMailDes.Text = MessageManager.GetValue(MessageKey.AdminC0011);
        }

        private void InitPage()
        {
            this.CustomTextBoxCompanyName.Text = CaContext.Current.CompanyName;
            this.CustomTextBoxEmail.Text = CaSettings.AdminEmail;

            if (CaSettings.IsSiteOpen)
                this.RadioButtonIsSiteOpenYes.Checked = true;
            else
                this.RadioButtonIsSiteOpenNo.Checked = true;

            if (CaSettings.AllowRegist)
                this.RadioButtonAllowRegistYes.Checked = true;
            else
                this.RadioButtonAllowRegistNo.Checked = true;
        }

        protected void CustomButton1_Click(object sender, EventArgs e)
        {
            BasicSettingBizProcess param = new BasicSettingBizProcess();
            param.AdminEmail = this.CustomTextBoxEmail.Text;
            param.CompanyName = this.CustomTextBoxCompanyName.Text;

            if (this.RadioButtonIsSiteOpenYes.Checked)
                param.IsSiteOpen = true;
            else
                param.IsSiteOpen = false;

            if (this.RadioButtonAllowRegistYes.Checked)
                param.AllowRegist = true;
            else
                param.AllowRegist = false;

            BasicSettingBizLogic logic = new BasicSettingBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result)
            {
                CaContext.Current.CompanyName = this.CustomTextBoxCompanyName.Text;
                Logger.Info(MessageManager.GetValue(MessageKey.AdminL0003));
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030));
            }
        }
    }
}