﻿using System;
using System.Web.UI.WebControls;

using ZXR.Core;
using ZXR.IO;
using ZXR.Web.Controls;
using CAUtility.Pages;

using CAUtility.Logic.BackupFileManager;
using CAUtility;

namespace WebApplication.Admin.SystemManager
{

    public partial class BackupFileManager : SecurityPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            this.ZxrGridView1.AllowSelect = false;
            this.ZxrGridView1.AllowCheck = true;
            this.ZxrGridView1.OperationButtonClick += new WebApplication.WebParts.FileGridView.OperationButtonHandler(ZxrGridView1_OperationButtonClick);
            this.ZxrGridView1.OperationCompleted += new WebApplication.WebParts.FileGridView.OperationCompletedHandler(ZxrGridView1_OperationCompleted);

            if (!IsPostBack)
            {
                GetBackupfileListBizProcess param = new GetBackupfileListBizProcess();
                param.Path = Server.MapPath("~/Backup");

                GetBackupfileListBizLogic logic = new GetBackupfileListBizLogic();
                GetBackupfileListBizResult result = (GetBackupfileListBizResult)logic.Execute(param);

                InitInterface();

                this.ZxrGridView1.DataSource = result.DataList;
                this.ZxrGridView1.DataBind();
            }
        }

        void ZxrGridView1_OperationCompleted(object sender, EventArgs e)
        {
            Response.Redirect("~/Admin/SystemManager/BackupFileManager.aspx");
        }

        void ZxrGridView1_OperationButtonClick(object sender, EventArgs e)
        {
            try
            {
                FileIO.DeleteFile(Server.MapPath("~/Backup/" + ((GridViewRow)sender).Cells[2].Text));
            }
            catch (ZxrException ex)
            {
                WebMessageBox.Show(ex.Message);
            }
        }

        private void InitInterface()
        {
            this.ZxrGridView1.OperationButtonText =  MessageManager.GetValue(MessageKey.AdminD0031);
        }

    }
}
