﻿using System;

using ZXR.Core;
using ZXR.BusinessLogic;

using CAUtility.Pages;
using CAUtility.Logic.BackupFileManager;
using CAUtility;

namespace WebApplication.Admin.SystemManager
{
    public partial class DataBackup : SecurityPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                InitInterface();
            }
        }

        private void InitInterface()
        {
            this.CustomButtonAttach.Text = MessageManager.GetValue(MessageKey.AdminD0079);
            this.CustomButtonConfigfile.Text = MessageManager.GetValue(MessageKey.AdminD0080);
            this.CustomButtonLog.Text = MessageManager.GetValue(MessageKey.AdminD0081);
            this.CustomButtonDatabase.Text = MessageManager.GetValue(MessageKey.AdminD0078);
            this.DisplayLabelNotfy.Text = MessageManager.GetValue(MessageKey.AdminC0010, CaSettings.BackupPath);
            this.CustomHyperLinkFileManager.Text = MessageManager.GetValue(MessageKey.AdminD0149);
            this.CustomHyperLinkBf.Text = MessageManager.GetValue(MessageKey.AdminD0150);
        }

        protected void CustomButtonDatabase_Click(object sender, EventArgs e)
        {

            string fileHeadName = "DatabaseBak";
            string date = DateTime.Now.ToString("yyyy-MM-dd HH-mm-ss");
            string path  = System.IO.Path.Combine(CaSettings.BackupPath, fileHeadName + date + ".zip");

            DbFileBackupBizProcess param = new DbFileBackupBizProcess();
            param.FileSavePath = Server.MapPath(path);

            DbFileBackupBizLogic logic = new DbFileBackupBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result)
            {

                Response.Redirect(path);
            }
        }

        protected void CustomButtonConfigfile_Click(object sender, EventArgs e)
        {
            string fileHeadName = "ConfigFileBak";
            string date = DateTime.Now.ToString("yyyy-MM-dd HH-mm-ss");
            string path = CaSettings.BackupPath + fileHeadName + date + ".zip";

            ConfigFileBackupBizProcess param = new ConfigFileBackupBizProcess();
            param.FileSavePath = Server.MapPath(path);

            ConfigFileBackupBizLogic logic = new ConfigFileBackupBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result)
            {

                Response.Redirect(path);
            }
        }

        protected void CustomButtonAttach_Click(object sender, EventArgs e)
        {
            string fileHeadName = "AttachBak";

            string date = DateTime.Now.ToString("yyyy-MM-dd HH-mm-ss");
            string path = CaSettings.BackupPath + fileHeadName + date + ".zip";

            AttachFileBackupBizProcess param = new AttachFileBackupBizProcess();
            param.FileSavePath = Server.MapPath(path);

            AttachFileBackupBizLogic logic = new AttachFileBackupBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result)
            {

                Response.Redirect(path);
            }
        }

        protected void CustomButtonLog_Click(object sender, EventArgs e)
        {
            string fileHeadName = "LogBak";
            string date = DateTime.Now.ToString("yyyy-MM-dd HH-mm-ss");
            string path = CaSettings.BackupPath + fileHeadName + date + ".zip";

            LogFileBackupBizProcess param = new LogFileBackupBizProcess();
            param.FileSavePath = Server.MapPath(path);

            LogFileBackupBizLogic logic = new LogFileBackupBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result)
            {

                Response.Redirect(path);
            }
        }
    }
}
