﻿using System;
using System.Web.UI.WebControls;
using CAUtility.Pages;

using ZXR.Core;
using ZXR.IO;
using ZXR.Web.Controls;
using CAUtility.Logic.LogManager;
using CAUtility;

namespace WebApplication.Admin.SystemManager
{
    public partial class LogFileManager : SecurityPage
    {
        private GetLogFileListBizResult result = null;

        protected void Page_Init(object sender, EventArgs e)
        {
            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            this.ZxrGridView1.AllowSelect = false;
            this.ZxrGridView1.AllowCheck = true;

            GetLogFileListBizProcess param = new GetLogFileListBizProcess();
            param.Path = Server.MapPath("~/Log");

            GetLogFileListBizLogic logic = new GetLogFileListBizLogic();
            result = (GetLogFileListBizResult)logic.Execute(param);

            if (!IsPostBack)
            {
                this.ZxrGridView1.DataSource = result.DataList;
                this.ZxrGridView1.DataBind();
            }

            this.ZxrGridView1.OperationButtonClick += new WebApplication.WebParts.FileGridView.OperationButtonHandler(ZxrGridView1_OperationButtonClick);
            this.ZxrGridView1.OperationCompleted += new WebApplication.WebParts.FileGridView.OperationCompletedHandler(ZxrGridView1_OperationCompleted);
        }

        void ZxrGridView1_OperationCompleted(object sender, EventArgs e)
        {
            Response.Redirect("~/Admin/SystemManager/LogFileManager.aspx");
        }

        void ZxrGridView1_OperationButtonClick(object sender, EventArgs e)
        {
            try
            {
                FileIO.DeleteFile(Server.MapPath("~/Log/" + ((GridViewRow)sender).Cells[2].Text));
            }
            catch (ZxrException ex)
            {
                WebMessageBox.Show(ex.Message);
            }
        }

        private void InitInterface()
        {
            this.ZxrGridView1.OperationButtonText = MessageManager.GetValue(MessageKey.AdminD0031); 
        }

    }
}