﻿using System;

using ZXR.Core;
using ZXR.BusinessLogic;
using ZXR.Web.Controls;

using CAUtility.Logic.GroupInfo;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Admin.UserManager
{
    public partial class GroupEdit :SecurityPage
    {

        private const string TransitionDefinition_OperationResult = "GroupManagement.aspx";

        private string QueryString_GroupID = string.Empty;

        protected void Page_Init(object sender, EventArgs e)
        {

            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            initQueryString();

            if (!IsPostBack)
            {

                if (!string.IsNullOrEmpty(QueryString_GroupID))
                {
                    GetGroupInfoBizProcess param = new GetGroupInfoBizProcess();
                    param.GroupId = Convert.ToInt32(QueryString_GroupID);

                    GetGroupInfoBizLogic logic = new GetGroupInfoBizLogic();
                    GetGroupInfoBizResult result = (GetGroupInfoBizResult)logic.Execute(param);

                    this.TextBoxGroupName.Text = result.GroupName;
                }
            }
        }

        private void initQueryString()
        {
            if (ZXR.Core.Validate.ValidateInteger(Request.QueryString["GroupId"], true) == false)
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
                QueryString_GroupID = Request.QueryString["GroupId"];
        }

        private void InitInterface()
        {
            this.LabelGroupName.Text = MessageManager.GetValue(MessageKey.AdminD0155);
            this.ButtonUpdate.Text = MessageManager.GetValue(MessageKey.AdminD0195);
        }

        protected void ButtonUpdate_Click(object sender, EventArgs e)
        {

            if (!string.IsNullOrEmpty(QueryString_GroupID))
            {
                UpdateGroupBizProcess param = new UpdateGroupBizProcess();
                param.GroupId = Convert.ToInt32(QueryString_GroupID);
                param.GroupName = this.TextBoxGroupName.Text;

                UpdateGroupBizLogic logic = new UpdateGroupBizLogic();
                BizResult result = logic.Execute(param);

                if (result.Result)
                {
                    WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030), TransitionDefinition_OperationResult);
                }
            }
            else
            {
                InsertGroupBizProcess param = new InsertGroupBizProcess();
                param.GroupName = this.TextBoxGroupName.Text;

                InsertGroupBizLogic logic = new InsertGroupBizLogic();
                BizResult result = logic.Execute(param);

                if (result.Result)
                {
                    WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030), TransitionDefinition_OperationResult);
                }
            }
        }
    }
}
