﻿using System;
using System.Collections.Generic;

using ZXR.Core;
using ZXR.Data;
using ZXR.DataAccess;
using ZXR.BusinessLogic;
using ZXR.Web.Controls;

using CAUtility.Logic.UserShoppingInfo;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Admin.UserManager
{
    public partial class MessageToUser : SecurityPage
    {

        private const string TransitionDefinition_OperationResult = "Default.aspx";

        protected void Page_Init(object sender, EventArgs e)
        {

            initInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        private void initInterface()
        {
            this.LabelMessage.Text = MessageManager.GetValue(MessageKey.AdminD0121);
            this.LabelTitle.Text = MessageManager.GetValue(MessageKey.AdminD0199);
            this.LabelPageTitle.Text = MessageManager.GetValue(MessageKey.AdminD0174);
            this.ButtonSend.Text = MessageManager.GetValue(MessageKey.AdminD0173);
            this.ButtonSend.ConfirmMessage = MessageManager.GetValue(MessageKey.AdminD0144);
        }

        protected void ButtonSend_Click(object sender, EventArgs e)
        {
            AllMemberMailBizProcess param = new AllMemberMailBizProcess();
            param.MailTitle = this.TextBoxTitle.Text;
            param.MailContent = this.TextBoxMessage.Text;

            AllMemberMailBizLogic logic = new AllMemberMailBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result)
            {
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030), TransitionDefinition_OperationResult);
            }
            else
            {
                WebMessageBox.Show(result.ResultData.ToString());
            }
        }
    }
}