﻿using System;

using ZXR.Web.Controls;
using ZXR.Core;
using ZXR.Security;
using ZXR.BusinessLogic;

using CAUtility.Pages;
using CAUtility.Logic.UserInfo;
using CAUtility.Logic.GroupInfo;
using CAUtility;

namespace WebApplication.Admin.UserManager
{

    public partial class UserAppend : SecurityPage
    {

        private const string TransitionDefinition_OperationResult = "UserManagement.aspx";

        protected void Page_Init(object sender, EventArgs e)
        {
            InitInterface();

            ListGroupInfoBizLogic logic = new ListGroupInfoBizLogic();
            ListGroupInfoBizResult result = (ListGroupInfoBizResult)logic.Execute(null);
            foreach (ListGroupInfoBizResultElement node in result.DataList)
            {
                this.DropDownListUserGroup.AddItem(node.GroupName, node.GroupID.ToString());
            }

            this.DropDownListUserGroup.SelectedValue = CaSettings.NewRegistUserGroup.ToString();
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        private void InitInterface()
        {
            this.DisplayLabelUserNameTitle.Text = MessageManager.GetValue(MessageKey.UserLoginS0001);
            this.DisplayLabelPassword.Text = MessageManager.GetValue(MessageKey.UserLoginS0002);
            this.CustomButtonRegist.Text = MessageManager.GetValue(MessageKey.UserLoginS0004);
            this.LabelFriendlyName.Text = MessageManager.GetValue(MessageKey.UserLoginS0041);
            this.LabelUserGroup.Text = MessageManager.GetValue(MessageKey.UserLoginS0007);
        }

        protected void CustomButtonUpdate_Click(object sender, EventArgs e)
        {

            if (!string.Equals(this.CustomTextBoxPassword.Text, this.CustomTextBoxPasswordConfirm.Text))
            {
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminE0011));
            }

            UserExistCheckBizProcess checkparam = new UserExistCheckBizProcess();
            checkparam.UserID = this.CustomTextBoxUsername.Text;

            UserExistCheckBizLogic checklogic = new UserExistCheckBizLogic();
            BizResult checkresult = checklogic.Execute(checkparam);

            if (checkresult.Result)
            {
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.UserLoginS0015));
            }
            else
            {

                InsertUserBizProcess param = new InsertUserBizProcess();
                param.Password = Md5Cryptogram.Md5Hash(this.CustomTextBoxPassword.Text);
                param.UserName = this.CustomTextBoxUsername.Text;
                param.FriendlyName = this.TextBoxFriendlyName.Text;
                param.UserGroup = Convert.ToInt32(this.DropDownListUserGroup.SelectedValue);

                InsertUserBizLogic logic = new InsertUserBizLogic();
                logic.Execute(param);

                WebMessageBox.Show(MessageManager.GetValue(MessageKey.AdminD0030), TransitionDefinition_OperationResult);
            }
        }

    }
}
