﻿using System;

using ZXR.Core;
using CAUtility.Pages;

using CAUtility;

namespace WebApplication.Common.ErrorPage
{
    public partial class _403 : NormalPage
    {

        private string QueryString_Culture = string.Empty;

        protected void Page_Load(object sender, EventArgs e)
        {
            initQueryString();

            InitInterface();

            if (string.Equals(QueryString_Culture, CaSettings.PageDefaultCulture))
            {
                this.HyperLinkLogin.NavigateUrl = "~/UserLogin.aspx";
                this.HyperLinkTop.NavigateUrl = "~/";
            }
            else
            {
                this.HyperLinkLogin.NavigateUrl = "~/" + QueryString_Culture + "/UserLogin.aspx";
                this.HyperLinkTop.NavigateUrl = "~/" + QueryString_Culture;
            }
        }

        private void InitInterface()
        {
            if (MessageManager.CultureTarget == null
                || string.IsNullOrEmpty(MessageManager.CultureTarget.Name))
                MessageManager.CultureTarget = new System.Globalization.CultureInfo(QueryString_Culture);

            this.LabelMessage.Text = MessageManager.GetValue(MessageKey.PageD0064);
            this.HyperLinkLogin.Text = "[" + MessageManager.GetValue(MessageKey.UserLoginS0003) + "]";
            this.HyperLinkTop.Text = "[" + MessageManager.GetValue(MessageKey.PageD0038) + "]";
        }

        private void initQueryString()
        {
            QueryString_Culture = Request.QueryString["culture"];
            if (!string.IsNullOrEmpty(QueryString_Culture))
            {
                if (!SupportCulture.IsSupport(QueryString_Culture))
                {
                    throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
                }
            }
            else
            {
                QueryString_Culture = CaSettings.AdminCulture;
            }
        }
    }
}