﻿using System;

using ZXR.Core;
using ZXR.Web;
using ZXR.Web.Controls;
using CAUtility.Pages;
using CAUtility;

namespace WebApplication.Common.ErrorPage
{

    public partial class OperationError : NormalPage
    {

        private string QueryString_Culture = string.Empty;

        protected void Page_Load(object sender, EventArgs e)
        {
            initQueryString();

            MessageManager.CultureTarget = new System.Globalization.CultureInfo(QueryString_Culture);

            this.DisplayLabelTitle.Text = MessageManager.GetValue(MessageKey.PageE0002);

            if (!string.IsNullOrEmpty(Request.QueryString["message"]))
            {
                this.DisplayLabel1.Text = Request.QueryString["message"];
            }
            else
            {
                this.DisplayLabel1.Text = "不明なエラーが発生しました、もう一度やり直してください。";
            }
        }

        private void initQueryString()
        {
            QueryString_Culture = Request.QueryString["culture"];
            if (!string.IsNullOrEmpty(QueryString_Culture ))
            {
                if (!SupportCulture.IsSupport(QueryString_Culture))
                {
                    throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
                }
            }
            else
            {
                QueryString_Culture = CaSettings.AdminCulture;
            }
        }

    }
}
