﻿using System;

using ZXR.Core;
using CAUtility.Pages;

using CAUtility;

namespace WebApplication.Common
{

    public partial class OperationResult : NormalPage
    {

        private bool QueryString_OperationResult = false;

        protected void Page_Init(object sender, EventArgs e)
        {
            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            initQueryString();

            if (QueryString_OperationResult)
            {
                this.DisplayLabelMessage.ForeColor = System.Drawing.Color.Green;
                this.DisplayLabelMessage.Text = MessageManager.GetValue(MessageKey.PageD0031);
            }
            else
            {
                this.DisplayLabelMessage.ForeColor = System.Drawing.Color.Red;
                this.DisplayLabelMessage.Text = MessageManager.GetValue(MessageKey.PageD0034);
            }
        }

        private void initQueryString()
        {
            if (ZXR.Core.Validate.ValidateBoolean(Request.QueryString["Result"]) == false)
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
                QueryString_OperationResult = Convert.ToBoolean(Request.QueryString["Result"]);
        }

        private void InitInterface()
        {
            this.DisplayLabelTitle.Text = MessageManager.GetValue(MessageKey.PageD0017);
            this.DisplayLabelReturn.Text = MessageManager.GetValue(MessageKey.PageD0014);
        }
    }
}
