﻿using System;

using ZXR.Core;
using ZXR.Web;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Internal.Common
{
    public partial class InternalHead : MasterPage
    {

        private const string UserInfoCookieName = "UserInfo";

        protected void Page_Init(object sender, EventArgs e)
        {
            System.Web.UI.HtmlControls.HtmlLink myHtmlLink1 = new System.Web.UI.HtmlControls.HtmlLink();
            myHtmlLink1.Href = "~/App_Themes/Default/InternalPage.css";
            myHtmlLink1.Attributes.Add("rel", "stylesheet");
            myHtmlLink1.Attributes.Add("type", "text/css");
            Page.Header.Controls.Add(myHtmlLink1);

            MessageManager.CultureTarget = new System.Globalization.CultureInfo(CaSettings.PageDefaultCulture);
            this.LabelUserName.Text = MessageManager.GetValue(MessageKey.UserLoginS0042, ClientInfoContext.Current.UserPrincipal.FriendlyName);
            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
        }

        private void InitInterface()
        {
            this.CustomLinkButtonLogout.Text = MessageManager.GetValue(MessageKey.UserLoginS0006);
            this.HyperLinkHome.Text = MessageManager.GetValue(MessageKey.PageD0038);
            this.HyperLinkMember.Text = MessageManager.GetValue(MessageKey.UserLoginS0061);
        }

        protected void CustomLinkButtonLogout_Click(object sender, EventArgs e)
        {
            Session.Abandon();
            CookieManager.CookieDiscard(UserInfoCookieName);
            Response.Redirect("~/");
        }

    }
}
