﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Text;

using ZXR.Core;
using ZXR.DataAccess;
using CAUtility;

namespace WebApplication.Internal.Schedule
{
    public partial class Default
    {

        private int QueryString_PageIndex = 1;

        public string getLineFormat(int typeid, string dataStatus)
        {
            StringBuilder sb = new StringBuilder();

            if (typeid == 1)
            {
                sb.Append("<img src=\"../../App_Themes/Default/Images/System/Repeat.png\" alt=\"");
                sb.Append(MessageManager.GetValue(MessageKey.ScheduleD0002));
                sb.Append("\" height=\"12\" />");
            }
            else if (typeid == 2)
            {
                sb.Append("<img src=\"../../App_Themes/Default/Images/System/DoubleLeftArrowHS.png\" alt=\"");
                sb.Append(MessageManager.GetValue(MessageKey.ScheduleD0003));
                sb.Append("\" height=\"10\" /><img src=\"../../App_Themes/Default/Images/System/DoubleRightArrowHS.png\" alt=\"");
                sb.Append(MessageManager.GetValue(MessageKey.ScheduleD0003));
                sb.Append("\" height=\"10\" />");
            }
            else
            {
                sb.Append("●");
            }

            if (string.Equals(dataStatus, DataStatus.Updated.ToString()))
            {
                sb.Append("<img src=\"../../App_Themes/Default/Images/System/HasUpdate.png\" alt=\"");
                sb.Append(MessageManager.GetValue(MessageKey.ScheduleD0004));
                sb.Append("\" height=\"12\" />");
                sb.Append(LinkFormat);
            }
            else if (string.Equals(dataStatus, DataStatus.Cancel.ToString()))
            {
                sb.Append("<img src=\"../../App_Themes/Default/Images/System/DeleteHS.png\" alt=\"");
                sb.Append(MessageManager.GetValue(MessageKey.ScheduleD0005));
                sb.Append("\" height=\"12\" /><Del>");
                sb.Append(LinkFormat);
                sb.Append("</Del>");
            }
            else
            {
                sb.Append(LinkFormat);
            }

            return sb.ToString();
        }

        public string CreateMidasi(string groupId, DateTime dt)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("<tr class=\"namemidasi\" height=\"10px\">");
            sb.Append("<td class=\"namemidasi\" height=\"10\">&nbsp;</td>");
            for (int i = 0; i < 7; i++)
            {
                sb.Append("<td class=\"midasi\" height=\"10\">");
                sb.Append("<a href=\"Default.aspx?");
                if (!string.IsNullOrEmpty(groupId))
                {
                    sb.Append("GroupID=");
                    sb.Append(groupId);
                    sb.Append("&");
                }
                sb.Append("Year=");
                sb.Append(dt.AddDays(i).Date.Year.ToString());
                sb.Append("&Month=");
                sb.Append(dt.AddDays(i).Date.Month.ToString());
                sb.Append("&Day=");
                sb.Append(dt.AddDays(i).Date.Day.ToString());
                sb.Append("\">");
                sb.Append(dt.AddDays(i).Date.ToString("MM月dd日"));
                sb.Append("(");
                sb.Append(DatetimeUtil.ToCultureWeekDay(dt.AddDays(i), MessageManager.CultureTarget));
                sb.Append(")");
                sb.Append("</a></td>");
            }
            sb.Append("</tr>");

            return sb.ToString();
        }

    }
}
