﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using ZXR.Log;
using ZXR.Core;
using ZXR.DataAccess;
using CAUtility.Logic.GroupInfo;
using CAUtility.Logic.Schedule;
using CAUtility;

namespace WebApplication.Internal.Schedule
{
    public partial class Default
    {
        public void initSelfSchedule(DateTime dt)
        {
            ListScheduleBizProcess param = new ListScheduleBizProcess();
            param.UserName = ClientInfoContext.Current.UserPrincipal.UserName;
            param.StartDate = dt;

            ListScheduleBizLogic logic = new ListScheduleBizLogic();
            ListScheduleBizResult result = (ListScheduleBizResult)logic.Execute(param);

            string[] td = new string[7];

            List<string> continuou = new List<string>();

            foreach (ListScheduleBizResultElement ele in result.DataList)
            {
                string format = getLineFormat(ele.Type, ele.Status);

                if (ele.Type == 0)
                {
                    if (ele.StartTime.Date == dt.Date)
                    {
                        td[0] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                    else if (ele.StartTime.Date == dt.AddDays(1).Date)
                    {
                        td[1] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                    else if (ele.StartTime.Date == dt.AddDays(2).Date)
                    {
                        td[2] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                    else if (ele.StartTime.Date == dt.AddDays(3).Date)
                    {
                        td[3] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                    else if (ele.StartTime.Date == dt.AddDays(4).Date)
                    {
                        td[4] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                    else if (ele.StartTime.Date == dt.AddDays(5).Date)
                    {
                        td[5] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                    else if (ele.StartTime.Date == dt.AddDays(6).Date)
                    {
                        td[6] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                }
                else if (ele.Type == 1)
                {
                    CycleDatetime cd = CycleDatetime.Parse(ele.RepeatString);
                    if (cd.Compare(dt.Date))
                    {
                        td[0] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                    else if (cd.Compare(dt.AddDays(1).Date))
                    {
                        td[1] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                    else if (cd.Compare(dt.AddDays(2).Date))
                    {
                        td[2] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                    else if (cd.Compare(dt.AddDays(3).Date))
                    {
                        td[3] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                    else if (cd.Compare(dt.AddDays(4).Date))
                    {
                        td[4] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                    else if (cd.Compare(dt.AddDays(5).Date))
                    {
                        td[5] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                    else if (cd.Compare(dt.AddDays(6).Date))
                    {
                        td[6] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                    }
                }
                else if (ele.Type == 2)
                {
                    int startPoint = (ele.StartTime.Date - dt.Date).Days < 0 ? 0 : (ele.StartTime.Date - dt.Date).Days;

                    if (startPoint > 6)
                    {
                        continue;
                    }

                    int endPoint = (ele.EndTime.Date - dt.Date).Days <= 6 ? (ele.EndTime.Date - dt.Date).Days : 6;

                    StringBuilder row = new StringBuilder();
                    row.Append("<tr>");

                    if (startPoint > 0)
                    {
                        row.Append("<td class=\"ContinuousEmpty\" colspan=\"");
                        row.Append(startPoint.ToString());
                        row.Append("\">");
                        row.Append("&nbsp;</td>");
                    }

                    row.Append("<td class=\"Continuous\" colspan=\"");
                    row.Append((endPoint - startPoint + 1).ToString());
                    row.Append("\">");
                    row.Append(string.Format(format, ele.ID, ele.StartTime.ToString("MM/dd"), ele.EndTime.ToString("MM/dd"), ele.Title));
                    row.Append("</td>");

                    if (6- endPoint  > 0)
                    {
                        row.Append("<td class=\"ContinuousEmpty\" colspan=\"");
                        row.Append((6- endPoint).ToString());
                        row.Append("\">");
                        row.Append("&nbsp;</td>");
                    }

                    row.Append("</tr>");

                    continuou.Add(row.ToString());
                }
            }

            StringBuilder sb = new StringBuilder();
            sb.Append("<table id=\"ScheduleTable\">");

            sb.Append(CreateMidasi("", dt));

            sb.Append("<tr>");
            sb.Append("<td class=\"Header\"");
            if (continuou.Count > 0)
            {
                sb.Append("rowspan=\"" + (continuou.Count + 1) + "\"");
            }
            sb.Append(">");
            sb.Append(string.IsNullOrEmpty(ClientInfoContext.Current.UserPrincipal.FriendlyName) ? ClientInfoContext.Current.UserPrincipal.UserName : ClientInfoContext.Current.UserPrincipal.FriendlyName);
            sb.Append("</td>");
            for (int i = 0; i < 7; i++)
            {
                sb.Append("<td>");
                sb.Append("<a href=\"Edit.aspx?UserName=");
                sb.Append(ClientInfoContext.Current.UserPrincipal.UserName);
                sb.Append("&Year=");
                sb.Append(dt.AddDays(i).Year.ToString());
                sb.Append("&Month=");
                sb.Append(dt.AddDays(i).Month.ToString());
                sb.Append("&Day=");
                sb.Append(dt.AddDays(i).Day.ToString());
                sb.Append("\"><img src=\"../../App_Themes/Default/Images/System/CommentHS.png\" alt=\"");
                sb.Append(MessageManager.GetValue(MessageKey.ScheduleD0001));
                sb.Append("\" height=\"16\" /></a><br/>");
                sb.Append(td[i]);
                sb.Append("</td>");
            }
            sb.Append("</tr>");

            foreach (string row in continuou)
            {
                sb.Append(row);
            }

            sb.Append("</table>");

            this.LabelSchedule.Text = sb.ToString();
        }
    }
}
