﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using ZXR.Log;
using ZXR.Core;
using ZXR.DataAccess;
using CAUtility.Logic.GroupInfo;
using CAUtility.Logic.Schedule;
using CAUtility;

namespace WebApplication.Internal.Schedule
{
    public partial class Default
    {
        public void initSpecifiedGroupSchedule(DateTime dt)
        {
            Dictionary<string, string[]> userTd = new Dictionary<string, string[]>();
            Dictionary<string, string> userName = new Dictionary<string, string>();

            Dictionary<string, List<string>> userConTd = new Dictionary<string, List<string>>();

            List<string> continuou = new List<string>();

            ListGroupUsersBizProcess groupUserParam = new ListGroupUsersBizProcess();
            groupUserParam.GroupList = new List<string>() { QueryString_GroupId };
            groupUserParam.OnePageMaxItemsCount = CaSettings.AdminTableMaxDataCount;
            groupUserParam.PageIndex = QueryString_PageIndex;

            ListGroupUsersBizLogic groupUserLogic = new ListGroupUsersBizLogic();
            ListGroupUsersBizResult groupUserResult = (ListGroupUsersBizResult)groupUserLogic.Execute(groupUserParam);

            this.PageDivider1.ItemCount = groupUserResult.TotalUserCount;
            this.PageDivider1.DispalyPageCount = CaSettings.AdminTablePageDividerDisplayCount;
            this.PageDivider1.OnePageMaxItemCount = CaSettings.AdminTableMaxDataCount;
            this.PageDivider1.Visible = true;

            foreach (ListGroupUsersBizResultElement ele in groupUserResult.DataList)
            {
                if (!userTd.ContainsKey(ele.UserName))
                {
                    userTd.Add(ele.UserName, new string[7]);
                    userName.Add(ele.UserName, ele.FriendlyName);
                    userConTd.Add(ele.UserName, new List<string>());
                }
            }

            ListScheduleBizProcess param = new ListScheduleBizProcess();
            param.GroupID = Convert.ToInt32(QueryString_GroupId);
            param.StartDate = dt;

            ListScheduleBizLogic logic = new ListScheduleBizLogic();
            ListScheduleBizResult result = (ListScheduleBizResult)logic.Execute(param);

            string[] td = new string[7];

            foreach (ListScheduleBizResultElement ele in result.DataList)
            {
                string format = getLineFormat(ele.Type, ele.Status);

                if (ele.GroupID != 0) // グループ
                {
                    if (ele.Type == 0)
                    {
                        if (ele.StartTime.Date == dt.Date)
                        {
                            td[0] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (ele.StartTime.Date == dt.AddDays(1).Date)
                        {
                            td[1] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (ele.StartTime.Date == dt.AddDays(2).Date)
                        {
                            td[2] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (ele.StartTime.Date == dt.AddDays(3).Date)
                        {
                            td[3] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (ele.StartTime.Date == dt.AddDays(4).Date)
                        {
                            td[4] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (ele.StartTime.Date == dt.AddDays(5).Date)
                        {
                            td[5] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (ele.StartTime.Date == dt.AddDays(6).Date)
                        {
                            td[6] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                    }
                    else if (ele.Type == 1)
                    {
                        CycleDatetime cd = CycleDatetime.Parse(ele.RepeatString);
                        if (cd.Compare(dt.Date))
                        {
                            td[0] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (cd.Compare(dt.AddDays(1).Date))
                        {
                            td[1] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (cd.Compare(dt.AddDays(2).Date))
                        {
                            td[2] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (cd.Compare(dt.AddDays(3).Date))
                        {
                            td[3] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (cd.Compare(dt.AddDays(4).Date))
                        {
                            td[4] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (cd.Compare(dt.AddDays(5).Date))
                        {
                            td[5] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (cd.Compare(dt.AddDays(6).Date))
                        {
                            td[6] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                    }
                    else if (ele.Type == 2)
                    {
                        int startPoint = (ele.StartTime.Date - dt.Date).Days < 0 ? 0 : (ele.StartTime.Date - dt.Date).Days;
                        if (startPoint > 6)
                        {
                            Logger.Info("潜在的なバグ[Default.aspx.SpceifedGroup.cs 001] DBアクセスクエリに不具合が出る可能性がある");
                            continue;
                        }
                        int endPoint = (ele.EndTime.Date - dt.Date).Days <= 6 ? (ele.EndTime.Date - dt.Date).Days : 6;

                        StringBuilder row = new StringBuilder();
                        row.Append("<tr>");

                        if (startPoint > 0)
                        {
                            row.Append("<td class=\"ContinuousEmpty\" colspan=\"");
                            row.Append(startPoint.ToString());
                            row.Append("\">");
                            row.Append("&nbsp;</td>");
                        }

                        row.Append("<td class=\"Continuous\" colspan=\"");
                        row.Append((endPoint - startPoint + 1).ToString());
                        row.Append("\">");
                        row.Append(string.Format(format, ele.ID, ele.StartTime.ToString("MM/dd"), ele.EndTime.ToString("MM/dd"), ele.Title));
                        row.Append("</td>");

                        if (6 - endPoint > 0)
                        {
                            row.Append("<td class=\"ContinuousEmpty\" colspan=\"");
                            row.Append((6 - endPoint).ToString());
                            row.Append("\">");
                            row.Append("&nbsp;</td>");
                        }

                        row.Append("</tr>");

                        continuou.Add(row.ToString());
                    }
                }
                else //ユーザーテーブル
                {
                    if (!userTd.ContainsKey(ele.AuthorID))
                    {
                        continue;
                    }

                    if (ele.Type == 0)
                    {
                        if (ele.StartTime.Date == dt.Date)
                        {
                            userTd[ele.AuthorID][0] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (ele.StartTime.Date == dt.AddDays(1).Date)
                        {
                            userTd[ele.AuthorID][1] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (ele.StartTime.Date == dt.AddDays(2).Date)
                        {
                            userTd[ele.AuthorID][2] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (ele.StartTime.Date == dt.AddDays(3).Date)
                        {
                            userTd[ele.AuthorID][3] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (ele.StartTime.Date == dt.AddDays(4).Date)
                        {
                            userTd[ele.AuthorID][4] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (ele.StartTime.Date == dt.AddDays(5).Date)
                        {
                            userTd[ele.AuthorID][5] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (ele.StartTime.Date == dt.AddDays(6).Date)
                        {
                            userTd[ele.AuthorID][6] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                    }
                    else if (ele.Type == 1)
                    {
                        CycleDatetime cd = CycleDatetime.Parse(ele.RepeatString);
                        if (cd.Compare(dt.Date))
                        {
                            userTd[ele.AuthorID][0] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (cd.Compare(dt.AddDays(1).Date))
                        {
                            userTd[ele.AuthorID][1] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (cd.Compare(dt.AddDays(2).Date))
                        {
                            userTd[ele.AuthorID][2] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (cd.Compare(dt.AddDays(3).Date))
                        {
                            userTd[ele.AuthorID][3] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (cd.Compare(dt.AddDays(4).Date))
                        {
                            userTd[ele.AuthorID][4] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (cd.Compare(dt.AddDays(5).Date))
                        {
                            userTd[ele.AuthorID][5] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                        else if (cd.Compare(dt.AddDays(6).Date))
                        {
                            userTd[ele.AuthorID][6] += string.Format(format, ele.ID, ele.StartTime.ToString("HH:mm"), ele.EndTime.ToString("HH:mm"), ele.Title);
                        }
                    }
                    else if (ele.Type == 2)
                    {
                        int startPoint = (ele.StartTime.Date - dt.Date).Days < 0 ? 0 : (ele.StartTime.Date - dt.Date).Days;
                        if (startPoint > 6)
                        {
                            Logger.Info("潜在的なバグ[Default.aspx.SpceifedGroup.cs 003] DBアクセスクエリに不具合が出る可能性がある");
                            continue;
                        }
                        int endPoint = (ele.EndTime.Date - dt.Date).Days <= 6 ? (ele.EndTime.Date - dt.Date).Days : 6;

                        StringBuilder row = new StringBuilder();
                        row.Append("<tr>");

                        if (startPoint > 0)
                        {
                            row.Append("<td class=\"ContinuousEmpty\" colspan=\"");
                            row.Append(startPoint.ToString());
                            row.Append("\">");
                            row.Append("&nbsp;</td>");
                        }

                        row.Append("<td class=\"Continuous\" colspan=\"");
                        row.Append((endPoint - startPoint + 1).ToString());
                        row.Append("\">");
                        row.Append(string.Format(format, ele.ID, ele.StartTime.ToString("MM/dd"), ele.EndTime.ToString("MM/dd"), ele.Title));
                        row.Append("</td>");

                        if (6 - endPoint > 0)
                        {
                            row.Append("<td class=\"ContinuousEmpty\" colspan=\"");
                            row.Append((6 - endPoint).ToString());
                            row.Append("\">");
                            row.Append("&nbsp;</td>");
                        }

                        row.Append("</tr>");

                        userConTd[ele.AuthorID].Add(row.ToString());
                    }
                }
            }

            StringBuilder sb = new StringBuilder();
            sb.Append("<table id=\"ScheduleTable\">");

            sb.Append(CreateMidasi(QueryString_GroupId, dt));

            sb.Append("<tr>");
            sb.Append("<td class=\"Header\"");
            if (continuou.Count > 0)
            {
                sb.Append("rowspan=\"" + (continuou.Count + 1) + "\"");
            }
            sb.Append(">");
            sb.Append(result.GroupName);
            sb.Append("</td>");
            for (int i = 0; i < 7; i++)
            {
                sb.Append("<td>");
                sb.Append("<a href=\"Edit.aspx?GroupID=");
                sb.Append(QueryString_GroupId);
                sb.Append("&Year=");
                sb.Append(dt.AddDays(i).Year.ToString());
                sb.Append("&Month=");
                sb.Append(dt.AddDays(i).Month.ToString());
                sb.Append("&Day=");
                sb.Append(dt.AddDays(i).Day.ToString());
                sb.Append("\"><img src=\"../../App_Themes/Default/Images/System/CommentHS.png\" alt=\"");
                sb.Append(MessageManager.GetValue(MessageKey.ScheduleD0001));
                sb.Append("\" height=\"16\" /></a><br/>");
                sb.Append(td[i]);
                sb.Append("</td>");
            }
            sb.Append("</tr>");

            foreach (string row in continuou)
            {
                sb.Append(row);
            }

            int index = 1;

            foreach (string username in userTd.Keys)
            {
                if (index % 4 == 0)
                {

                    sb.Append(CreateMidasi(QueryString_GroupId, dt));
                }

                sb.Append("<tr>");
                sb.Append("<td class=\"Header\"");
                if (userConTd[username].Count > 0)
                {
                    sb.Append("rowspan=\"" + (userConTd[username].Count + 1) + "\"");
                }
                sb.Append(">");
                sb.Append(string.IsNullOrEmpty(userName[username]) ? username : userName[username]);
                sb.Append("</td>");
                for (int i = 0; i < 7; i++)
                {
                    sb.Append("<td>");
                    sb.Append("<a href=\"Edit.aspx?UserName=");
                    sb.Append(username);
                    sb.Append("&Year=");
                    sb.Append(dt.AddDays(i).Year.ToString());
                    sb.Append("&Month=");
                    sb.Append(dt.AddDays(i).Month.ToString());
                    sb.Append("&Day=");
                    sb.Append(dt.AddDays(i).Day.ToString());
                    sb.Append("\"><img src=\"../../App_Themes/Default/Images/System/CommentHS.png\" alt=\"");
                    sb.Append(MessageManager.GetValue(MessageKey.ScheduleD0001));
                    sb.Append("\" height=\"16\" /></a><br/>");
                    sb.Append(userTd[username][i]);
                    sb.Append("</td>");
                }
                sb.Append("</tr>");

                foreach (string row in userConTd[username])
                {
                    sb.Append(row);
                }

                index++;
            }

            sb.Append("</table>");

            this.LabelSchedule.Text = sb.ToString();
        }
    }
}
