﻿using System;

using ZXR.Core;
using ZXR.BusinessLogic;
using ZXR.Security;

using CAUtility.Logic.UserInfo;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Contents
{
    public partial class ChangePassword : NormalMemberPage
    {

        private const string TransitionDefinition_OperationResult = "UserOperateResult.aspx";

        protected void Page_Init(object sender, EventArgs e)
        {
            initInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        private void initInterface()
        {
            this.LabelConfirmPassword.Text = MessageManager.GetValue(MessageKey.UserLoginS0030);
            this.LabelNewPassword.Text = MessageManager.GetValue(MessageKey.UserLoginS0025);
            this.LabelOldPassword.Text = MessageManager.GetValue(MessageKey.UserLoginS0024);
            this.LabelPasswordExp.Text = MessageManager.GetValue(MessageKey.UserLoginS0012);
            this.LabelTitle.Text = MessageManager.GetValue(MessageKey.UserLoginS0023);
            this.ButtonChangePassword.Text = MessageManager.GetValue(MessageKey.UserLoginS0023);
        }

        protected void ButtonChangePassword_Click(object sender, EventArgs e)
        {
            ValidationUserBizProcess param = new ValidationUserBizProcess();
            param.UserName = ClientInfoContext.Current.UserPrincipal.UserName;
            param.Password = Md5Cryptogram.Md5Hash(this.TextBoxOldPassword.Text);

            ValidationUserBizLogic logic = new ValidationUserBizLogic();
            ValidationUserBizResult result = (ValidationUserBizResult)logic.Execute(param);

            if (result.Result == true)
            {
                RechangePasswordBizProcess pwParam = new RechangePasswordBizProcess();
                pwParam.Password = Md5Cryptogram.Md5Hash(this.TextBoxNewPassword.Text);
                pwParam.UserName = ClientInfoContext.Current.UserPrincipal.UserName;

                RechangePasswordBizLogic pwLogic = new RechangePasswordBizLogic();
                BizResult pwResult = pwLogic.Execute(pwParam);

                if (pwResult.Result == true)
                {
                    Response.Redirect(TransitionDefinition_OperationResult + "?Result=true&MessageId="
                        + MessageKey.UserLoginS0043);
                }
                else
                {
                    Response.Redirect(TransitionDefinition_OperationResult + "?Result=true&MessageId="
                            + MessageKey.UserLoginS0056);
                }
            }
            else
            {
                Response.Redirect(TransitionDefinition_OperationResult + "?Result=false&MessageId="
                       + MessageKey.UserLoginS0057);
            }
        }
    }
}
