﻿using System;

using ZXR.Core;
using ZXR.Web;

using CAUtility.Logic.UserShoppingInfo;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Contents
{
    public partial class CustomInfo : NormalMemberPage
    {
        private const string OrderInfoCookieName = "OrderInfo";

        private string TransitionDefinition_OperationResult = "Checkout.aspx";

        protected void Page_Init(object sender, EventArgs e)
        {
            System.Web.UI.HtmlControls.HtmlLink myHtmlLink1 = new System.Web.UI.HtmlControls.HtmlLink();
            myHtmlLink1.Href = CaSettings.SkinDirectory + "Product.css";
            myHtmlLink1.Attributes.Add("rel", "stylesheet");
            myHtmlLink1.Attributes.Add("type", "text/css");
            this.Page.Header.Controls.Add(myHtmlLink1);

            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
          
        }

        private void InitInterface()
        {
        }

        protected void CustomButtonSubmit_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(this.TextBoxYubin.Text) && string.IsNullOrEmpty(this.TextBoxKunsiku.Text) && string.IsNullOrEmpty(this.TextBoxJyusyo.Text))
            {

                GetUserDetailsBizProcess userParam = new GetUserDetailsBizProcess();
                userParam.UserID = ClientInfoContext.Current.UserPrincipal.UserName;

                GetUserDetailsBizLogic userLogic = new GetUserDetailsBizLogic();
                GetUserDetailsBizResult userResult = (GetUserDetailsBizResult)userLogic.Execute(userParam);

                CaSession.Jyusyo = userResult.Address;
                CaSession.ZipCode = userResult.ZipCode;
                CaSession.UserPCEmail = userResult.PCMail;
            }
            else
            {
                CaSession.ZipCode = this.TextBoxYubin.Text;
                CaSession.Jyusyo = this.DropDownListTodofu.SelectedValue + this.TextBoxKunsiku.Text + this.TextBoxJyusyo.Text;
            }

            CookieManager customInfoCookie = new CookieManager(OrderInfoCookieName);
            if (!string.IsNullOrEmpty(this.CustomTextBoxComment.Text))
            {
                customInfoCookie.SetValue("Remarks", this.CustomTextBoxComment.Text);
            }

            customInfoCookie.SetValue("ArrivalTime", this.DropDownListArrivalTime.SelectedValue);

            Response.Redirect(TransitionDefinition_OperationResult);
        }
    }
}
