﻿using System;
using ZXR.BusinessLogic;

using CAUtility.Logic.Page;
using CAUtility.Pages;
using CAUtility;

namespace WebApplication.Contents
{

    public partial class Default : NormalPage
    {
        protected void Page_Init(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(SupportCulture.GetCultureFromUrl()))
            {
                string startupScript = @"
    <script language=""javascript"" type=""text/javascript"">
         if (navigator.appName == 'Netscape')
             var language = navigator.language;
         else
             var language = navigator.browserLanguage;

                switch (language)
                {
";

                foreach (string culture in SupportCulture.LanguageList)
                {
                    if (string.Equals(culture, CaSettings.PageDefaultCulture))
                        continue;

                    startupScript += @"
                    case '" + culture.Split('-')[0] + @"':
                        document.location.href = '" + culture + @"/Default.aspx';
                    break;
            ";
                }

                startupScript += @"
                    default:
                        document.location.href = '/';
                        break;
                }
            </script>";

                this.ClientScript.RegisterStartupScript(this.GetType(),
                    "startup",
                    startupScript);
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            GetTopPageBizProcess param = new GetTopPageBizProcess();
            string culture = SupportCulture.GetCultureFromUrl();

            if (string.IsNullOrEmpty(culture))
                param.Culture = CAUtility.CaSettings.PageDefaultCulture;
            else
                param.Culture = SupportCulture.GetCultureFromUrl();

            GetTopPageBizLogic logic = new GetTopPageBizLogic();
            BizResult result = logic.Execute(param);

            Response.Redirect("Page.aspx?PageID=" + result.ResultData.ToString());
        }
    }
}
