﻿using System;

using CAUtility.Pages;
using ZXR.Core;

using CAUtility;

namespace WebApplication.Contents
{
    public partial class MemberPage : NormalMemberPage
    {
        protected void Page_Init(object sender, EventArgs e)
        {
            initInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            string culture = SupportCulture.GetCultureFromUrl();
            culture = string.IsNullOrEmpty(culture) ? CaSettings.PageDefaultCulture : culture;
            if (CaContext.Current.MemberTopPage.ContainsKey(culture))
                this.LabelContents.Text = CaContext.Current.MemberTopPage[culture];
        }

        private void initInterface()
        {
            this.HyperLinkChangePassword.Text = MessageManager.GetValue(MessageKey.UserLoginS0055);
            this.HyperLinkEditInfo.Text = MessageManager.GetValue(MessageKey.UserLoginS0054);
            this.HyperLinkSchedue.Text = MessageManager.GetValue(MessageKey.ScheduleD0008);
            this.LabelProfile.Text = MessageManager.GetValue(MessageKey.UserLoginS0059);
            this.LabelMemberFunc.Text = MessageManager.GetValue(MessageKey.UserLoginS0060);
        }

    }
}
