﻿using System;
using System.Text.RegularExpressions;

using ZXR.Core;
using CAUtility.Pages;

using CAUtility.Logic.NewsLetter.News;
using CAUtility;

namespace WebApplication.Contents
{

    public partial class News : PluginFunctionPage
    {

        private string currentPageTopPage_ = string.Empty;

        private string QueryString_NewsId = string.Empty;

        private string QueryString_NewsTagID = string.Empty;

        private int QueryString_CurrentPageIndex = 0;

        protected void Page_Init(object sender, EventArgs e)
        {
            System.Web.UI.HtmlControls.HtmlLink myHtmlLink1 = new System.Web.UI.HtmlControls.HtmlLink();
            myHtmlLink1.Href = CaSettings.SkinDirectory + "NewsLetter.css";
            myHtmlLink1.Attributes.Add("rel", "stylesheet");
            myHtmlLink1.Attributes.Add("type", "text/css");
            this.Page.Header.Controls.Add(myHtmlLink1);

            initQueryString();
            initInterface();
        }

        private void initInterface()
        {
        }

        protected void Page_Load(object sender, EventArgs e)
        {

            GetOneDetails();

            CAUtility.Plugin.ContentConvertor pluginContent = new CAUtility.Plugin.ContentConvertor();
            string pageCulture = string.IsNullOrEmpty(CAUtility.SupportCulture.GetCultureFromUrl()) ? CAUtility.CaSettings.PageDefaultCulture : CAUtility.SupportCulture.GetCultureFromUrl();
            foreach (System.Web.UI.Control control in pluginContent.DynamicSideMenu(CAUtility.CaContext.Current.SideArea[pageCulture]))
                this.PlaceHolderSideMenu.Controls.Add(control);
        }

        private void initQueryString()
        {
            if (ZXR.Core.Validate.ValidateInteger(Request.QueryString["NewsID"], true) == false)
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
                QueryString_NewsId = Request.QueryString["NewsID"];

            if (ZXR.Core.Validate.ValidateInteger(Request.QueryString["NewsTagID"], true) == false)
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
                QueryString_NewsTagID = Request.QueryString["NewsTagID"];

            if (ZXR.Core.Validate.ValidateInteger(Request.QueryString["Page"], true) == false)
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
            {
                QueryString_CurrentPageIndex = Convert.ToInt32(Request.QueryString["Page"]);
                QueryString_CurrentPageIndex = QueryString_CurrentPageIndex == 0 ? 1 : QueryString_CurrentPageIndex;
            }
        }

        private void GetOneDetails()
        {
            GetOneNewsBizProcess param = new GetOneNewsBizProcess();
            param.NewsID = QueryString_NewsId;

            GetOneNewsBizLogic logic = new GetOneNewsBizLogic();
            GetOneNewsBizResult result = (GetOneNewsBizResult)logic.Execute(param);

            this.LabelContent.Text = StringUtility.StringDecode(result.NewsContent);
            this.DisplayLabelTitle.Text = result.NewsTitle;
            this.LabelDatetime.Text = result.RegDatetime;
        }

        public override bool AuthValidate(System.Collections.Generic.List<string> hostPagePluginList)
        {
            foreach (string str in hostPagePluginList)
            {
                Regex regex = new Regex(@"^(NewsLetter\()(\s*"+ QueryString_NewsTagID +@"\s*|\s*"+ QueryString_NewsTagID +@"\s*[,]\s*[0-9]{1,}\s*)(\))$");
                Match match = regex.Match(str);
                if (match.Success)
                    return true;

                Regex regex2 = new Regex(@"^(Document\()(\s*" + QueryString_NewsTagID + @"\s*|\s*" + QueryString_NewsTagID + @"\s*[,]\s*[0-9]{1,}\s*)(\))$");
                Match match2 = regex2.Match(str);
                if (match2.Success)
                    return true;
            }

            return false;
        }
    }
}
