﻿using System;
using System.Text.RegularExpressions;

using ZXR.Core;
using CAUtility.Pages;

using CAUtility.Logic.NewsLetter.News;
using CAUtility;

namespace WebApplication.Contents
{
    public partial class NewsTag : PluginFunctionPage
    {

        private string currentPageTopPage_ = string.Empty;

        private string QueryString_NewsTagID = string.Empty;

        private int QueryString_CurrentPageIndex = 0;

        protected void Page_Init(object sender, EventArgs e)
        {
            System.Web.UI.HtmlControls.HtmlLink myHtmlLink1 = new System.Web.UI.HtmlControls.HtmlLink();
            myHtmlLink1.Href = CaSettings.SkinDirectory + "NewsLetter.css";
            myHtmlLink1.Attributes.Add("rel", "stylesheet");
            myHtmlLink1.Attributes.Add("type", "text/css");
            this.Page.Header.Controls.Add(myHtmlLink1);

            initQueryString();
            initInterface();

            string currentCulture = SupportCulture.GetCultureFromUrl();
            if (string.IsNullOrEmpty(currentCulture))
                currentCulture = CaSettings.PageDefaultCulture;

            ImageButtonRss.PostBackUrl = "~/Rss2.0.aspx?PageID=" + System.Web.HttpContext.Current.Request.QueryString["PageId"]
                + "&Culture=" + currentCulture
                + "&Target=QuickPost"
                + "&ID=" + QueryString_NewsTagID;
        }

        private void initInterface()
        {
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            InitTagsNews();

            CAUtility.Plugin.ContentConvertor pluginContent = new CAUtility.Plugin.ContentConvertor();
            string pageCulture = string.IsNullOrEmpty(CAUtility.SupportCulture.GetCultureFromUrl()) ? CAUtility.CaSettings.PageDefaultCulture : CAUtility.SupportCulture.GetCultureFromUrl();
            foreach (System.Web.UI.Control control in pluginContent.DynamicSideMenu(CAUtility.CaContext.Current.SideArea[pageCulture]))
                this.PlaceHolderSideMenu.Controls.Add(control);
        }

        private void initQueryString()
        {
            if (ZXR.Core.Validate.ValidateInteger(Request.QueryString["NewsTagID"], true) == false)
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
                QueryString_NewsTagID = Request.QueryString["NewsTagID"];

            if (ZXR.Core.Validate.ValidateInteger(Request.QueryString["Page"], true) == false)
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
            {
                QueryString_CurrentPageIndex = Convert.ToInt32(Request.QueryString["Page"]);
                QueryString_CurrentPageIndex = QueryString_CurrentPageIndex == 0 ? 1 : QueryString_CurrentPageIndex;
            }
        }

        private void InitTagsNews()
        {
            ListNewsBizProcess param = new ListNewsBizProcess();
            param.TagID = Convert.ToInt32(QueryString_NewsTagID);
            param.PageIndex = QueryString_CurrentPageIndex;

            ListNewsBizLogic logic = new ListNewsBizLogic();
            ListNewsBizResult result = (ListNewsBizResult)logic.Execute(param);

            this.PageDivider1.OnePageMaxItemCount = CaSettings.NewsCountInPage;
            this.PageDivider1.DispalyPageCount = CaSettings.AdminTablePageDividerDisplayCount;
            this.PageDivider1.ItemCount = result.TotalPostCount;

            string culture = SupportCulture.GetCultureFromUrl();
            if (string.IsNullOrEmpty(culture))
            {
                culture = CaSettings.PageDefaultCulture;
            }

            string newsList = string.Empty;
            newsList = "<table border=0 cellpadding=0 cellspacing=0 width=95%>\r\n";

            foreach (ListNewsBizResultElement ele in result.DataList)
            {
                newsList += "  <tr>\r\n";
                newsList += "    <td align=left>\r\n";
                newsList += "<a href='News.aspx?NewsID=" + ele.NewsID + "&NewsTagID=" + QueryString_NewsTagID + "&PageId=" + System.Web.HttpContext.Current.Request.QueryString["PageId"] + "'>" + ele.NewsTitle + "</a>";
                newsList += "    </td>\r\n";
                newsList += "    <td align=right>\r\n";
                newsList += System.DateTime.Parse(ele.RegDatetime).ToString("yyyy年MM月dd日");
                newsList += "    </td>\r\n";
                newsList += "  </tr>\r\n";
                newsList += "  <tr>\r\n";
                newsList += "    <td class=newstd colspan=2>\r\n";
                newsList += "&nbsp;";
                newsList += "    </td>\r\n";
                newsList += "  </tr>\r\n";
            }
            newsList += "</table>\r\n";

            this.LabelContent.Text = newsList;
            this.DisplayLabelTitle.Text = result.TagName;
        }

        public override bool AuthValidate(System.Collections.Generic.List<string> hostPagePluginList)
        {
            foreach (string str in hostPagePluginList)
            {
                Regex regex = new Regex(@"^(NewsLetter\()(\s*" + QueryString_NewsTagID + @"\s*|\s*" + QueryString_NewsTagID + @"\s*[,]\s*[0-9]{1,}\s*)(\))$");
                Match match = regex.Match(str);
                if (match.Success)
                    return true;

                Regex regex2 = new Regex(@"^(Document\()(\s*" + QueryString_NewsTagID + @"\s*|\s*" + QueryString_NewsTagID + @"\s*[,]\s*[0-9]{1,}\s*)(\))$");
                Match match2 = regex2.Match(str);
                if (match2.Success)
                    return true;
            }

            return false;
        }
    }
}