﻿using System;

using ZXR.Core;
using ZXR.Web;

using CAUtility;
using CAUtility.Pages;
using CAUtility.Logic.Products;

namespace WebApplication.Contents
{

    public partial class ProductDetail : NormalPage
    {

        private string QueryString_ProductID = string.Empty;

        protected void Page_Init(object sender, EventArgs e)
        {
            System.Web.UI.HtmlControls.HtmlLink myHtmlLink1 = new System.Web.UI.HtmlControls.HtmlLink();
            myHtmlLink1.Href = CaSettings.SkinDirectory + "Product.css";
            myHtmlLink1.Attributes.Add("rel", "stylesheet");
            myHtmlLink1.Attributes.Add("type", "text/css");
            this.Page.Header.Controls.Add(myHtmlLink1);

            initQueryString();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            initQueryString();

            string currentCultureString = SupportCulture.GetCultureFromUrl();

            GetProductDetailsBizProcess param = new GetProductDetailsBizProcess();
            param.ID = QueryString_ProductID;

            GetProductDetailsBizLogic logic = new GetProductDetailsBizLogic();
            GetProductDetailsBizResult result = (GetProductDetailsBizResult)logic.Execute(param);

            if (!string.IsNullOrEmpty(result.MetaKeyword))
            {
                ZxrHttpMeta.AddMeta("keywords", result.MetaKeyword);
            }

            this.DisplayLabelProductDetails.Text = StringUtility.StringDecode(result.Details);

            CAUtility.Plugin.ContentConvertor pluginContent = new CAUtility.Plugin.ContentConvertor();
            string pageCulture = string.IsNullOrEmpty(CAUtility.SupportCulture.GetCultureFromUrl()) ? CAUtility.CaSettings.PageDefaultCulture : CAUtility.SupportCulture.GetCultureFromUrl();

            foreach (System.Web.UI.Control control in pluginContent.DynamicSideMenu(CAUtility.CaContext.Current.SideArea[pageCulture]))
                this.PlaceHolderSideMenu.Controls.Add(control);
        }

        private void initQueryString()
        {
            if (ZXR.Core.Validate.ValidateInteger(Request.QueryString["ProductID"]) == false)
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
                QueryString_ProductID = Request.QueryString["ProductID"];
        }

    }
}
