﻿using System;
using System.Web;

using ZXR.Core;
using ZXR.Security;
using ZXR.Net;
using ZXR.BusinessLogic;
using ZXR.Web.Controls;

using CAUtility.Logic.UserInfo;
using CAUtility.Logic.UserShoppingInfo;
using CAUtility.Logic.ReturnPassword;
using CAUtility.Pages;
using CAUtility;
using CAUtility.Utility;

namespace WebApplication.Contents
{

    public partial class ReturnPassword : NormalPage
    {

        private string TransitionDefinition_Postback = "ReturnPasswordResult.aspx";

        private const string TransitionDefinition_OperationResult = "UserOperateResult.aspx";

        protected void Page_Init(object sender, EventArgs e)
        {
            initInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        private void initInterface()
        {
            this.LabelAnswer.Text = MessageManager.GetValue(MessageKey.UserLoginS0028);
            this.LabelQuestion.Text = MessageManager.GetValue(MessageKey.UserLoginS0027);
            this.LabelTitle.Text = MessageManager.GetValue(MessageKey.UserLoginS0026);
            this.LabelUserIDDes.Text = MessageManager.GetValue(MessageKey.UserLoginS0001);
            this.LabelUserName.Text = MessageManager.GetValue(MessageKey.UserLoginS0001);
            this.ButtonByEmail.Text = MessageManager.GetValue(MessageKey.UserLoginS0014);
            this.ButtonSubmit.Text = MessageManager.GetValue(MessageKey.UserLoginS0029);
            this.DisplayLabelDetails.Text = MessageManager.GetValue(MessageKey.UserLoginS0013);
        }

        protected void ButtonByEmail_Click(object sender, EventArgs e)
        {
            UserExistCheckBizProcess uparam = new UserExistCheckBizProcess();
            uparam.UserID = this.TextBoxUserId.Text;
            UserExistCheckBizLogic ulogic = new UserExistCheckBizLogic();
            BizResult uResult = ulogic.Execute(uparam);
            if (uResult.Result == false)
            {
                Response.Redirect(TransitionDefinition_OperationResult + "?Result=false&MessageId="
                        + MessageKey.UserLoginS0046);

                return;
            }

            GetUserDetailsBizProcess param = new GetUserDetailsBizProcess();
            param.UserID = this.TextBoxUserId.Text;

            GetUserDetailsBizLogic logic = new GetUserDetailsBizLogic();
            GetUserDetailsBizResult result = (GetUserDetailsBizResult)logic.Execute(param);

            if (string.IsNullOrEmpty(result.PCMail))
            {
                Response.Redirect(TransitionDefinition_OperationResult + "?Result=false&MessageId="
                        + MessageKey.UserLoginS0046);

                return;
            }

            string code = DesCryptogram.Encrypt(this.TextBoxUserId.Text);
            insertCodeToDatabase(code);

            string to = result.PCMail;

            string content = MessageManager.GetValue(MessageKey.UserLoginS0052,
                this.TextBoxUserId.Text,
                HttpContext.Current.Request.Url.Scheme + "://" + HttpContext.Current.Request.Url.Authority +
                    "/ReturnPasswordResult.aspx?Code=" + code
                );

            MailUtil mail = new MailUtil();
            mail.SendMailToMember(to,
                MessageManager.GetValue(MessageKey.UserLoginS0047),
                content);

            Response.Redirect(TransitionDefinition_OperationResult + "?Result=true&MessageId="
                    + MessageKey.UserLoginS0053);
        }

        protected void ButtonSubmit_Click(object sender, EventArgs e)
        {
            GetUserDetailsBizProcess param = new GetUserDetailsBizProcess();
            param.UserID = this.TextBoxUserName.Text;

            GetUserDetailsBizLogic logic = new GetUserDetailsBizLogic();
            GetUserDetailsBizResult result = (GetUserDetailsBizResult)logic.Execute(param);

            if (string.Equals(this.DropDownListSecretQuestion.SelectedValue, result.SecretQuestion.ToString())
                && string.Equals(DesCryptogram.Encrypt(this.TextBoxAnswer.Text), DesCryptogram.Encrypt(result.SecretAnswer)))
            {
                insertCodeToDatabase(DesCryptogram.Encrypt(this.TextBoxUserName.Text));
                Response.Redirect(TransitionDefinition_Postback + "?Code=" + DesCryptogram.Encrypt(this.TextBoxUserName.Text));
            }
            else
            {
                WebMessageBox.Show(MessageManager.GetValue(MessageKey.UserLoginS0045));
            }
        }

        private bool insertCodeToDatabase(string code)
        {
            InsertCodeBizProcess param = new InsertCodeBizProcess();
            param.Code = code;

            InsertCodeBizLogic logic = new InsertCodeBizLogic();
            BizResult result = logic.Execute(param);

            return result.Result;
        }

    }
}
