﻿using System;

using ZXR.Security;
using ZXR.Core;
using ZXR.BusinessLogic;

using CAUtility.Logic.UserInfo;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Contents
{
    public partial class ReturnPasswordResult : NormalPage
    {

        private string QueryString_Code = string.Empty;

        private string QueryString_UserName = string.Empty;

        protected void Page_Load(object sender, EventArgs e)
        {
            initQueryString();

             resetPassword();
        }

        private void resetPassword()
        {
            string newPassword = GuidUtility.RandomString(2) + GuidUtility.RandomNumber(10000, 99999).ToString();

            ForgotPasswordBizProcess param = new ForgotPasswordBizProcess();
            param.UserName = QueryString_UserName;
            param.Password = Md5Cryptogram.Md5Hash(newPassword);
            param.Code = QueryString_Code;

            ForgotPasswordBizLogic logic = new ForgotPasswordBizLogic();
            BizResult result = logic.Execute(param);

            if (result.Result)
            {
                this.LabelPassword.Text = newPassword;
            }
            else
            {
                this.LabelResult.Visible = false;
                this.LabelPassword.Text = "コードの利用期間が切れました。パスワードの再発行ができません。";
            }
        }

        private void initQueryString()
        {
            if (ZXR.Core.Validate.ValidataRequired(Request.QueryString["Code"]) == false)
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
                QueryString_Code = Request.QueryString["Code"];

            try
            {
                QueryString_UserName = DesCryptogram.Decrypt(QueryString_Code);
            }
            catch
            {
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            }
        }
    }
}
