﻿using System;

using ZXR.Core;
using CAUtility;
using CAUtility.Pages;

namespace WebApplication.Contents
{

    public partial class UserRegisterResult :  NormalPage
    {

        private bool QueryString_Result = false;

        private string QueryString_MessageId = string.Empty;

        protected void Page_Init(object sender, EventArgs e)
        {
            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            initQueryString();

            this.DisplayLabelResult.Text = MessageManager.GetValue(MessageKey.PageD0026);

            if (QueryString_Result == true)
            {
                this.HyperLinkBack.Visible = false;

                if (!string.IsNullOrEmpty(QueryString_MessageId))
                    this.DisplayLabelComment.Text = "<font color=Green>" + MessageManager.GetValue(QueryString_MessageId) + "</font>";
                else
                    this.DisplayLabelComment.Text = "<font color=Green>" + Request.QueryString["Message"] + "</font>";
            }
            else
            {
                this.HyperLinkBack.Visible = true;

                if (!string.IsNullOrEmpty(QueryString_MessageId))
                    this.DisplayLabelComment.Text = "<font color=Red>" + MessageManager.GetValue(QueryString_MessageId) + "</font>";
                else
                    this.DisplayLabelComment.Text = "<font color=Red>" + Request.QueryString["Message"] + "</font>";
            }
        }

        private void InitInterface()
        {
            this.HyperLinkTop.Text = "[" + MessageManager.GetValue(MessageKey.PageD0038) + "]";
            this.HyperLinkBack.Text = "[" + MessageManager.GetValue(MessageKey.PageD0037) + "]";
        }

        private void initQueryString()
        {
            if (ZXR.Core.Validate.ValidateBoolean(Request.QueryString["Result"]) == false)
                throw new ZxrException(MessageManager.GetValue(MessageKey.AdminE0002)) { ErrorType = ErrorType.IntrusionAttempt };
            else
                QueryString_Result = Convert.ToBoolean(Request.QueryString["Result"]);

                QueryString_MessageId = Request.QueryString["MessageId"];
        }
    }
}
