﻿using System;

using ZXR.Core;
using ZXR.Web.Controls;
using CAUtility;

namespace WebApplication.WebParts
{

    public partial class ShoppingCartControl : UserControl
    {
        protected void Page_Init(object sender, EventArgs e)
        {
            InitInterface();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                InitPage();
            }
        }

        private void InitInterface()
        {
            this.HyperLinkShoppingBag.Text = MessageManager.GetValue("D0001");
            this.ButtonBuy.Text = MessageManager.GetValue("D0007");
            this.LabelCountDisplay.Text = MessageManager.GetValue("D0005");
            this.HyperLinkToList.Text = MessageManager.GetValue("D0008");
        }

        private void InitPage()
        {

            this.HyperLinkShoppingBag.NavigateUrl =
                "~/Contents/" + SupportCulture.GetCultureFromUrl() + "/ShoppingCart.aspx?Action=confirm";

            if (ViewState["Count"] != null)
                Response.Write("&Count=" + ViewState["Count"].ToString() + ">");

            if (Request.QueryString["Pid"] == null)
            {
                this.PanelShoppingCart.Visible = false;
            }

            this.HyperLinkToList.NavigateUrl =
                "~/Contents/" + SupportCulture.GetCultureFromUrl() + "/ProductPage.aspx";
        }

        protected void TextBoxCount_TextChanged(object sender, EventArgs e)
        {
            Response.Redirect(
                   "~/Contents/" + SupportCulture.GetCultureFromUrl()
                   + "/ShoppingCart.aspx?Action=add&Pid="
                   + Request.QueryString["Pid"].ToString()
                   + "&Count=" + this.CustomTextBoxCount.Text);
        }

        protected void ButtonBuy_Click(object sender, EventArgs e)
        {
            Response.Redirect(
                    "~/Contents/" + SupportCulture.GetCultureFromUrl()
                    + "/ShoppingCart.aspx?Action=add&Pid="
                    + Request.QueryString["Pid"].ToString()
                    + "&Count=" + this.CustomTextBoxCount.Text);
        }

    }
}